/*
 * Copyright Mr DROUOT Patrick since 2006
 * 
 * www.patrickdrouot2000@yahoo.fr
 * 
 * 
 * This file is part of GraphExotica.
 * GraphExotica is free software;
 * you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2 of the License.
 * GraphExotica is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. 

*/
import java.awt.Color;
import java.awt.*;
import javax.swing.*;

import javax.swing.JPanel;
import javax.swing.border.LineBorder;

public class DialogueAntecedents extends JPanel
{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 5565163407365453689L;
	Font En;
	JButton PasAnt,LesAnt,Terminer,Correction;
	JLabel Texte,Enonce;
	JTextField Reponse[];
	
	public DialogueAntecedents(int x, int y, int Largeur , int Hauteur, double Ant)
	{
		int Larg=Largeur/2;
		int Haut=Hauteur/4;
		int Larg_rep=(Largeur-20)/8;
		setBorder(new LineBorder(new Color(255, 0, 0)));
		setBackground(new Color(0, 0, 0));
		setBounds(x,y,Largeur,Hauteur);	
		En=new Font("", Font.BOLD, 16);
		
		PasAnt=new JButton("n'a pas d'antcdent");
		LesAnt=new JButton("a au moins un antcdent");
		Terminer=new JButton("Je valide ma saisie");
		Correction=new JButton("Correction");
		Enonce=new JLabel("Le nombre "+Ant);Enonce.setForeground(new Color(255,255,255));Enonce.setHorizontalAlignment(SwingConstants.CENTER);
		Enonce.setFont(En);
		Texte=new JLabel("Saisissez tous les antcdents (un antcdent par case).");
		Texte.setBounds(0,20+Haut,Largeur,Haut);Texte.setForeground(new Color(255,255,0));Texte.setHorizontalAlignment(SwingConstants.CENTER);
		Texte.setFont(En);
		Texte.setVisible(false);
		setLayout(null);
		Enonce.setBounds(0,0,Largeur,20);
		LesAnt.setBounds(0,20,Larg,Haut); //DialogueAntecedents.LesAnt
		PasAnt.setBounds(Larg,20,Larg,Haut);
		
		Reponse=new JTextField[8];
		for (int i=0;i<8;i++)
		{
			Reponse[i]=new JTextField("");
			Reponse[i].setBounds(10+i*Larg_rep,2*Haut+20,Larg_rep-10,Haut/2);
			Reponse[i].setHorizontalAlignment(SwingConstants.CENTER);
			Reponse[i].setVisible(false);
			Reponse[i].setFont(En);
			this.add(Reponse[i]);
		}
		//Terminer.setBounds(0,3*Haut+20,Largeur,20);Terminer.setVisible(false);*
		Terminer.setBounds(0,3*Haut,Largeur,20);Terminer.setVisible(false);
		//Correction.setBounds(0,3*Haut+50,Largeur,20);Correction.setVisible(false);
		Correction.setBounds(0,3*Haut+30,Largeur,20);Correction.setVisible(false);
		this.add(LesAnt);this.add(PasAnt);this.add(Enonce);this.add(Texte);this.add(Terminer);this.add(Correction);
	}
}
