/*
 * Copyright Mr DROUOT Patrick since 2006
 * 
 * www.patrickdrouot2000@yahoo.fr
 * 
 * 
 * This file is part of GraphExotica.
 * GraphExotica is free software;
 * you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2 of the License.
 * GraphExotica is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. 

*/
import java.awt.Color;
import java.awt.*;
import javax.swing.*;
import javax.swing.JPanel;
import javax.swing.border.LineBorder;

public class DialogueImages extends JPanel
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 3764940691479375687L;
	JButton Valider;
	JLabel Enonce;
	JTextField Reponse;
	Font En;
	FontMetrics fm;
	
	public DialogueImages(int x, int y,int Largeur , int Hauteur)
	{
		setBorder(new LineBorder(new Color(255, 0, 0)));
		setBackground(new Color(0, 0, 0));
		setBounds(x,y,Largeur,Hauteur);	
		
		setLayout(null);
		Valider=new JButton("Valider la saisie");
		Enonce=new JLabel("f(x)=");Enonce.setForeground(new Color(255,255,255));Enonce.setHorizontalAlignment(SwingConstants.RIGHT);
		
		Font En=new Font("", Font.BOLD, 16);fm = getFontMetrics(En);
		Enonce.setFont(En);	
		Reponse=new JTextField("");
		Reponse.setFont(En);
		Enonce.setBounds(20,20,150,30);
		Reponse.setBounds(180,20,200,30);
		Valider.setBounds(20,70,200,30);
		Valider.setVisible(true);Enonce.setVisible(true);Reponse.setVisible(true);
		this.add(Valider);this.add(Enonce);this.add(Reponse);
	}
	public void ChangeEnonce(String Ph)
	{
		Enonce.setBounds(20,20,fm.stringWidth(Ph)+5,30);
		Reponse.setBounds(30+fm.stringWidth(Ph),20,80,30);
		Valider.setBounds(20,70,fm.stringWidth(Ph)+90,30);
		Enonce.setText(Ph);
		
	}
}
