/*
 * Copyright Mr DROUOT Patrick since 2006
 * 
 * www.patrickdrouot2000@yahoo.fr
 * 
 * 
 * This file is part of GraphExotica.
 * GraphExotica is free software;
 * you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2 of the License.
 * GraphExotica is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. 

*/
import java.awt.Color;
import java.awt.*;
import java.awt.MediaTracker;
import javax.swing.*;
import javax.swing.JPanel;
import javax.swing.border.LineBorder;

public class DialogueInequation extends JPanel
{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -4758518933565959037L;
	JButton Valider,BouttonCorrection,Aucune_Reponse,Aide;
	JLabel Enonce,T1,T2,T3;
	JTextField Reponse;
	Font En,Aid;
	FontMetrics fm;
	boolean Im1,Im2;
	int LgT1,Largeur;
	final String Ch="Vous recherchez les abscisses des points situs:";
	
	
	public DialogueInequation(int x, int y,int Largeur , int Hauteur)
	{
		this.Largeur=Largeur;
		setBorder(new LineBorder(new Color(255, 0, 0)));
		setBackground(new Color(0, 0, 0));
		setBounds(x,y,Largeur,Hauteur);	
		Font En=new Font("", Font.BOLD, 16);
		Font Aid=new Font("Serif", Font.PLAIN, 16);fm = getFontMetrics(Aid);LgT1=fm.stringWidth(Ch)+15;
	    setLayout(null);
	    Im1=false;Im2=false;
	    
	    Aide=new JButton("Aide");TailleBoutonAide();Aide.setVisible(false);
	    T1=new JLabel(Ch);T2=new JLabel("");T3=new JLabel("");
	    T1.setFont(Aid);T2.setFont(Aid);T3.setFont(Aid);
	    T1.setBounds(20,130,LgT1,25);T2.setBounds(60,160,Largeur-30,25);T3.setBounds(60,190,Largeur-30,25);
	    T1.setVisible(false);T2.setVisible(false);T3.setVisible(false);
	    T1.setBackground(new Color(0,0,0));T1.setForeground(new Color(255,255,0));T1.setHorizontalAlignment(SwingConstants.LEFT);
	    T2.setBackground(new Color(0,0,0));T2.setForeground(new Color(76,183,225));T2.setHorizontalAlignment(SwingConstants.LEFT);
	    T3.setBackground(new Color(0,0,0));T3.setForeground(new Color(76,183,225));T3.setHorizontalAlignment(SwingConstants.LEFT);
	    add(T1);add(T2);add(T3);
		Valider=new JButton("Valider");
		Aucune_Reponse=new JButton("S=\u2205");
		Enonce=new JLabel("");Enonce.setForeground(new Color(255,255,255));Enonce.setHorizontalAlignment(SwingConstants.CENTER);
		Enonce.setFont(En);
		Reponse=new JTextField("");Reponse.setFont(En);
		BouttonCorrection=new JButton("Correction");
		Enonce.setBounds(20,10,Largeur-40,30);
		Reponse.setBounds(20,50,Largeur*3/4,30);
		Aucune_Reponse.setBounds(Largeur*3/4+30,50,Largeur/4-50,30);
		Valider.setBounds(20,90,Largeur-40,30);
		BouttonCorrection.setBounds(20,130,Largeur-40,30);
		Valider.setVisible(true);Enonce.setVisible(true);Reponse.setVisible(true);Aucune_Reponse.setVisible(true);
		BouttonCorrection.setVisible(false);
		add(Valider);add(Enonce);add(Reponse);add(BouttonCorrection);add(Aucune_Reponse);add(Aide);
	}
	public void AfficheBoutonCorrection()
	{
		if (Aide.isVisible())
		{
			int l=(Largeur-40)/2;
			Aide.setBounds(20,130,l-5,30);
			BouttonCorrection.setBounds(20+l+5,130,l-5,30);
		}
		else
		{
			int l=Math.max(20+LgT1,Largeur/2);
			BouttonCorrection.setBounds(20+l,130,Largeur-l-40,30);
		}
		BouttonCorrection.setVisible(true);
	}
	public void TailleBoutonAide()
	{
		Aide.setBounds(20,130,Largeur-40,30);
	}
	public void paintComponent(Graphics Graph)
	{
		Image ima;
		super.paintComponent(Graph);
		ima=Toolkit.getDefaultToolkit().createImage(getClass().getResource("sphere.gif")); 
		MediaTracker mt = new MediaTracker(this); 
	    mt.addImage(ima, 0); 
	    try 
	    { 
	    	mt.waitForAll(); 
	    } 
	    catch (InterruptedException e) {} 
		if (Im1) {Graph.drawImage(ima,40,167,null);}
		if (Im2) {Graph.drawImage(ima,40,197,null);}
	}
	public void Puce1(boolean b) {Im1=b;}
	public void Puce2(boolean b) {Im2=b;}
}
