/*
 * Copyright Mr DROUOT Patrick since 2006
 * 
 * www.patrickdrouot2000@yahoo.fr
 * 
 * 
 * This file is part of GraphExotica.
 * GraphExotica is free software;
 * you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2 of the License.
 * GraphExotica is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. 

*/
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import javax.swing.*;
import javax.swing.border.LineBorder;
public class EnsembleDef extends JPanel
{
	/**
	 * 
	 */
	private static final long serialVersionUID = -4295803708339227052L;
	JButton Valider,Agrandir,TailleNormal,Correction;
	JLabel Enonce,Regle,Regle2;
	JTextField Reponse;
	Font En;
	FontMetrics fm;
	final String Ph="L'ensemble de dfinition de la fonction f est";
	int Largeur;

	public EnsembleDef(int x, int y,int Largeur , int Hauteur,boolean Lim)
	{
		this.Largeur=Largeur;
		setBorder(new LineBorder(new Color(255, 0, 0)));
		setBackground(new Color(0, 0, 0));
		setBounds(x,y,Largeur,Hauteur);	
		setLayout(null);
		Font En=new Font("", Font.BOLD, 14);fm = getFontMetrics(En);
		Valider=new JButton("Valider la saisie");Valider.setFont(En);Valider.setBounds(20,60,Largeur-40,20);
		Agrandir=new JButton("Dilatation suivant les abscisses");Agrandir.setFont(En);Agrandir.setBounds(20,90,Largeur-40,20);
		TailleNormal=new JButton("Taille d'origine");TailleNormal.setFont(En);TailleNormal.setBounds(20,120,Largeur-40,20);
		TailleNormal.setEnabled(false);
		if (Lim) Regle=new JLabel("La limite demande est un nombre dcimal");
		else Regle=new JLabel("Les bornes de l'ensemble de dfinition sont des dcimaux");
		Regle.setForeground(new Color(255,0,255));Regle.setHorizontalAlignment(SwingConstants.CENTER);
		Regle.setFont(En);
		Regle.setBounds(20,150,Largeur-40,40);	
		if (Lim) Regle2=new JLabel("exact aux diximes");
		else Regle2=new JLabel("exacts aux diximes");
		Regle2.setForeground(new Color(255,0,255));Regle2.setHorizontalAlignment(SwingConstants.CENTER);
		Regle2.setFont(En);
		Regle2.setBounds(20,180,Largeur-40,40);	
		
		Enonce=new JLabel(Ph);
		Reponse=new JTextField("");
		Enonce.setForeground(new Color(255,255,255));Enonce.setHorizontalAlignment(SwingConstants.RIGHT);
		Enonce.setFont(En);
		int l=fm.stringWidth(Ph);
		Enonce.setBounds(20,20,l+5,25);	
		Reponse.setBounds(l+30,20,200,25);
		Reponse.setFont(new Font("", Font.PLAIN, 14));Reponse.setHorizontalAlignment(SwingConstants.LEFT);
		Correction=new JButton("Correction");
		Correction.setHorizontalAlignment(SwingConstants.CENTER);
		Correction.setFont(En);
		Correction.setBounds(l+250,20,Largeur-(l+270),25);
		
		this.add(Enonce);this.add(Reponse);this.add(Agrandir);this.add(Valider);this.add(TailleNormal);this.add(Regle);this.add(Regle2);this.add(Correction);
	}
	public void EnonceChange(String P)
	{
		Enonce.setText(P);
		int l=fm.stringWidth(P);
		Enonce.setBounds(20,20,l+5,25);
		Reponse.setBounds(l+30,20,200,25);
		Correction.setBounds(l+250,20,Largeur-(l+270),25);
	}
}
