/*
 * Copyright Mr DROUOT Patrick since 2006
 * 
 * www.patrickdrouot2000@yahoo.fr
 * 
 * 
 * This file is part of GraphExotica.
 * GraphExotica is free software;
 * you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2 of the License.
 * GraphExotica is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. 

*/
import java.io.IOException;
import javax.swing.*; 
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.awt.Cursor;

public class MaFenAide extends JFrame implements ActionListener,HyperlinkListener
{
	/**
	 * 
	 */
	private static final long serialVersionUID = -800446238051021071L;
	Container Cont;
	JEditorPane html; 
	JButton Closed;
	JViewport vp;
	private Cursor main = new Cursor(Cursor.HAND_CURSOR);
	private Cursor defaut = new Cursor(Cursor.DEFAULT_CURSOR);
	public MaFenAide(String Fichier)
	{
		Cont=getContentPane();
		setTitle("Aides");
		Cont.setLayout(new BorderLayout());
		try
		{
			html = new JEditorPane( getClass().getResource(Fichier));  
		} 
		catch (IOException e) 
		{
			e.printStackTrace();
		} 
		html.setEditable(false); // Read-only
		
		html.addHyperlinkListener (this);
		
		JScrollPane scroller = new JScrollPane(); 
		JViewport vp = scroller.getViewport();
		Closed=new JButton("Fermer");
		Closed.addActionListener(this);
		vp.add(html); 
		Cont.add("Center",scroller );
		Cont.add("South",Closed );
	}
	public void actionPerformed(ActionEvent arg0) 
	{
		Fin();		
	}
	public void Fin()
	{
		setVisible(false);
		dispose();
	}
	public void hyperlinkUpdate(HyperlinkEvent evt) 
	{		
		//permet de changer le pointeur de la souris lors du survol d'un lien hypertext
		if(evt.getEventType()==HyperlinkEvent.EventType.ENTERED) {html.setCursor(main);}
		//permet de changer le pointeur de la souris en pointeur normal aprs le survol d'un lien hypertext
		else {html.setCursor(defaut);}
		if(evt.getEventType()==HyperlinkEvent.EventType.ACTIVATED) 
		{
			try 
			{
				html.setPage(evt.getURL());
			}
				catch (Exception e) {}
		}
	}
}
