/*
 * Copyright Mr DROUOT Patrick since 2006
 * 
 * www.patrickdrouot2000@yahoo.fr
 * 
 * 
 * This file is part of GraphExotica.
 * GraphExotica is free software;
 * you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2 of the License.
 * GraphExotica is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. 

*/
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Toolkit;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.LineBorder;
import java.awt.*;
public class PanneauCourbe extends JPanel implements MouseListener, MouseMotionListener
{
	/**
	 * 
	 */
	private static final long serialVersionUID = -689564970669352224L;
	private Image image;
	private Image BDBulle;
	public boolean CorrDroite=false;
	boolean BD=false;
	int BDx,BDy;
	boolean Bulle=false;
	boolean Droite=false;
	boolean AffCoef=true,AffLigne=true;
	int uniteX=5,uniteY=5; // longueur d'une unite en pixels
	int Num,Den;
	float Triche[][]=new float[25][2];
	int NbTriche=0;
	double xmin,xmax,ymin,ymax;
	int Largeur,Hauteur,xO,yO,LargeurCourbe,NbPoints;
	double xpas,ypas;
	double[][] Polynome=new double[20][4]; // Coefficients des polynmes
	double d,a,b;
	int i,poly,pixel;
	int PixelX[],PixelY[];
	double Curseur=0;
	int CurseurPixel=0;
	double[][] Point;
	//Tangente
	boolean Tangente=false;
	int indiceTangente;
	double Tcoef;
	double Tx;
	int xE,yE,xF,yF;
	int [] OvalTangenteX=new int[2];
	int [] OvalTangenteY=new int[2];
	int OvalIteration=0;
	// Correction antcdents
	boolean Correct_Ant;
	boolean First; // pour la correction, le premier antcdent doit afficher l'ordonne.
	boolean BarrePasAnt; // affiche y=Ant si pas d'antecdent
	double[] Abs_Ant=new double[8];
	int Compt_Ant,NbAnt;
	double Correct_Parcours;
	double Ant;
	// Correction Inequation
	boolean Correct_Ineq=false;
	boolean Correct_Intervalle=false;
	boolean AfficheBarreIneq=false;
	double borne1,borne2;
	int PixelInterX[]= new int[8]; 
	int PixelInterY[]= new int[8];
	int PixelPointX[]=new int[8];
	boolean G[]= new boolean[8];
	boolean D[]= new boolean[8];
	int CompteurInter,CompteurPoint;
	final int HauteurCrochet=8;
	//Limite et ens. de def;
	Intervalle Inter[]=new Intervalle[2];
	boolean Limite,Agrandir,EntrainAgrandir;
	int CursX,CursY,lg,ht;
	int NbInter;
	int PixelX2[],PixelY2[];
	int LargeurCourbe2,LargeurCourbe3;
	boolean Courbe2,Courbe3;
	int Largeurreelle;
	int indiceAbscisse;
	int Cx,Cy;
	Font En;
	FontMetrics fm;
	EnsembleDef MesDef;
	//Tableau de variations
	boolean tableau=false;
	boolean EntrainBall=false;
	int QBall;
	int BallX[]=new int[20]; // coordonnes en pixels des ovales
	int BallY[]=new int[20];
	
	
	public PanneauCourbe(int x, int y, int Largeur , int Hauteur)
	{
		Font En=new Font("", Font.PLAIN, 8);fm = getFontMetrics(En);
		Correct_Ant=false;
		Agrandir=false;EntrainAgrandir=false;
		PixelX=new int [Largeur+31];
		PixelY=new int [Largeur+31];
		PixelX2=new int [Largeur+31];
		PixelY2=new int [Largeur+31];
		this.Largeur=Largeur;this.Hauteur=Hauteur;
		setBorder(new LineBorder(new Color(255, 0, 0)));
		setBackground(new Color(0, 0, 0));
		setBounds(x,y,Largeur,Hauteur);
		Largeurreelle=Largeur-x;
		// Ecouteur de souris
		addMouseListener(this);
		addMouseMotionListener(this);
		
		image=Toolkit.getDefaultToolkit().createImage(getClass().getResource("BulleDiffMax.gif")); 
	}
	public void ChangeCourbeLimite(double xmin, double xmax, double ymin, double ymax, double[][] Point,int NbPoints,Intervalle[] I,int Nb,EnsembleDef Obj)
	{
		this.MesDef=Obj;
		this.xmin=xmin;this.xmax=xmax;this.ymin=ymin;this.ymax=ymax;this.NbPoints=NbPoints;this.Point=Point;
		this.NbInter=Nb;
		this.Inter=I;
		Limite=true;
		CalculCourbeDiscontinuite();
	}
	public void ZoomCourbe()
	{
		double Nvxmin,Nvxmax;
		Nvxmin= abscissePixel(CursX);
		Nvxmax= abscissePixel(CursX+lg);
		if ((Nvxmax-Nvxmin)<0.2d) 
		{
			Nvxmax=Nvxmin+0.2d;
			JOptionPane.showMessageDialog(this, "Trop petit !\nJe vais voir ce que je peux faire...","Information",JOptionPane.INFORMATION_MESSAGE);
		}
		ZoomAnimation Tache=new ZoomAnimation(this,Nvxmin,Nvxmax,xmin,xmax);
		Tache.start();
		//CalculCourbeDiscontinuite();
	}
	
	public void ChangeCourbe(double xmin, double xmax, double ymin, double ymax, double[][] Point,int NbPoints)
	{
		Limite=false;
		this.xmin=xmin;this.xmax=xmax;this.ymin=ymin;this.ymax=ymax;this.NbPoints=NbPoints;this.Point=Point;
		xpas=((double) Largeur/(xmax-xmin));ypas=(double) ((double)Hauteur/(ymax-ymin));
		xO=(int)(-xpas*xmin);yO=(int)(ypas*ymax);
		if (Droite) {Droite();}
		else
		{
//			Calcule les coef des polynmes
			
			for (int i=0;i<NbPoints-1;i++)	{CalculHermite(i,0d,0d);}
		
			// Calcule les pixels  relier pour construire la courbe
			for (int i=0;i<NbPoints;i++)
			LargeurCourbe=Absc(Math.min(Point[(NbPoints-1)][0],xmax))-Absc(Math.max(Point[0][0],xmin));
			pixel=Absc(Point[0][0]); // pixel de dpart
			if (Point[0][0]<xmin) {pixel=Absc(xmin);}
			for (int j=0;j<LargeurCourbe;j++)
			{
				PixelX[j]=pixel;
				a=abscissePixel(pixel); // convertit le pixel i en abscisse a
				PixelY[j]=Ordo(Fonction(a));
				pixel++;
			}
		}
		
		if (tableau | Droite) // tableau de variations: initialise les coords en pixels des ovales
		{
			TableauBall();
		}
	}
	public void TableauBall()
	{
		for (int i=0;i<NbPoints;i++)
		{
			BallX[i]=Absc(Point[i][0]);
			BallY[i]=Ordo(Point[i][1]);
			
		}
	}
	public void CalculTableau()
	{
		for (int i=0;i<NbPoints;i++) // recalcule suivant la position des ovales.
		{
			Point[i][0]=abscissePixel(BallX[i]);
			Point[i][1]=ordonneePixel(BallY[i]);
		if (Droite)
		{
			Point[i][0]=(double) Math.round(Point[i][0]);
			Point[i][1]=(double) Math.round(Point[i][1]);
		}
		}
		if (Droite) {Droite();}
		else
		{
			for (int i=0;i<NbPoints-1;i++)	{CalculHermite(i,0d,0d);}
			for (int i=0;i<NbPoints;i++)
			LargeurCourbe=Absc(Math.min(Point[(NbPoints-1)][0],xmax))-Absc(Math.max(Point[0][0],xmin));
			pixel=Absc(Point[0][0]); // pixel de dpart
			if (Point[0][0]<xmin) {pixel=Absc(xmin);}
			for (int j=0;j<LargeurCourbe;j++)
			{
				PixelX[j]=pixel;
				a=abscissePixel(pixel);
				PixelY[j]=Ordo(Fonction(a));
				pixel++;
			}
		}
	}
	public double Droite(double x)
	{
		double coef=(Point[1][1]-Point[0][1])/(Point[1][0]-Point[0][0]);
		double ordorig=Point[1][1]-coef*Point[1][0];
		return (coef*x+ordorig);
	}
	public void Droite()
	{
		uniteX=(Absc(1)-Absc(0))/2+2;uniteY=(Ordo(0)-Ordo(1))/2+2;
		LargeurCourbe=2;pixel=Absc(xmin);
		for (int j=0;j<LargeurCourbe;j++)
		{
			PixelX[j]=pixel;
			a=abscissePixel(pixel);
			PixelY[j]=Ordo(Droite(a));
			pixel=Absc(xmax);
		}
	}
	public void AfficheTangente(double Curs,double Image,Graphics Graph)
	{
		double Coef=DeriveFonction(Curs);
		if (Arrondir(Curs)==Arrondir(Tx)) {Coef=DeriveFonction(Tx);}
		double OrdaOrigine=Image-Coef*Curs;
		int x=Absc(xmin);
		int y=Ordo(Coef*xmin+OrdaOrigine);
		int xx=Absc(xmax);
		int yy=Ordo(Coef*xmax+OrdaOrigine);
		Graph.setColor(new Color(255,0,0));
		Graph.drawLine(x,y,xx,yy);
	}
	
	public void CalculCourbeDiscontinuite()
	{
		int indice=indiceAbscisse; // L'indice de Point[] qui spare les deux courbes.
		xpas=((double) Largeur/(xmax-xmin));ypas=(double) ((double)Hauteur/(ymax-ymin));
		xO=(int)(-xpas*xmin);yO=(int)(ypas*ymax);
		// recherche le indice de discontinuite
		//for (int i=0;i<NbPoints;i++) if (Inter[0].Y()==Point[i][0]) {indice=i;i=NbPoints;}
		//Calcul des polynomes
		for (int i=0;i<indice;i++)	{CalculHermite(i,0d,0d);}
		Point[indice][0]--;for (int i=indice;i<NbPoints-1;i++)	{CalculHermite(i,0d,0d);}
		Point[indice][0]++;
		//Calcule des pixels
		LargeurCourbe=Absc(Math.min(Point[(NbPoints-1)][0],xmax))-Absc(Math.max(Point[0][0],xmin));
		
		pixel=Math.max(Absc(Point[0][0]),Absc(xmin));
		LargeurCourbe2=Math.min(Absc(Point[indice][0]),Absc(xmax))-pixel;
		if (abscissePixel(LargeurCourbe2)>Inter[0].Y()) {LargeurCourbe2--;}
		if (LargeurCourbe2<=0) {Courbe2=false;}
		else 
		{
			Courbe2=true;
			for (int j=0;j<=LargeurCourbe2;j++)
			{PixelX[j]=pixel;PixelY[j]=Ordo(Fonction(abscissePixel(pixel)));pixel++;}
		}
		pixel=Absc(Math.max(Inter[1].X(),xmin));if (abscissePixel(pixel)<Inter[1].X()) {pixel++;}
		LargeurCourbe3=Math.min(Absc(Point[NbPoints-1][0]),Absc(xmax))-pixel;
		if (abscissePixel(LargeurCourbe3+pixel)>Inter[1].Y()) {LargeurCourbe3--;}
		
		if (LargeurCourbe3<=0) {Courbe3=false;}
		else 
		{
			Courbe3=true;
			PixelX2[0]=pixel;PixelY2[0]=Ordo(Point[indice+1][1]);pixel++;
			for (int j=1;j<=LargeurCourbe3;j++)
			{PixelX2[j]=pixel;PixelY2[j]=Ordo(Fonction(abscissePixel(pixel)));pixel++;}
		}
	}
	public double abscissePixel(int p)  // convertit le pixel p en abscisse double
	{
		return ((double)(p-xO))/xpas;
	}
	public double ordonneePixel(int p)
	{
		return ((double)(yO-p))/ypas;
	}
	public void CalculHermite(int i,double a,double b)
	{
		d=(Point[i][0]-Point[i+1][0]);d=d*d*d;a=0d;b=0d;
		
		if (Tangente)
		{
			if (indiceTangente==(i+1)) {b=Tcoef;}
			if (indiceTangente==i) {a=Tcoef;}
		}
		
		Polynome[i][0]=(Point[i][0]*a+b*Point[i][0]-Point[i+1][0]*a+2*Point[i+1][1]-2*Point[i][1]-b*Point[i+1][0])/d;
		Polynome[i][1]=(-2*b*Point[i][0]*Point[i][0]-Point[i][0]*Point[i][0]*a+3*Point[i][1]*Point[i][0]-3*Point[i+1][1]*Point[i][0]+b*Point[i+1][0]*Point[i][0]-Point[i+1][0]*Point[i][0]*a+2*Point[i+1][0]*Point[i+1][0]*a+3*Point[i][1]*Point[i+1][0]-3*Point[i+1][1]*Point[i+1][0]+b*Point[i+1][0]*Point[i+1][0])/d;
		Polynome[i][2]=(-Point[i+1][0]*Point[i+1][0]*Point[i+1][0]*a-2*b*Point[i+1][0]*Point[i+1][0]*Point[i][0]-Point[i+1][0]*Point[i+1][0]*a*Point[i][0]+2*Point[i][0]*Point[i][0]*a*Point[i+1][0]+b*Point[i][0]*Point[i][0]*Point[i+1][0]+6*Point[i+1][1]*Point[i+1][0]*Point[i][0]-6*Point[i][1]*Point[i+1][0]*Point[i][0]+b*Point[i][0]*Point[i][0]*Point[i][0])/d;
		Polynome[i][3]=(Point[i+1][0]*Point[i+1][0]*Point[i+1][0]*Point[i][0]*a-Point[i][1]*Point[i+1][0]*Point[i+1][0]*Point[i+1][0]-Point[i+1][0]*Point[i+1][0]*Point[i][0]*Point[i][0]*a+b*Point[i+1][0]*Point[i+1][0]*Point[i][0]*Point[i][0]+3*Point[i][1]*Point[i+1][0]*Point[i+1][0]*Point[i][0]-b*Point[i+1][0]*Point[i][0]*Point[i][0]*Point[i][0]-3*Point[i+1][1]*Point[i+1][0]*Point[i][0]*Point[i][0]+Point[i+1][1]*Point[i][0]*Point[i][0]*Point[i][0])/d;
	}
	//Correction Inquations*****************
	public void PixelisationIntervalle(Intervalle Inter)
	{  //PixelInterX
		if (Inter.Point())
		{
			PixelPointX[CompteurPoint]=Absc(Inter.X());
			CompteurPoint++;
		}
		else
		{
			PixelInterX[CompteurInter]=Absc(Inter.X());
			PixelInterY[CompteurInter]=Absc(Inter.Y());
			G[CompteurInter]=Inter.OuvertaG();
			D[CompteurInter]=Inter.OuvertaD();
			CompteurInter++;
		}
	}
	public double Fonction(double x)
	{
		int i=0;
		while (Point[i+1][0]<x && (i<NbPoints)) {i++;}
		return (((Polynome[i][0]*x)+Polynome[i][1])*x+Polynome[i][2])*x+Polynome[i][3];
	}
	public double DeriveFonction(double x)
	{
		int i=0;
		while (Point[i+1][0]<x && (i<NbPoints)) {i++;}
		return (((3d*Polynome[i][0]*x)+2d*Polynome[i][1])*x+Polynome[i][2]);
	}
	public boolean DomaineDef(double x)
	{
		boolean reponse=true;
		if ((Point[0][0]>x) | (Point[(NbPoints-1)][0]<x)) {reponse=false;}
		else
		{
			if (Limite)
			{
				if (NbInter!=1)
				{	x=Arrondir4(x);
					if (Egal(x,Inter[0].Y()) && Inter[0].OuvertaD()) {reponse=false;}
					if (Egal(x,Inter[1].X()) && Inter[1].OuvertaG()) {reponse=false;}
					if ((Egal(x,Inter[0].Y()) && !Inter[0].OuvertaD()) | (Egal(x,Inter[1].X()) && !Inter[1].OuvertaG())) {reponse=true;}
					if ((Inter[0].Y()<x) && (x<Inter[1].X()))  {reponse=false;}
				}
			}
		}
		if (Droite)
		{
			reponse=true;
		}
		return reponse;
	}
	public double Arrondir4(double nb) {return ((double)Math.round(nb*100000))/100000d;}
	public double Arrondir(double nb) {return ((double)Math.round(nb*10))/10d;}
	public boolean Egal(double a,double b) {return ((Math.abs(a-b)<0.00001d));}
	public boolean Proche(double x) 
	{
		boolean Rep=false;
		if (NbInter!=1) {Rep=((Math.abs(x-Inter[0].Y())<1d) | (Math.abs(x-Inter[1].X())<1d));}
		return Rep;
	}
	
	public int Absc(double x)	{return (int) ((x-xmin)*xpas);} // convertit en pixel
	public int Ordo(double y)	{return (int) ((ymax-y)*ypas);} // convertit en pixel
	
	public void AfficheRepere(Graphics Graph)
	{
		double x;
		double graduationX=1d;
		double Arr=1;

		if ((xmax-xmin)<=5d) {graduationX=0.5d;Arr=10d;}
		if ((xmax-xmin)<=1d) {graduationX=0.1d;;Arr=10d;}
		if ((xmax-xmin)<=0.5d) {graduationX=0.05d;Arr=100d;}
		//Grilles
		Graph.setColor(new Color(0,0,200));
		for(double i=xmin;i<xmax;i=i+graduationX){Graph.drawLine(Absc(i),0,Absc(i),Hauteur);}
		x=0;for(double i=ymin;i<ymax;i++)	{x=x+ypas;Graph.drawLine(0,(int)x,Largeur,(int)x);}
		//Axes
		Graph.setColor(new Color(0,255,15));
		Graph.drawLine(0,yO,Largeur,yO); // abcsisses
		Graph.drawLine(xO,0,xO,Hauteur);
		//Flches
		Graph.drawLine(Largeur,yO,(Largeur-5),(yO-5));
		Graph.drawLine(Largeur,yO,(Largeur-5),(yO+5));
		Graph.drawLine(xO,0,(xO-5),5);
		Graph.drawLine(xO,0,(xO+5),5);
		//Graduations
		if ((Arr==1d) && (Math.round(i)==i)) 
		{for(double i=xmin;i<xmax;i=i+graduationX) {Graph.drawString(""+(int) (i),Absc(i),yO-2);x=x+graduationX;}}
		else {for(double i=xmin;i<xmax;i=i+graduationX) {Graph.drawString(""+(Math.round(i*Arr)/Arr),Absc(i),yO-2);x=x+graduationX;}}
		x=Hauteur-5;for(double i=ymin;i<ymax;i++) {Graph.drawString(""+Math.round(i),xO+2,(int) x);x=x-ypas;}
		
	}
	public void Affiche(String Sx,String Sy,Graphics Graph)
	{
		int xSx=Cx;
		int ySx=Cy;
		int ySy=Cy;
		int xSy=Cx;
		int lgx=fm.stringWidth(Sx)+6;
		int lgy=fm.stringWidth(Sy)+13;
		//Sx
		if (Cy>yO) {ySx=yO-12;} else {ySx=yO+12;}
		if (ySx>Hauteur-2) {ySx=yO-12;}
		if (ySx<0) {ySx=yO+12;}
		xSx=Math.min(Cx,Largeurreelle-lgx);
		//Sy
		if (Cx<xO) {xSy=xO+12;} else {xSy=xO-lgy;}
		if (xSy>Largeurreelle-lgy) {xSy=xO-lgy;}
		if (xSy<0) {xSy=xO+12;}
		ySy=Math.max(12,Cy);
		ySy=Math.min(Hauteur-2,ySy);
		Graph.drawString(Sx,xSx,ySx);Graph.drawString(Sy,xSy,ySy);
		if ((!EntrainAgrandir) && (Sx.length()!=0) && (Sy.length()!=0))
		{
			String Phx="("+Sx+" ; "+Sy+")";
			int taille=fm.stringWidth(Phx)+21;
			int x=0;
			int y=12;
			if (Math.abs(xmin)<Math.abs(xmax)) {x=Largeurreelle-taille;}
			if (Math.abs(ymin)>Math.abs(ymax)) {y=Hauteur-2;}
			Graph.drawString(Phx,x,y);
		}
	}
	public void AfficheCurseur(double Curs,boolean Corr,Graphics Graph)
	{
		if (DomaineDef(Curs)) 
		{
			int dy=12;
			Graphics2D graphics2D = (Graphics2D) Graph;
			double Image=Fonction(Curs);
			
			if (Tangente) 
			{
				AfficheTangente(Curs,Image,Graph);
				if (Arrondir(Curs)==Arrondir(Tx)) AideCoef(xE,yE,xF,yF,graphics2D);
			}
			
			if (Droite) 
			{
				float[] style={2,10};
				graphics2D.setStroke( new BasicStroke(1,BasicStroke.CAP_BUTT,BasicStroke.JOIN_MITER,10.0f,style,0));
				int xA=(int) Math.round(abscissePixel(BallX[0]));
				int yA=(int) Math.round(ordonneePixel(BallY[0]));
				int xB=(int) Math.round(abscissePixel(BallX[1]));
				int yB=(int) Math.round(ordonneePixel(BallY[1]));
				if (Bulle)	
				{
					if (tableau) {Graph.drawImage(image,Absc((double)(xA)),Ordo((double)(yA)),null);} else {Graph.drawImage(image,(Largeur/2-133),(Hauteur/2-86),null);}
				}
				AideCoef(xA,yA,xB,yB,graphics2D);
			}
			else
			{
				for (int v=0;v<NbTriche;v++)
				{
					if (((float) (Math.round(Curs*10d))/10f)==Triche[v][0]) 
							{Image=(double) Triche[v][1];}
				}
				
				Cx=Absc(Curs);Cy=Ordo(Image);
				if (Bulle)
				{
					Graph.drawImage(image,Cx,Cy,null);
				}
							
				if (Corr) 
				{
					Graph.setColor(new Color(255,0,0));
					Affiche(""+(float) (Math.round(Curs*10))/10,"",Graph);
					if (First) {Affiche("",""+(float) (Math.round(Image*100))/100,Graph);}
				}
				else
				{
					Graph.setColor(new Color(255,255,0)); // Fonctionnement normal
					String Phx="x="+(float) (Math.round(Curs*10))/10;
					if (Limite) {if (Proche(Curs)) {Phx="x="+(Arrondir4(Curs));}}				
					float yyy;
					if (tableau) {yyy=(float) (Math.round(Image*10d))/10f;} else {yyy=(float) (Math.round(Image*1000d))/1000f;}
					Affiche(Phx,""+yyy,Graph);
					
					if (BarrePasAnt) {int k=Ordo(Ant);Graph.drawLine(0,k,Largeur,k);Graph.drawString("y="+Ant,Largeur-40,k+dy);}
				}
				
				// Pointills
				if ((!Tangente) || (Arrondir(Curs)!=Arrondir(Tx)) || (!AffLigne) )
				{
					float[] style={5,10};
					graphics2D.setStroke( new BasicStroke(1,BasicStroke.CAP_BUTT,BasicStroke.JOIN_MITER,10.0f,style,0)); //pointills 10 blancs 5
					graphics2D.drawLine(Cx,Cy,Cx,yO);graphics2D.drawLine(Cx,Cy,xO,Cy);
					graphics2D.setStroke(new BasicStroke( 1f ));// retire les pointills.	
				}
				
			}
		}
	}
	public void AideCoef(int xA,int yA,int xB,int yB,Graphics2D graphics2D)
	{
		float[] style={3,10};
		graphics2D.setStroke( new BasicStroke(1,BasicStroke.CAP_BUTT,BasicStroke.JOIN_MITER,10.0f,style,0));
		int PxA=Absc((double)(xA));int PyA=Ordo((double)(yA));int PxB=Absc((double)(xB));int PyB=Ordo((double)(yB));
		Den=xB-xA;Num=yB-yA;
		if (AffLigne)
		{
			graphics2D.drawLine(PxA,PyA,PxB,PyA);graphics2D.drawLine(PxB,PyA,PxB,PyB);	
			style[0]=10f;style[1]=0f;graphics2D.setStroke( new BasicStroke(1,BasicStroke.CAP_BUTT,BasicStroke.JOIN_MITER,10.0f,style,0));
			if (PxA<PxB) {graphics2D.drawLine(PxB,PyA,PxB-13,PyA-10);graphics2D.drawLine(PxB,PyA,PxB-13,PyA+10);}
			else {graphics2D.drawLine(PxB,PyA,PxB+13,PyA-10);graphics2D.drawLine(PxB,PyA,PxB+13,PyA+10);}
			
			if (PyB!=PyA)
			{
				if (PyB>PyA) {graphics2D.drawLine(PxB,PyB,PxB-10,PyB-13);graphics2D.drawLine(PxB,PyB,PxB+10,PyB-13);}
				else {graphics2D.drawLine(PxB,PyB,PxB-10,PyB+13);graphics2D.drawLine(PxB,PyB,PxB+10,PyB+13);}
			}
			
		}
		Font En=new Font("", Font.BOLD, 18);
		graphics2D.setFont(En);if (!Tangente) graphics2D.setColor(new Color(255,255,255));
		if ((AffCoef) && (AffLigne))
		{
			graphics2D.drawString(""+(xB-xA),(PxB+PxA)/2,PyA);
			graphics2D.drawString(""+(yB-yA),PxB+1,(PyB+PyA)/2);
		}
		graphics2D.setStroke(new BasicStroke( 1f ));
		En=new Font("", Font.BOLD, 12);graphics2D.setFont(En);
	}
	public void BDBulle(String Ch,int x,int y)
	{
		BDBulle=Toolkit.getDefaultToolkit().createImage(getClass().getResource(Ch));
		BDx=x;BDy=y;
	    MediaTracker mt = new MediaTracker(this); 
	    mt.addImage(BDBulle, 0); 
	    try 
	    { 
	    	mt.waitForAll(); 
	    } 
	   catch (InterruptedException e) {} 
	}
	public void OvalTangenteInitialise()
	{
		OvalIteration=0;
	}
	public void OvalTangente(int x,int y)
	{
		OvalTangenteX[OvalIteration]=x;OvalTangenteY[OvalIteration]=y;OvalIteration++;
	}
	public void paintComponent(Graphics Graph)
	{
		super.paintComponent(Graph);
		
		Graph.setFont(En);
		
		AfficheRepere(Graph);
		if (BD)
		{
			Graph.drawImage(BDBulle,BDx,BDy,null);
		}
		
//		 affiche les barres Inquation
		if (AfficheBarreIneq)
		{
			int dy=12;
			int k;
			Graph.setColor(new Color(128,128,0));
			if (borne1<ymin+2) {dy=-12;}
			if (Math.abs(borne1)<1.5d) 
			{
				if (borne1>0) {dy=-12;} else {dy=12;}
			}
			if (borne1>ymin && borne1!=0) {k=Ordo(borne1);Graph.drawLine(0,k,Largeur,k);Graph.drawString("y="+borne1,Largeur-40,k+dy);}
			dy=12;
			Graph.setColor(new Color(128,0,128));
			if (borne2<ymax-2) {dy=-12;}
			if (Math.abs(borne2)<1.5d) 
			{
				if (borne2>0) {dy=-12;} else {dy=12;}
			}
			if (borne2<ymax && borne2!=0) {k=Ordo(borne2);Graph.drawLine(0,k,Largeur,k);Graph.drawString("y="+borne2,Largeur-40,k+dy);}
			Graph.setColor(new Color(0,255,0));
		}
		
		if ((Limite) && (LargeurCourbe2!=0))
		{
			if (Courbe2) Graph.drawPolyline(PixelX,PixelY,LargeurCourbe2-1);
			if (Courbe3) Graph.drawPolyline(PixelX2,PixelY2,LargeurCourbe3);
		}
		else 
		{ 
			Graph.drawPolyline(PixelX,PixelY,LargeurCourbe);
		}
		
		if (tableau)
		{
			for (int i=0;i<NbPoints;i++)
			{
				if (Droite)
				{
					if (CorrDroite)
					{
						Graph.fillOval(Absc(Point[i][0])-5,Ordo(Point[i][1])-5,10,10);
					}
					else
					{
						int x=(int) Math.round(abscissePixel(BallX[i]));
						int y=(int) Math.round(ordonneePixel(BallY[i]));
						Graph.fillOval(Absc(x)-5,Ordo(y)-5,10,10);
					}
				}
				else {Graph.fillOval(BallX[i]-5,BallY[i]-5,10,10);}
			}
		}
		// Tangente Correction
		if (Tangente)
		{
			for (int i=0;i<OvalIteration;i++)
			{
				Graph.setColor(new Color(255,0,0));
				Graph.fillOval(OvalTangenteX[i]-5,OvalTangenteY[i]-5,10,10);
			}
		}
		//Cadre zoom
		if (EntrainAgrandir) {Graph.drawRect(CursX,CursY,lg,ht);}
		//Affichage Cf
		if ((Limite) && (!Courbe2) && (Courbe3))
		{
			if (PixelY2[1]>PixelY2[0]) {Graph.drawString("(Cf)",PixelX2[0]+10,PixelY2[0]-10);} else {Graph.drawString("(Cf)",PixelX2[0]+10,PixelY2[0]+10);}
		}
		else
		{
			if (((Limite) && (Courbe2)) | (!Limite))
			{
				if (PixelY[1]>PixelY[0]) {Graph.drawString("(Cf)",PixelX[0]+10,PixelY[0]-10);} else {Graph.drawString("(Cf)",PixelX[0]+10,PixelY[0]+10);}
			}
		}
		if (Correct_Ant)
		{// Correction
			First=true;
			int i=0;
			AfficheCurseur(Correct_Parcours,false,Graph);
			while ((Abs_Ant[i]<Correct_Parcours) && (i<NbAnt))
			{
				AfficheCurseur(Abs_Ant[i],true,Graph); // Affiche les points antcdents
				i++;First=false;
			}
		}
		else {AfficheCurseur(Curseur,false,Graph);} // Mode normal
		
		// Correction Inquations
		if (Correct_Ineq)
		{	
			Graphics2D graphics2D = (Graphics2D) Graph;
			graphics2D.setStroke( new BasicStroke(3,BasicStroke.CAP_ROUND,BasicStroke.JOIN_BEVEL));
			int Mult;
			int Couleur=0;
			for (int i=0;i<CompteurInter;i++)
			{
				graphics2D.setColor(new Color(255,Couleur,0));Couleur=255-Couleur;
				if (PixelInterX[i]<=CurseurPixel)
				{	Mult=1;
					if (i!=0)
					{
						if ((PixelInterX[i]-PixelInterY[i-1])<6) {Mult=2;}
					}
					if (G[i]) {Crochet1(PixelInterX[i],HauteurCrochet*Mult,graphics2D);} else {Crochet2(PixelInterX[i],HauteurCrochet*Mult,graphics2D);}
					if (PixelInterY[i]<=CurseurPixel)
					{
						if (D[i]) {Crochet2(PixelInterY[i],HauteurCrochet,graphics2D);} else {Crochet1(PixelInterY[i],HauteurCrochet,graphics2D);}
						if (Correct_Intervalle) {graphics2D.drawLine(PixelInterX[i],yO,PixelInterY[i],yO);}
						RepassePoint(PixelInterX[i],PixelInterY[i],graphics2D);
					}
					else 
					{
						if (Correct_Intervalle) {graphics2D.drawLine(PixelInterX[i],yO,CurseurPixel,yO);}
						RepassePoint(PixelInterX[i],CurseurPixel,graphics2D);
					}
				}
			}
			for (int i=0;i<CompteurPoint;i++)
			{
				graphics2D.setColor(new Color(255,Couleur,0));Couleur=255-Couleur;
				if (PixelPointX[i]<=CurseurPixel)
				{
					if (Correct_Intervalle)
					{
						graphics2D.drawLine(PixelPointX[i]-HauteurCrochet,yO+HauteurCrochet,PixelPointX[i]+HauteurCrochet,yO-HauteurCrochet);
						graphics2D.drawLine(PixelPointX[i]-HauteurCrochet,yO-HauteurCrochet,PixelPointX[i]+HauteurCrochet,yO+HauteurCrochet);
					}
					RepasseSingleton(PixelPointX[i],graphics2D);
				}
			}
		}
	}
	public void RepassePoint(int x,int y,Graphics2D graphics2D)
	{
		
		
		int debut=x-PixelX[0],fin=y-PixelX[0];
		if (!Correct_Intervalle) 
		{
			graphics2D.setColor(new Color(255,0,0));
			graphics2D.fillOval(PixelX[debut]-5,PixelY[debut]-5,10,10);
		}
		if (debut<LargeurCourbe)
		{
			if (!Correct_Intervalle) 
			{
				graphics2D.setColor(new Color(255,0,0));
				if (fin<1)
				{
					graphics2D.fillOval(PixelX[0]-5,PixelY[0]-5,10,10);
				}
				else {graphics2D.fillOval(PixelX[fin-1]-5,PixelY[fin-1]-5,10,10);}
			}
			fin=Math.min(LargeurCourbe,fin);
			if (fin>1)
			{
				for (int i=debut;i<fin-2;i=i+2)
				{
					graphics2D.drawLine(PixelX[i],PixelY[i],PixelX[i+2],PixelY[i+2]);
				}
				graphics2D.drawLine(PixelX[fin-2],PixelY[fin-2],PixelX[fin-1],PixelY[fin-1]);
			}
			else {graphics2D.drawLine(PixelX[0],PixelY[0],PixelX[1],PixelY[1]);}
			
		}
	}
	public void RepasseSingleton(int x,Graphics2D graphics2D)
	{
		int debut=x-PixelX[0];
		if (!Correct_Intervalle) {graphics2D.setColor(new Color(255,0,0));}
		if (debut<LargeurCourbe)
		{
			graphics2D.fillOval(PixelX[debut]-5,PixelY[debut]-5,10,10);
		}
	}
	
	public void Crochet1(int x,int taille,Graphics2D graphics2D) // ]
	{
		if (Correct_Intervalle)
		{
			graphics2D.drawLine(x,yO-taille,x,yO+taille);
			graphics2D.drawLine(x,yO-taille,x-6,yO-taille);
			graphics2D.drawLine(x,yO+taille,x-6,yO+taille);
		}
	}
	public void Crochet2(int x,int taille,Graphics2D graphics2D) // [
	{
		if (Correct_Intervalle)
		{
			graphics2D.drawLine(x,yO-taille,x,yO+taille);
			graphics2D.drawLine(x,yO-taille,x+6,yO-taille);
			graphics2D.drawLine(x,yO+taille,x+6,yO+taille);
		}
	}
	
	public void mouseClicked(MouseEvent arg0) 	{}
	public void mouseEntered(MouseEvent arg0) 	{}
	public void mouseExited(MouseEvent arg0) 	{}
	public void mousePressed(MouseEvent arg0) 
	{
		CurseurPixel=arg0.getX();
		Curseur=abscissePixel(arg0.getX());
		repaint();
	}
	public void mouseReleased(MouseEvent arg0) 
	{
		if (Agrandir)
		{
			EntrainAgrandir=false;
			Agrandir=false;MesDef.Agrandir.setForeground(new Color(0,0,0));
			ZoomCourbe();
			repaint();
		}
	}
	public void mouseDragged(MouseEvent arg0) 
	{
		
		if (tableau)
		{
			boolean cont=true;
			if (!EntrainBall)
			{
				for (int i=0;i<NbPoints;i++)
				{
					if ((Math.abs(arg0.getX()-BallX[i])<uniteX) && (Math.abs(arg0.getY()-BallY[i])<uniteY)) {QBall=i;EntrainBall=true;break;}
				}
			}
			if (EntrainBall)
			{
								
				if (QBall!=0) {if (arg0.getX()<(BallX[QBall-1]+uniteX)) {cont=false;}}
				if (QBall!=(NbPoints-1)) {if (arg0.getX()>(BallX[QBall+1]-uniteX)) {cont=false;}}
				
				if (cont)
				{
					BallX[QBall]=arg0.getX();BallY[QBall]=arg0.getY();CalculTableau();
					repaint();
				}
				else {EntrainBall=false;}
			}
		}
		
		if (Agrandir)
		{
			if (EntrainAgrandir) 
			{
				lg=arg0.getX()-CursX;ht=arg0.getY()-CursY;
				if (lg<0) {lg=-lg;CursX=arg0.getX();}
				if (ht<0) {ht=-ht;CursY=arg0.getY();}
			}
			else 
			{CursX=arg0.getX();CursY=arg0.getY();EntrainAgrandir=true;}
		}
		else
		{
			CurseurPixel=arg0.getX();
			Curseur=abscissePixel(arg0.getX());
		}
		repaint();
	}
	public void mouseMoved(MouseEvent arg0) 
	{}
}
