/*
 * Copyright Mr DROUOT Patrick since 2006
 * 
 * www.patrickdrouot2000@yahoo.fr
 * 
 * 
 * This file is part of GraphExotica.
 * GraphExotica is free software;
 * you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2 of the License.
 * GraphExotica is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. 

*/
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.text.DateFormat;
import java.util.Date;
import java.util.Locale;
public class Principal extends JFrame implements ActionListener
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 698667084836171251L;
	ImageIcon Toto,Attention,Triste;
	public static boolean StopChronos=false;
	static boolean IsThread;
	final int DiffMax=6;
	int Largeur,Hauteur; //Dimensions de l'cran
	int LargeurCourbe,HauteurCourbe; // Largeur et Hauteur du panneau du repre courbe
	double xmin,xmax,ymin,ymax; // taille du repre
	int NbGraduationsAbscisses,NbGraduationsOrdonnees;
	double[][] Point=new double [20][2]; // points d'interpolation
	double[][] PointV=new double [20][2]; // tableau de variations
	int NbPoints; // nombre de points d'interpolation
	int NbPointsV; // Tableau de variations
	int Difficulte;
	int Erreur,NbQuestion,ErreurQuestion;
	public Object o=this; // Pour les boites de dialogues !
	//Exo Inquation
	boolean ExoInequation=false;
	boolean Doucement=false;
	int Doux=0;
	public boolean Apprentissage;
	public double sup,inf,borne1,borne2;
	public int Indice[]=new int[8];
	public int CompteurIndice,NbInter;
	public Intervalle Inter[]=new Intervalle[8]; // Correction automatique
	public Intervalle InterS[]=new Intervalle[8]; // Saisie de l'utilisateur
	public boolean Inegalite1,Inegalite2;
	public boolean UneBorne;
	public boolean PasSolIneq;
	public boolean SansSingleton=false;
	public boolean Tangente=false;
	public String Ineq;
	public double Extremite;
	String Sol;
	String Rep;
	final char guil='"';
	int NbInterS;
	boolean Recom;
	//Exo_droite
	int xA,yA,xB,yB,Ordb;
	boolean BloqCoef,OrdAOrigine;
	public int module;
	//Exo Antcdents
	public boolean Preums=true;
	public int NbAnt=0; // Nb d'antcdents
	public double Ant;
	public double xAnt[]=new double[8];
	public String Info; // Pour le dialogue
	public boolean Exo_Ant; // false-> quation
	public boolean CorrectionAnt=false;
	//Exo Images
	public double Image,Anteced;
	public boolean Phrase;
	// Evaluation
	String NomEvaluation;
	boolean Passe;
	boolean PasDernierEval;
	boolean Evaluation=false;
	int EvalIter;
	int EvalExo[];
	double note;
	int NbAntEval=0;
	int NbIneqEval=0;
	boolean AvecAnt=false; // true -> oblige l'existence de NbAntEval antcdents ! sinon laisse le choix au hasard;
	boolean AvecIneq=false;
	int NbreQuestImage,NbreQuestAnt,NbreQuestEqu,NbreQuestIneq;
	int NbreQuestVariation,ErrVariation,PointQuest;
	int ErrImage,ErrAnt,ErrEqu;
	int NbreQuestDroite,ErrDroite;
	int NbreQuestTangente,ErrTangente;
	boolean Aide=false;
	float ErrCrochet,ErrIneq;
	boolean Crochet;
	String Path;
	String Nom="";
	String Bilan;
	final int NbResult=7;
	String Resultat[]=new String[NbResult];
	//Ensemble Def
	boolean EnsDef,Lim,PremierZoom;
	double ValeurLimite;
	//tableaux
	boolean CorrectionV=false;
	Container Content;
	JMenuItem Exo_Nombre_Derive=new JMenuItem("Nombre driv");
	JMenuItem Exo_Tangente=new JMenuItem("Equation tangente");
	JMenuItem Exo_Def = new JMenuItem("Ensemble de dfinition simple");
	JMenuItem Exo_Defc = new JMenuItem("Ensemble de dfinition");
	JMenuItem Exo_Lim = new JMenuItem("Limites");
	JMenuItem Exo_Images = new JMenuItem("Images");
    JMenuItem Exo_Antecedents = new JMenuItem("Antcdents");
    JMenuItem Exo_Equation = new JMenuItem("Equations");
    JMenuItem Exo_InEquation = new JMenuItem("Inquations");
    JMenuItem Exo_InEquationApprentissage = new JMenuItem("Inquations faciles");
    JMenuItem Exo_InEquationSansG = new JMenuItem("Inquations sans singleton");
    JMenuItem Exo_DoubleInEquation = new JMenuItem("Double inquations");
    JMenuItem Exo_variation = new JMenuItem("Tableaux de variations - Courbe");
    JMenuItem Exo_variation2 = new JMenuItem("Courbe - Tableaux de variations");
    JMenuItem DCoef = new JMenuItem("Droite - Coefficient directeur");
    JMenuItem CoefD = new JMenuItem("Coefficient directeur - Droite");
    JMenuItem EquD = new JMenuItem("Equation - Droite");
    JMenuItem DEqu = new JMenuItem("Droite - Equation");
    JMenuItem Quitter = new JMenuItem("Quitter");
    JMenuItem EvalImaAnt = new JMenuItem("Images et antcdents");
    JMenuItem EvalIneq = new JMenuItem("Images, antcdents, quations, et inquations");
    JMenuItem EvalVariation = new JMenuItem("Tableaux de variations");
    JMenuItem EvalDroite = new JMenuItem("Equations de droite");
    JMenuItem EvalSeconde = new JMenuItem("Gnrale");
    JMenuItem EvalPremS = new JMenuItem("Equations, inquations, et variations");
    JMenuItem EvalPremSTG = new JMenuItem("Equations, inquations, et variations");
    JMenuItem EvalPremL = new JMenuItem("Images, quations, inquations, et variations");
    JMenuItem Eval_Derive=new JMenuItem("Nombres drivs - Tangentes");
    JMenuItem ChoixDuRepertoire = new JMenuItem("Rpertoire");
    JMenuItem Help = new JMenuItem("Aide");
    JMenuItem HelpEval = new JMenuItem("Contenu des valuations");
    JMenuItem Auteur=new JMenuItem("A propos de");
    JMenuItem Licence=new JMenuItem("Licence");
// Panneau principal
    JPanel Affichage;
    BarreDiff Power;
//	dclaration des panneaux
    PanneauCourbe MaCourbe;
    DialogueAntecedents MesAntecedents;
    DialogueImages MesImages;
    DialogueInequation MesInequations;
    EnsembleDef MesDef;
    DialogueVariations MesVar;
    DialogueVariations2 MesVar2;
    DialogueLectGraphCoef MesLectGraphCoef;
	
	public Principal()
    {
		Principal.IsThread=false;
        Initialise();
        setVisible(true);   
    }
	public void Initialise()
	{
// rpertoire courant dans Path
		RepertoirCourant();
		Toto=new ImageIcon(getClass().getResource("Smiley50.png")); // Sensible aux majuscules !
		Attention = new ImageIcon(getClass().getResource("Attention.png"));
		Triste = new ImageIcon(getClass().getResource("Triste50.png"));
        Container Content = this.getContentPane();        
        Largeur = (int)Toolkit.getDefaultToolkit().getScreenSize().width;
        Hauteur = (int)Toolkit.getDefaultToolkit().getScreenSize().height;
        NbGraduationsAbscisses=Largeur/50;NbGraduationsOrdonnees=Hauteur/64;
        setBounds(0,0,Largeur, Hauteur);
        this.setResizable(false);
        this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE); // Ne peut tre ferme avec X
        if ((Hauteur<600) | (Largeur<800)) 	{Information("Rsolution insuffisante !");setVisible(false);dispose();System.exit(0);}
        JMenuBar MenuBar = new JMenuBar();
        this.setJMenuBar(MenuBar);
        JMenu Menu1 = new JMenu("Exercices");
        JMenu SousMenu1 = new JMenu ("Equations de droite");
        JMenu Menu2 = new JMenu("Evaluation");
        JMenu SousMenu2 = new JMenu("Seconde");
        JMenu SousMenu2S= new JMenu("PremireS");
        JMenu SousMenu2STG= new JMenu("PremireSTG");
        JMenu SousMenu2L= new JMenu("PremireL");
        JMenu Menu3 = new JMenu("Configuration");
        JMenu Menu4 = new JMenu("Aide");
        MenuBar.add(Menu1);
        //Menu1.add(Exo_Defc);
        Menu1.add(SousMenu1);
        SousMenu1.add(DCoef);SousMenu1.add(CoefD);SousMenu1.add(EquD);SousMenu1.add(DEqu);
        Menu1.addSeparator();
        Menu1.add(Exo_Def);Menu1.add(Exo_Images);Menu1.add(Exo_Antecedents);
        Menu1.add(Exo_Equation);Menu1.add(Exo_InEquationApprentissage);Menu1.add(Exo_InEquationSansG);
        Menu1.add(Exo_InEquation);Menu1.add(Exo_DoubleInEquation);
        Menu1.addSeparator();
        Menu1.add(Exo_variation);Menu1.add(Exo_variation2);
        Menu1.addSeparator();
        Menu1.add(Exo_Lim);
        Menu1.addSeparator();
        Menu1.add(Exo_Nombre_Derive);Menu1.add(Exo_Tangente);
        Menu1.addSeparator();
        Menu1.add(Quitter);
        Menu2.add(SousMenu2);
        SousMenu2.add(EvalImaAnt);SousMenu2.add(EvalIneq);SousMenu2.add(EvalSeconde);
        Menu2.add(SousMenu2S);
        SousMenu2S.add(EvalPremS);
        Menu2.add(SousMenu2STG);
        SousMenu2STG.add(EvalPremSTG);
        Menu2.add(SousMenu2L);
        SousMenu2L.add(EvalPremL);
        Menu2.add(EvalVariation);Menu2.add(EvalDroite);Menu2.add(Eval_Derive);
        MenuBar.add(Menu2);
        Menu3.add(ChoixDuRepertoire);
        MenuBar.add(Menu3);
        Menu4.add(Help);Menu4.add(HelpEval);Menu4.add(Auteur);Menu4.add(Licence);
        MenuBar.add(Menu4);
        
        // Ecouteurs du menu
        //this.addWindowListener( new WindowAdapter(){public void windowClosing(WindowEvent e){setVisible(false);dispose();System.exit(0);}});
        Quitter.addActionListener( new ActionListener(){public void actionPerformed(ActionEvent e){System.exit(0);}});
        DCoef.addActionListener(this);
        CoefD.addActionListener(this);
        EquD.addActionListener(this);
        DEqu.addActionListener(this);
        Exo_Def.addActionListener(this);
        Exo_Defc.addActionListener(this);
        Exo_Images.addActionListener(this);
        Exo_Antecedents.addActionListener(this);
        Exo_Equation.addActionListener(this);
        Exo_InEquation.addActionListener(this);
        Exo_InEquationApprentissage.addActionListener(this);
        Exo_InEquationSansG.addActionListener(this);
        Exo_DoubleInEquation.addActionListener(this);
        Exo_variation.addActionListener(this);
        Exo_variation2.addActionListener(this);
        EvalImaAnt.addActionListener(this);
        EvalIneq.addActionListener(this);
        EvalVariation.addActionListener(this);EvalDroite.addActionListener(this);
        EvalSeconde.addActionListener(this);
        EvalPremS.addActionListener(this);
        EvalPremSTG.addActionListener(this);
        EvalPremL.addActionListener(this);
        Eval_Derive.addActionListener(this);
        ChoixDuRepertoire.addActionListener(this);
        Help.addActionListener(this);
        HelpEval.addActionListener(this);
        Auteur.addActionListener(this);
        Licence.addActionListener(this);
        Exo_Lim.addActionListener(this);
        Exo_Nombre_Derive.addActionListener(this);
        Exo_Tangente.addActionListener(this);
        
        //Panneau principal
        Affichage = new JPanel();
        Affichage.setBorder(new LineBorder(new Color(255,0, 0)));
        Affichage.setBackground(new Color(0, 0, 0));
        Affichage.setLayout(null);
        Hauteur=Hauteur-11;
        Power=new BarreDiff(Largeur);
        Content.setLayout(new BorderLayout());
        Content.add("North",Power);
        Content.add("Center",Affichage);
        Hauteur=Hauteur-25;
        PremierZoom=true;
	}
	public void actionPerformed(ActionEvent arg0) 
	{
		SansSingleton=false;Doucement=false;Doux=0;
		if (!Principal.IsThread)
		{	
		if (arg0.getSource()==Auteur)	{LancerAuteur();}
		if (!Evaluation)
		{
			NbreQuestVariation=0;NbreQuestImage=0;NbreQuestAnt=0;NbreQuestEqu=0;NbreQuestIneq=0;NbreQuestDroite=0;
			ErrImage=0;ErrIneq=0;ErrVariation=0;ErrEqu=0;ErrDroite=0;note=0f;
			EnsDef=false;Apprentissage=false;
			if (arg0.getSource()==Help)	{LancerAide("Aide.html");}
			if (arg0.getSource()==Licence)	{License();}
			if (arg0.getSource()==Exo_Antecedents) 
			{	Evaluation=false;Erreur=0;NbQuestion=0;ErreurQuestion=0;Exo_Ant=true;
			Difficulte=0;Exo_Ant();Preums=true;} // Preums=true <=> pas ens vide ds le dpart !
			if (arg0.getSource()==Exo_Equation) 
			{	Evaluation=false;Erreur=0;NbQuestion=0;ErreurQuestion=0;Exo_Ant=false;
			Difficulte=0;Exo_Ant();Preums=true;}
			if (arg0.getSource()==Exo_Images) 
			{	Evaluation=false;Difficulte=0;Exo_Image();}
			if (arg0.getSource()==Exo_InEquation) 
			{	Evaluation=false;UneBorne=true;Erreur=0;NbQuestion=0;ErreurQuestion=0;
			Difficulte=0;Exo_Inequation();}
			if (arg0.getSource()==Exo_InEquationApprentissage) 
			{	Evaluation=false;UneBorne=true;Erreur=0;NbQuestion=0;ErreurQuestion=0;
			Difficulte=0;Apprentissage=true;Exo_Inequation();}
			if (arg0.getSource()==Exo_InEquationSansG) 
			{	Evaluation=false;UneBorne=true;Erreur=0;NbQuestion=0;ErreurQuestion=0;
			Difficulte=0;SansSingleton=true;Exo_Inequation();}
			if (arg0.getSource()==Exo_DoubleInEquation) 
			{	Evaluation=false;UneBorne=false;Erreur=0;NbQuestion=0;ErreurQuestion=0;
			Difficulte=0;Exo_Inequation();}
			if (arg0.getSource()==Exo_Def) 
			{	Lim=false;Evaluation=false;Difficulte=0;EnsembleDefintion();}
			if (arg0.getSource()==Exo_Defc) 
			{	Lim=false;Evaluation=false;Difficulte=1;EnsembleDefintion();}
			if (arg0.getSource()==Exo_Lim) 
			{	Lim=true;Evaluation=false;Difficulte=1;EnsembleDefintion();}
			if (arg0.getSource()==Exo_variation) 
			{	Evaluation=false;Difficulte=0;TableauVariation();}
			if (arg0.getSource()==Exo_variation2) 
			{	Evaluation=false;Difficulte=0;TableauVariation2();}
			if (arg0.getSource()==DCoef) 
			{	Tangente=false;OrdAOrigine=false;BloqCoef=false;Evaluation=false;Difficulte=0;DroiteDE(2);}
			if (arg0.getSource()==CoefD) 
			{	Tangente=false;OrdAOrigine=false;BloqCoef=true;Evaluation=false;Difficulte=0;DroiteDE(1);}
			if (arg0.getSource()==EquD) 
			{	Tangente=false;OrdAOrigine=true;BloqCoef=true;Evaluation=false;Difficulte=0;DroiteDE(3);}
			if (arg0.getSource()==DEqu) 
			{	Tangente=false;OrdAOrigine=true;BloqCoef=false;Evaluation=false;Difficulte=0;DroiteDE(4);}
			if (arg0.getSource()==Exo_Tangente) {Tangente=true;Evaluation=false;Difficulte=0;DroiteDE(4);}
			if (arg0.getSource()==Exo_Nombre_Derive) {Tangente=true;Evaluation=false;Difficulte=0;DroiteDE(2);}
			//Evaluation
			if (arg0.getSource()==EvalImaAnt)	{EvaluationImageAntecedent();}
			if (arg0.getSource()==EvalIneq)	{EvaluationIneq();}
			if (arg0.getSource()==EvalVariation){EvaluationVariation();}
			if (arg0.getSource()==EvalDroite){EvaluationDroite();}
			if (arg0.getSource()==Eval_Derive){EvaluationDerive();}
			if (arg0.getSource()==EvalSeconde){EvaluationSeconde();}
			if (arg0.getSource()==EvalPremS){EvaluationPS();}
			if (arg0.getSource()==EvalPremSTG){SansSingleton=true;EvaluationSTG();}
			if (arg0.getSource()==EvalPremL){SansSingleton=true;EvaluationL();}
			if (arg0.getSource()==ChoixDuRepertoire)	{RepertoireDeSauvegarde();}
			if (arg0.getSource()==HelpEval)	{HelpEvaluation();}
		}
		else {Information("Votre valuation n'est pas termine.");}
		}
	}
	public void License()
	{
		Presentation("LICENCE.html",580,240);
	}
	public void RepertoirCourant()
	{
		File file=new File("");
		Path=file.getAbsolutePath();
	}
	public void RepertoireDeSauvegarde()
	{
		Affichage.removeAll();
		
		String[] choisir = {"oui", "non", "Je ne comprends pas"};
		int reponse = JOptionPane.showOptionDialog(this,"Etes-vous sre de vouloir modifier le rpertoire de sauvegarde ?","Soyez prudent.",JOptionPane.YES_NO_CANCEL_OPTION,JOptionPane.WARNING_MESSAGE,null,choisir,choisir[2]);
		if (reponse == JOptionPane.YES_OPTION)
		{
			JFileChooser choix = new JFileChooser("."); // rpertoire courant
			choix.setApproveButtonText("Rpertoire de sauvegarde");
			choix.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY); // Que les rpertoires
			int rVal=choix.showOpenDialog(this);
			if (rVal == JFileChooser.APPROVE_OPTION)
			{Path = choix.getSelectedFile().getAbsolutePath();}
		}
		else
		{
			if (reponse != JOptionPane.NO_OPTION) 
			{JOptionPane.showMessageDialog(this, "Les rsultats des valuations sont sauvegards sous la forme\n" +
					"d'un fichier texte (\"Nom de l'lve.txt\").\n\n" +
					"Par dfaut, le rpertoire de sauvegarde est celui du logiciel.\n" +
					"Vous pouvez le changer en utilisant cet item.","Information",JOptionPane.INFORMATION_MESSAGE);}
		}
		Affichage.repaint();
	}
	public void HelpEvaluation()
	{	String Reponse;
		Reponse = JOptionPane.showInputDialog(this, "Pour accder aux valuations,\n" +
				"il faut tre professeur de mathmatiques.\n" +
				"Si c'est le cas, vous serez\nqu'un groupe ablien est un groupe");
		if (Reponse!=null) 
		{	
			if (Reponse.equalsIgnoreCase("COMMUTATIF")) 
			{
				LancerAide("AideEval.html");
			}
			else {Information("Allez travailler !");}
		}
	}
	public void LancerAide(String Fichier)
	{
		MaFenAide Fen=new MaFenAide(Fichier);
		Fen.setSize(Largeur,Hauteur+35);
		Fen.setVisible(true);
	}
	public void LancerAuteur()
	{
		Information("M. DROUOT Patrick,\nprofesseur de mathmatiques\ndans l'acadmie d'Amiens.","info");
	}
	public void Information(String Ph)
	{
		JOptionPane.showMessageDialog(this, Ph,"Information",JOptionPane.INFORMATION_MESSAGE);
	}
	public void Information(String Ph,String Titre)
	{
		JOptionPane.showMessageDialog(this, Ph,Titre,JOptionPane.INFORMATION_MESSAGE);
	}
	public void Congratulation(String Ph,String Titre)
	{
		JOptionPane.showMessageDialog(this, Ph,Titre,JOptionPane.INFORMATION_MESSAGE,Toto);
	}
	public void Error(String Ph)
	{
		JOptionPane.showMessageDialog(this, Ph,"Erreur",JOptionPane.ERROR_MESSAGE,Triste);
	}
	public void Avertissement(String Ph)
	{
		JOptionPane.showMessageDialog(this, Ph,"Respectez les rgles de saisie",JOptionPane.INFORMATION_MESSAGE,Attention);
	}
	public boolean YourNamePlease()
	{	boolean retour=true;
		boolean recommence=true;
		while (recommence)
		{
			Nom = JOptionPane.showInputDialog(this, "Quel est votre nom ?");
			recommence=false;
			if (Nom==null) {retour=false;}
			else
				{
				if (Nom.length()>20) {recommence=true;}
				else
				{
					String P=Nom.toUpperCase();
					for (int i=0;i<P.length();i++)
					{
						if ((P.charAt(i)<'0') | (P.charAt(i)>'9'))
							{if ((P.charAt(i)<'A') |(P.charAt(i)>'Z') ) {recommence=true;}}
					}
				}
				}
		}
		return (retour);
	}
	public void calcul_bilan()
	{	
		for (int i=0;i<NbResult;i++)	{Resultat[i]="";}
		Bilan=NomEvaluation+"\n\n";
	
		if (NbreQuestImage!=0) {Resultat[0]="Images :"+Arrondir((float)(NbreQuestImage-ErrImage)/(float)NbreQuestImage*100f)+"%";}
		if (NbreQuestAnt!=0) {Resultat[1]="Antcdents :"+Arrondir((float)(NbreQuestAnt-ErrAnt)/(float)NbreQuestAnt*100f)+"%";}
		if (NbreQuestEqu!=0) {Resultat[2]="Equations :"+Arrondir((float)(NbreQuestEqu-ErrEqu)/(float)NbreQuestEqu*100f)+"%";}
		if (NbreQuestIneq!=0) {Resultat[3]="Inquations :"+Arrondir(((float)NbreQuestIneq-ErrIneq)/(float)NbreQuestIneq*100f)+"%";}
		if (NbreQuestVariation!=0) {Resultat[4]="Tableaux de variations :"+Arrondir(((float)NbreQuestVariation-ErrVariation)/(float)NbreQuestVariation*100f)+"%";}
		if (NbreQuestDroite!=0) {Resultat[5]="Droites :"+Arrondir(((float)NbreQuestDroite-ErrDroite)/(float)NbreQuestDroite*100f)+"%";}
		if (NbreQuestTangente!=0) {Resultat[6]="Nombres drivs - Tangentes :"+Arrondir(((float)NbreQuestTangente-ErrTangente)/(float)NbreQuestTangente*100f)+"%";}
		//note=Arrondir((double)note/(double)(NbreQuestImage+NbreQuestAnt+NbreQuestEqu+NbreQuestIneq)*20d);
		note=Arrondir((double)note/(double)(NbreQuestImage+NbreQuestAnt+NbreQuestEqu+NbreQuestIneq+NbreQuestVariation+NbreQuestDroite+NbreQuestTangente)*20d);
		for (int i=0;i<NbResult;i++)
		{
			if (Resultat[i].length()!=0) Bilan=Bilan+Resultat[i]+"\n";
		}
		Bilan=Bilan+"\n\n"+"Note :"+note+"/20";
	}
	public void Save()
	{
		File f = new File(Path+File.separator+Nom+".txt");// suivant le systme de fichier
		try 
		{
			DateFormat formateurFr= DateFormat.getDateTimeInstance(DateFormat.FULL,DateFormat.FULL,Locale.FRENCH);
			String dateFr = formateurFr.format(new Date());
			
			FileWriter writer = new FileWriter(f,true); // ajoute  la fin du fichier courant.
			BufferedWriter fichier= new BufferedWriter(writer);
			fichier.newLine();fichier.write("************************************************************************");fichier.newLine();
			
			fichier.write("Pourcentage de rusite des objectifs de "+Nom+" :");fichier.newLine();
			fichier.write(dateFr);fichier.newLine();
			fichier.write("************************************************************************");fichier.newLine();
			fichier.newLine();
			fichier.write(NomEvaluation);fichier.newLine();fichier.newLine();
			for (int i=0;i<NbResult;i++)
			{
				if (Resultat[i].length()!=0) {fichier.write(Resultat[i]);fichier.newLine();}
			}
			fichier.newLine();
			fichier.write("Note :"+note+"/20");
			fichier.close();
		}
		catch(IOException e) 
		{
			e.printStackTrace();
		}
	}
	public void EvaluationVariation()
	{
		if (YourNamePlease())
		{
			NomEvaluation="Evaluation: tableaux de variation";
			Evaluation=true;PasDernierEval=false;
			EvalIter=0;
			EvalExo=new int[40];
			int Exo[]={8,0,9,0,8,1,9,1,8,0,8,2,8,1,9,2,0};
			for (int i=0;i<Exo.length;i++) {EvalExo[i]=Exo[i];}
			ToutAZero();
			Chronos Montre=new Chronos(Power,15,0);
			Montre.start();
			Eval();
		}
	}
	public void EvaluationImageAntecedent() // seconde
	{
		if (YourNamePlease())
		{
			NomEvaluation="Evaluation Seconde: Images, antcdents";
			Evaluation=true;PasDernierEval=false;
			EvalIter=0;
			EvalExo=new int[40];
			int Exo[]={1,4,1,1,3,1,3,2,5,2,3,0,1,1,3,2,5,0,1,5,3,1,5,3,3,3,5,0,3,2,0}; // 7 images - 11 ant - 11 equ 
			for (int i=0;i<Exo.length;i++) {EvalExo[i]=Exo[i];}
			ToutAZero();
			Chronos Montre=new Chronos(Power,16,0);
			Montre.start();
			Eval();
		}
	}
	public void EvaluationIneq() //Seconde Images-antcdents-equation-Inquations
	{
		if (YourNamePlease())
		{
			NomEvaluation="Evaluation seconde: Images, antcdents, quations, inquations";
			Evaluation=true;PasDernierEval=false;
			EvalIter=0;
			EvalExo=new int[40];
			int Exo[]={1,1,3,2,3,0,1,1,5,1,5,3,5,0,3,2,6,1,3,4,6,2,6,0,1,5,2,6,1,7,1,3,0,0};
			for (int i=0;i<Exo.length;i++) {EvalExo[i]=Exo[i];}
			ToutAZero();
			Chronos Montre=new Chronos(Power,23,0);
			Montre.start();
			Eval();
		}
	}
	public void EvaluationSeconde() // Seconde Synthse
	{
		if (YourNamePlease())
		{
			NomEvaluation="Evaluation gnrale seconde";
			Evaluation=true;PasDernierEval=false;
			EvalIter=0;
			EvalExo=new int[36];
			int Exo1[]={1,3,2,5,1,6,0,5,3,9,0,1,3,0,6,2,8,1,5,2,1,7,1,9,2,5,0,2,3,1,6,2,0};
			int Exo2[]={5,1,1,3,2,6,0,5,3,9,0,3,0,1,6,2,8,1,5,2,1,7,1,9,2,5,0,2,3,1,6,2,0};
			if (Math.random()<0.5d) {for (int i=0;i<Exo1.length;i++) {EvalExo[i]=Exo1[i];}}
			else {for (int i=0;i<Exo2.length;i++) {EvalExo[i]=Exo2[i];}}
			ToutAZero();
			Chronos Montre=new Chronos(Power,30,0);
			Montre.start();
			Eval();
		}
	}
	public void EvaluationPS()
	{
		if (YourNamePlease())
		{
			NomEvaluation="Evaluation premire S";
			Evaluation=true;PasDernierEval=false;
			EvalIter=0;
			EvalExo=new int[36];
			int Exo1[]={3,3,1,5,2,6,1,7,1,3,0,5,4,6,3,7,3,9,2,5,0,7,2,8,3,3,5,1,0};
			int Exo2[]={1,5,2,3,3,6,1,7,1,1,3,0,5,4,6,3,7,3,9,2,5,0,8,3,7,2,3,5,0};
			if (Math.random()<0.5d) {for (int i=0;i<Exo1.length;i++) {EvalExo[i]=Exo1[i];}}
			else {for (int i=0;i<Exo2.length;i++) {EvalExo[i]=Exo2[i];}}
			ToutAZero();
			Chronos Montre=new Chronos(Power,25,0);
			Montre.start();
			Eval();
		}
	}
	public void EvaluationSTG() //teste
	{
		NomEvaluation="Evaluation premire STG";
		if (YourNamePlease())
		{
			Evaluation=true;PasDernierEval=false;
			EvalIter=0;
			EvalExo=new int[30];
			int Exo1[]={1,3,2,1,5,0,6,1,5,3,3,1,1,8,1,9,0,1,6,1,5,1,0};
			int Exo2[]={1,5,0,1,3,2,6,1,5,3,3,1,9,0,1,8,1,1,5,1,6,1,0};
			if (Math.random()<0.5d) {for (int i=0;i<Exo1.length;i++) {EvalExo[i]=Exo1[i];}}
			else {for (int i=0;i<Exo2.length;i++) {EvalExo[i]=Exo2[i];}}
			ToutAZero();
			Chronos Montre=new Chronos(Power,20,0);
			Montre.start();
			Eval();
		}
	}
	public void EvaluationL() // teste
	{
		if (YourNamePlease())
		{
			NomEvaluation="Evaluation premire L";
			Evaluation=true;PasDernierEval=false;
			EvalIter=0;
			EvalExo=new int[30];
			int Exo1[]={8,0,5,2,1,3,2,1,5,0,6,1,5,3,3,1,6,2,1,8,1,9,1,1,0};
			int Exo2[]={1,8,0,3,2,5,2,1,5,0,6,1,5,3,3,1,6,2,1,9,1,1,8,1,0};
			if (Math.random()<0.5d) {for (int i=0;i<Exo1.length;i++) {EvalExo[i]=Exo1[i];}}
			else {for (int i=0;i<Exo2.length;i++) {EvalExo[i]=Exo2[i];}}
			ToutAZero();
			Chronos Montre=new Chronos(Power,22,0);
			Montre.start();
			Eval();
		}
	}
	public void EvaluationDroite() 
	{
		NomEvaluation="Evaluation quations de droites";
		if (YourNamePlease())
		{
			Evaluation=true;PasDernierEval=false;
			EvalIter=0;
			EvalExo=new int[40];
			int Exo[]={10,2,2,10,1,2,10,3,2,10,3,2,10,3,4,10,3,4,10,3,4,10,4,2,10,4,2,10,4,4,10,4,4,10,4,4,0};
			for (int i=0;i<Exo.length;i++) {EvalExo[i]=Exo[i];}
			ToutAZero();
			Chronos Montre=new Chronos(Power,20,0);
			Montre.start();
			Eval();
		}
	}
	public void EvaluationDerive()
	{
		NomEvaluation="Evaluation nombres drivs et tangentes";
		if (YourNamePlease())
		{
			Evaluation=true;PasDernierEval=false;
			EvalIter=0;
			EvalExo=new int[40];
			int Exo[]={11,1,11,2,11,3,11,4,11,4,12,2,11,4,11,4,12,3,12,4,12,4,11,3,12,4,0};
			for (int i=0;i<Exo.length;i++) {EvalExo[i]=Exo[i];}
			ToutAZero();
			Chronos Montre=new Chronos(Power,20,0);
			Montre.start();
			Eval();
		}
	}
	public void ToutAZero()
	{
		note=0d;
		NbreQuestDroite=0;ErrDroite=0;
		NbreQuestImage=0;NbreQuestAnt=0;NbreQuestEqu=0;NbreQuestIneq=0;
		NbreQuestVariation=0;ErrVariation=0;
		ErrImage=0;ErrAnt=0;ErrEqu=0;ErrIneq=0f;
		ErrTangente=0;NbreQuestTangente=0;
	}
	/*
	 * EvalExo: 0 <-> Stop ; 1 <-> Image ou f(2)=... ; 2 <-> Antcdent ; 3 <-> Antcdents + choix du nb d'antcdents ;
	 * 4 <-> Equation ; 5 <-> Equation+choix du nb de solutions ;6 <-> Inquation simple+choix difficult;7 <-> Double inquations+choix difficult
	 * 9 <-> Tableau de variations-Courbe+choix difficult 8 <-> Courbe-Tableau de variations+choix difficult
	 * 10 (type d'exos)(Difficult) Droite
	 *        type exos=1 => Cstruire droite connaissant coef
	 *        type exos=2 => Donner le coef
	 *        type exos=3 =>Cstruire droite
	 *        type exos=4 => Donner eq. 
	 *  11 <-> nombre Driv (Difficult) - 12 <-> Tangente (Difficult)
	 */
	public void CasNul()
	{
		StopChronos=true;
		Affichage.removeAll();Affichage.repaint();
		Evaluation=false;AvecAnt=false;
		calcul_bilan();
		DialogueResultat Dial=new DialogueResultat((Principal) o,Largeur/2,Hauteur/2,Bilan);
		Dial.setLocation(Largeur/4,Hauteur/4);Dial.show();
		Save();
	}
	public void  Eval()
	{ 
		ExoInequation=false;Tangente=false;
		ErreurQuestion=0;
		Passe=false;
		if (EvalIter==0) 
		{
			PasDernierEval=true;
		}
		if (StopChronos)
		{
			while ((EvalExo[EvalIter]!=0))
			{
				switch (EvalExo[EvalIter])
				{
				case 0:CasNul();break;
				case 1:NbreQuestImage++;ErrImage++;break;
				case 2:NbreQuestAnt++;ErrAnt++;break;
				case 3:
					EvalIter++;NbAntEval=EvalExo[EvalIter];Difficulte=Math.max(NbAntEval,1);
					NbreQuestAnt=NbreQuestAnt+Difficulte;ErrAnt=ErrAnt+Difficulte;
					break;
				case 4:NbreQuestEqu++;ErrEqu++;break;
				case 5:
					EvalIter++;NbAntEval=EvalExo[EvalIter];Difficulte=Math.max(NbAntEval,1);
					NbreQuestEqu=NbreQuestEqu+Difficulte;ErrEqu=ErrEqu+Difficulte;
					break;
				case 6:
					EvalIter++;NbAntEval=EvalExo[EvalIter];Difficulte=Math.max(NbAntEval,1);
					NbreQuestIneq=NbreQuestIneq+Difficulte;ErrIneq=ErrIneq+Difficulte;
					break;
				case 7:
					EvalIter++;NbAntEval=EvalExo[EvalIter];Difficulte=Math.max(NbAntEval,1);
					NbreQuestIneq=NbreQuestIneq+Difficulte;ErrIneq=ErrIneq+Difficulte;
					break;
				case 8:
					EvalIter++;Difficulte=EvalExo[EvalIter]+2;NbreQuestVariation=NbreQuestVariation+Difficulte;ErrVariation=ErrVariation+Difficulte;
					break;
				case 9:
					EvalIter++;Difficulte=EvalExo[EvalIter]+2;NbreQuestVariation=NbreQuestVariation+Difficulte;ErrVariation=ErrVariation+Difficulte;
					break;
				case 10:
					EvalIter++;
					if (EvalExo[EvalIter]>2) {NbreQuestDroite=NbreQuestDroite+2;ErrDroite=ErrDroite+2;} else {NbreQuestDroite++;ErrDroite++;}
					EvalIter++;
					break;
				case 11:
					EvalIter++;
					if (EvalExo[EvalIter]>2) {NbreQuestTangente++;ErrTangente++;}
					break;
				case 12:
					EvalIter++;
					if (EvalExo[EvalIter]>2) {NbreQuestTangente=NbreQuestTangente+2;ErrTangente=ErrTangente+2;}
					break;
				}
				EvalIter++;
			}
			CasNul();
			Power.ChronoFin=false;
			EvalIter=0;
		}
		else
		{
			switch (EvalExo[EvalIter])
			{
			case 0: // STOP
				CasNul();
				break;
			case 1:
				Difficulte=0;Exo_Image();
				break;
			case 2:
				Exo_Ant=true;Difficulte=1;Exo_Ant();
				break;
			case 3:
				Exo_Ant=true;AvecAnt=true;EvalIter++;NbAntEval=EvalExo[EvalIter];Difficulte=Math.max(NbAntEval,1);Exo_Ant();
				break;
			case 4:
				Exo_Ant=false;Difficulte=1;Exo_Ant();
				break;
			case 5:
				Exo_Ant=false;AvecAnt=true;
				EvalIter++;NbAntEval=EvalExo[EvalIter];Difficulte=Math.max(NbAntEval,1);Exo_Ant();
				break;
			case 6:
				UneBorne=true;AvecIneq=true;ExoInequation=true;
				EvalIter++;NbIneqEval=EvalExo[EvalIter];Difficulte=NbIneqEval;Exo_Inequation();
				break;
			case 7:
				UneBorne=false;AvecIneq=true;ExoInequation=true;
				EvalIter++;NbIneqEval=EvalExo[EvalIter];Difficulte=NbIneqEval;Exo_Inequation();
				break;
			case 8:
				EvalIter++;Difficulte=EvalExo[EvalIter];TableauVariation2();
				break;
			case 9:
				EvalIter++;Difficulte=EvalExo[EvalIter];TableauVariation();
				break;
			case 10:
				EvalIter++;int type=EvalExo[EvalIter];EvalIter++;Difficulte=EvalExo[EvalIter];
				if (type<=2) OrdAOrigine=false; else OrdAOrigine=true;
				if (type==2 |type==4) BloqCoef=false; else BloqCoef=true;
				DroiteDE(type);
				break;
			case 11:
				EvalIter++;Difficulte=EvalExo[EvalIter];Tangente=true;DroiteDE(2);
				break;
			case 12:
				EvalIter++;Difficulte=EvalExo[EvalIter];Tangente=true;DroiteDE(4);
				break;
			}
		}
		
		EvalIter++;
		if (EvalExo[EvalIter]==0) {PasDernierEval=false;} 
	}
	public void AugmenteDifficulte()
	{
		if (Doucement)
		{
			if (Doux==1)
			{
				Difficulte++;
			}
			Doux=1-Doux;
		}
		else Difficulte++;
		Difficulte=Math.min(Difficulte,DiffMax);
	}
	public void Encouragement()
	{
		String Ph,Titre;
		Titre="Rponse juste";Ph="Bien, Continuons";
		if (!Evaluation && Aide) {Ph="Ressayer sans utiliser l'aide.";Aide=false;}
		else
		{
			switch (ErreurQuestion)
			{
				case 0: 
					if (Apprentissage) {Ph="Bonne rponse.";} 
					else 
					{
						Ph="Excellent, vous passez au niveau de difficult suprieur !";
						if (Doucement && Doux!=1) 
							{
							if (Difficulte<3) Ph="Trs bien,\nvous vous rapprochez du niveau de difficult suprieur !";
							else Ph="Trs bien,\nsi vous me redonnez une bonne rponse du premier coup,\nalors vous passerez au niveau de difficult suprieur !";
							}
						AugmenteDifficulte();
					}
					if (Evaluation) {Ph="Excellente rponse";}
					Titre="Flicitation";
					break;
				case 1:
					if (Difficulte>0) {Ph="Trs bien";}
					if (Difficulte<3) 
					{
						if ((Doux==1) || (!Doucement)) Ph="Bien, vous passez au niveau de difficult suprieur !";
						AugmenteDifficulte();
					}
					break;
				case 2: break;
				default: Ph="Vous commencez  comprendre.";if (Difficulte!=0) {Difficulte--;}
			}
		}
		
		if (Evaluation) 
		{
			if (PasDernierEval) {Ph=Ph+"\nOn continue avec un nouvel exercice.";}
		}
		if ((!Evaluation) && (Difficulte==DiffMax))
		{
			MaCourbe.Bulle=true;
		}
		Congratulation(Ph,Titre);
	}
	public void Exo_Inequation()
	{		
		Affichage.removeAll();
		Creation_Objets_Inequation();
		Initialise_Inequation();	
		if (Apprentissage) {Power.Barre(0);Power.repaint();} else {Power.Barre(Difficulte);Power.repaint();}
		Recom=true;ErreurQuestion=0;
		ErrCrochet=0f;Crochet=false;	
		MesInequations.Reponse.requestFocus();
		
		MesInequations.Aide.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e) 
    	{
			if (!Evaluation) 
			{
				if (Difficulte<4)
				{
					boolean i1,i2;i1=Inegalite1;i2=Inegalite2;
					Inegalite1=true;Inegalite2=true;
					InequationSolution();
					Inegalite1=i1;Inegalite2=i2;
					MaCourbe.Correct_Intervalle=false;
					Correction_Inequation();
					
					MaCourbe.CompteurPoint=0;
					for (int i=0;i<NbPoints;i++)
					{
						if ((Point[i][1]==borne1) | (Point[i][1]==borne2)) 
							{MaCourbe.PixelPointX[MaCourbe.CompteurPoint]=MaCourbe.Absc(Point[i][0]);MaCourbe.CompteurPoint++;}
					}
					InequationSolution();
				}
				Aide=true;
				MaCourbe.borne1=borne1;MaCourbe.borne2=borne2;MaCourbe.AfficheBarreIneq=true;AideIneq(MesInequations);
				MesInequations.repaint();				
				MaCourbe.repaint();
			}
    	}});
		
		MesInequations.Valider.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e) 
    	{
		if (MaCourbe.Correct_Intervalle | PasSolIneq) {RecommenceIneq();} 
		else	
			{	
			Rep=MesInequations.Reponse.getText();
			if (Rep.length()==0) 
			{
				String Ph="Si vous pensez que l'inquation n'a pas de solution,\n"+"utilisez la touche \"S=\u2205 \".";
				Information(Ph);
			}
			else
			{
				if (NbInter==0) 
				{
					if (Evaluation) {ErreurQuestion++;RecommenceIneq();}
					MaCourbe.borne1=borne1;MaCourbe.borne2=borne2;
					MaCourbe.AfficheBarreIneq=true;
					PasSolIneq=true;
					Affichage.repaint();
					String Phr="Cette inquation n'a pas de solution: S=\u2205.\n";
					if (borne1==sup) {Phr=Phr+"La courbe est en dessous de la droite y="+sup;}
						else {Phr=Phr+"La courbe est au dessus de la droite y="+inf;}
					Error(Phr);
					ErreurQuestion++;
					MesInequations.Valider.setText("Recommencer");
					MesInequations.Aucune_Reponse.setEnabled(false);
				}
				else
				{
					if (Lave())
					{	
						if (ConvertirString())
						{
							if (NbInterS>1) {OrdonnerIntervalles();} // Classe les InterS dans l'ordre croissant
							if (VerifieCoherence()) //vrifie si il n'y a pas par ex: [2;3[U{3}
							{
								if (ChercheErreurs()) 
								{							
									Encouragement();
									RecommenceIneq();Recom=false;
								}
								else
									{	if (Crochet) {Crochet=false;} else {ErreurQuestion++;}
									if (!((Evaluation) && ((float)(NbInter-ErreurQuestion)-ErrCrochet)<=0.01f))
									{
										if (ErreurQuestion==2 && !Apprentissage && (!MaCourbe.AfficheBarreIneq)) 
										{
											Information("Pour vous aidez, j'affiche les bornes de l'ingalit.","Indication");
											MaCourbe.borne1=borne1;MaCourbe.borne2=borne2;
											MaCourbe.AfficheBarreIneq=true;
										}
									}
									MesInequations.AfficheBoutonCorrection();
									Affichage.repaint();
									}
							}
						}
					}
				}
			}
		} 
		if (Recom && (Evaluation) && ((float)(NbInter-ErreurQuestion)-ErrCrochet)<=0.01f) {RecommenceIneq();}
		Recom=true;
    	}});
		MesInequations.BouttonCorrection.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e) 
    	{
			if (Evaluation) {Passe=true;ErreurQuestion=NbInter;RecommenceIneq();}
			else
			{	
				MaCourbe.borne1=borne1;MaCourbe.borne2=borne2;
				MaCourbe.AfficheBarreIneq=true;
				
				MesInequations.BouttonCorrection.setEnabled(false);			
				MaCourbe.Correct_Intervalle=true;
				Correction_Inequation();// Dessine les intervalles sur les axes !
				MesInequations.Reponse.setText("La solution est: "+Sol);MesInequations.Reponse.setEditable(false);
				MesInequations.Valider.setText("Recommencer");
				MesInequations.Aide.setVisible(false);
				MaCourbe.repaint();
			}

			
    	}});
		MesInequations.Aucune_Reponse.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e) 
    	{	
			if (NbInter!=0)
			{
				double cx;
				if (Inter[0].Point()) {cx=Inter[0].X();} else {cx=(Inter[0].X()+Inter[0].Y())/2;}
				Error("Non cette inquation a des solutions.\nPar exemple :\n     "+EnonceIneq(" f("+Arrondir(cx)+")="+Arrondir3(MaCourbe.Fonction(cx))+" "));
				MesInequations.Aucune_Reponse.setEnabled(false);
				Affichage.repaint();
				ErreurQuestion++;
			}
			else
			{
				Congratulation("Bien, continuons","Rponse Juste");
				RecommenceIneq();
			}
    	}});
		Affichage.repaint();
	}
	public void RecommenceIneq()
	{
		MaCourbe.NbTriche=0;MesInequations.Reponse.setEditable(true);
		if (!Apprentissage) {Power.Barre(Difficulte);Power.repaint();}
		if (Evaluation)
		{
			if (NbInter==0) {NbInter=1;}
			NbreQuestIneq=NbreQuestIneq+NbInter;
			ErrIneq=ErrIneq+(float)Math.min(NbInter,ErreurQuestion)+ErrCrochet;
			if (!Passe) {note=note+Math.max((float)NbInter-ErreurQuestion-ErrCrochet,0);}
			Eval();
		}
		else
		{
			ErreurQuestion=0;Erreur=Erreur+ErreurQuestion;
			MesInequations.Reponse.setText("");
			MaCourbe.Correct_Ineq=false;MaCourbe.Correct_Intervalle=false;
			MaCourbe.AfficheBarreIneq=false;
			Initialise_Inequation();
			Affichage.repaint();
		}
		MesInequations.T1.setVisible(false);MesInequations.T2.setVisible(false);MesInequations.T3.setVisible(false);
		MesInequations.Puce1(false);MesInequations.Puce2(false);
		MesInequations.TailleBoutonAide();
	}
	public boolean ChercheErreurs() // compare Inter et InsterS
	{
		boolean InterOk[]={false,false,false,false,false,false,false,false};
		int i=0;
		boolean PasErr=true;
		boolean Bornes=false;
		boolean Contenu=false;
		while (i<NbInterS && PasErr)
		{
			if (InterS[i].Point())
			{	
				PasErr=false;
				for (int j=0;j<NbInter;j++)
				{
					if (Inter[j].Point() && Egal(Inter[j].X(),InterS[i].X())) {PasErr=true;InterOk[j]=true;}	
				}
			}
			else
			{// InterS[i] est un intervalle
				PasErr=false;
				for (int j=0;j<NbInter;j++)
				{
					if (!Inter[j].Point())
					{
						
						if (Egal(Inter[j].X(),InterS[i].X()) && Egal(Inter[j].Y(),InterS[i].Y()))
						{// mme extrmits
							if ((Inter[j].OuvertaG()!=InterS[i].OuvertaG()) | (Inter[j].OuvertaD()!=InterS[i].OuvertaD())) {Bornes=true;j=NbInter;}
							else {PasErr=true;InterOk[j]=true;j=NbInter;}
						}
						else
						{
							if ((Inter[j].X()<=InterS[i].X()) && (Inter[j].Y()>=InterS[i].Y())) {Contenu=true;j=NbInter;}
						}
					}
				}
				
			}
			i++;
		}
		if (!PasErr) 
		{
			if (Bornes) 
			{	
				if (!((ExoInequation) && (Evaluation) && ((float)(NbInter-ErreurQuestion)-ErrCrochet)<0.6f))
				{
					Error("Corrigez les crochets de l'intervalle "+guil+Ecrire(InterS[i-1])+guil);
				}
				ErrCrochet=ErrCrochet+0.5f;Crochet=true;
			}
			if (Contenu)
			{
				String Ph="la solution.";
				if (EnsDef) Ph="l'ensemble de dfintion.";
				Error("L'intervalle "+guil+Ecrire(InterS[i-1])+guil+" est contenu dans "+Ph);
			}
			if (!Bornes && !Contenu && (EnsDef))
			{
				Error("Ce n'est pas l'ensemble de dfinition\nde la fonction f.");
			}
			if (!Bornes && !Contenu && (!EnsDef))
			{	
				String Ph="";
				boolean plouf=false;
				double cx=InterS[i-1].Y();
				for (int it=0;it<2;it++)
				{	if (!MaCourbe.DomaineDef(cx)) 
					{
						if ((plouf) && (cx!=InterS[i-1].Y())) {Ph=Ph+" ni en "+cx;} else {Ph="La fonction f n'est pas dfinie en "+cx;}
						plouf=true;
					}
					cx=InterS[i-1].X();
				}			
				if (plouf) {Error(Ph);}
				else
				{		
					if (InterS[i-1].Point())
					{
						plouf=false;
						if ((ArrondirFonction(InterS[i-1].X())<borne2) && (borne1<ArrondirFonction(InterS[i-1].X()))) {plouf=true;}
						else
						{
							if (Egal4(MaCourbe.Fonction(InterS[i-1].X()),borne2) && (!Inegalite2)) {plouf=true;}
							if (Egal4(MaCourbe.Fonction(InterS[i-1].X()),borne1) && (!Inegalite1)) {plouf=true;}
						}
						if (plouf) {Error(InterS[i-1].X()+" appartient  un intervalle contenu dans l'ensemble des solutions.\n\nAutrement dit,\n"+
								"L'ensemble des solutions contient "+guil+Ecrire(InterS[i-1])+guil+" et beaucoup de ses proches voisins !");}
						else 
						{
							if (ArrondirFonction(InterS[i-1].X())>borne2) {Error(borne2+" < f("+Arrondir(InterS[i-1].X())+") = "+Arrondir3(MaCourbe.Fonction(InterS[i-1].X())));}
							if (Egal4(MaCourbe.Fonction(InterS[i-1].X()),borne2)) {Error("f("+Arrondir(InterS[i-1].X())+") = "+borne2);}
							if (ArrondirFonction(InterS[i-1].X())<borne1) {Error("f("+Arrondir(InterS[i-1].X())+") = "+Arrondir3(MaCourbe.Fonction(InterS[i-1].X()))+" < "+borne1);}
							if (Egal4(MaCourbe.Fonction(InterS[i-1].X()),borne1)) {Error("f("+Arrondir(InterS[i-1].X())+") = "+borne1);}
						}
						
					}
					else
					{
						cx=InterS[i-1].X();
						plouf=true;
						boolean Find=false;
						while (plouf)
						{
							double y=ArrondirFonction(cx);
							if (y>borne2) 
							{
								Ph=borne2+" < f("+Arrondir(cx)+") = "+y;plouf=false;Find=true;
							}
							if (y<borne1) 
							{
								Ph="f("+Arrondir(cx)+") = "+y+" < "+borne1;plouf=false;Find=true;
							}
							if (cx<InterS[i-1].Y()) {cx=Math.min(cx+0.1d,InterS[i-1].Y());}
							else {plouf=false;}
							
						}
						if (Find) {Error(guil+Ecrire(InterS[i-1])+guil+" est faux.\nPar exemple :\n   "+Ph);}
						else 
						{
					
							// vrifie si pas ce type d'erreurs: [a,b[U]b,c]=[a,c]
							boolean singulier=false;
							for (int v=0;v<NbInter-1;v++)
							{
								if (!Inter[v].point)
								{
									if (Inter[v].OuvertaD() && Inter[v+1].OuvertaG())
									{
										if (Egal(Inter[v].Y(),Inter[v+1].X())) // [a,b[U]b,c]
										{
											if (Egal(InterS[i-1].X(),Inter[v].X()) && Egal(InterS[i-1].Y(),Inter[v+1].Y()))
											{
												String Phr="f("+Arrondir(Inter[v].Y())+") = "+Arrondir3(MaCourbe.Fonction(Inter[v].Y()));
												if (InterS[i-1].OuvertaG()==Inter[v].OuvertaG() && InterS[i-1].OuvertaD()==Inter[v+1].OuvertaD())
												{
													singulier=true;
													Error(guil+Ecrire(InterS[i-1])+guil+" a juste un nombre en trop !\n"+Phr+"\n\ndonc\nIl faut le dcouper en deux intervalles ne contenant pas "+Arrondir(Inter[v].Y()));
													break;	
												}
												else
												{
													singulier=true;
													String Phr2="";
													if (InterS[i-1].OuvertaG()!=Inter[v].OuvertaG()) {Phr2="a son crochet gauche de faux.";}
													if (InterS[i-1].OuvertaD()!=Inter[v+1].OuvertaD()) {Phr2="a son crochet droit de faux.";}
													if ((InterS[i-1].OuvertaG()!=Inter[v].OuvertaG()) && (InterS[i-1].OuvertaD()!=Inter[v+1].OuvertaD()))
													{
														Phr2="a ses deux crochets de faux.";
													}
													Error("L'intervalle "+guil+Ecrire(InterS[i-1])+guil+" "+Phr2+"\n\net en plus, "+Phr+" donc\nIl faut le dcouper en deux intervalles ne contenant pas "+Arrondir(Inter[v].Y()));
													break;
												}
												
											}
										}
										
									}
									
								}
							}
							if (!singulier) Error(guil+Ecrire(InterS[i-1])+guil+" est faux.");
							
						}
					}
				}
			}
		}
		else
		{
			
			for (int j=0;j<NbInter;j++)	{PasErr=PasErr && InterOk[j];}
			if (!PasErr) {Error("C'est bien, mais il en manque.");}
			else 
			{
				if (NbInterS>NbInter) {Error("Vous en fates un peu trop !");}
			}
		}
		return(PasErr);
	}
	public boolean Egal(double a,double b)
	{
		boolean Eg;
		Eg=(Math.abs(Arrondir(a)-Arrondir(b))<0.09d); // mme chiffre des diximes
		return (Eg);
	}
	public boolean EgaliteLarge(double a,double b)
	{
		return (Math.abs(Arrondir(a)-Arrondir(b))<0.11d); // mme chiffre des diximes	
	}
	public boolean Egalite(double a,double b)
	{
		return (Math.abs(a-b)<0.09d); // mme chiffre des diximes	
	}
	public boolean Egal4(double a,double b)
	{
		boolean Eg;
		Eg=(Math.abs(a-b)<0.0001d);
		return (Eg);
	}
	public String Ecrire(Intervalle I)
	{
		String Ph="";
		if (I.Point()) {Ph=Ph+"{"+Double.toString(I.X())+"}";}
		else
		{
			if (I.OuvertaG()) {Ph=Ph+"]";} else {Ph=Ph+"[";}
			Ph=Ph+Double.toString(I.X())+" , "+Double.toString(I.Y());
			if (I.OuvertaD()) {Ph=Ph+"[";} else {Ph=Ph+"]";}
		}
		return (Ph);
	}
	public boolean VerifieCoherence() // vrifie si il n'y a pas par ex: [2;3[U{3}
	{
		boolean Continue=true;
		for (int i=0;i<(NbInterS-1);i++)
		{
			if (InterS[i].Point())
			{
				if ((!InterS[i+1].Point()) && (InterS[i].X()==InterS[i+1].X())) 
				{// {a}U[a;b]
					Continue=false;
					String w=Ecrire(InterS[i+1]);InterS[i+1].X(false);
					MsgErr2(Ecrire(InterS[i])+"\u22C3"+w+" = "+Ecrire(InterS[i+1]));
				}
			}
			else
			{
				if (InterS[i+1].Point())
				{
					if  (InterS[i].Y()==InterS[i+1].X()) 
					{// [a;b]U{b}
						Continue=false;
						String w=Ecrire(InterS[i]);InterS[i].Y(false);
						MsgErr2(w+"\u22C3"+Ecrire(InterS[i+1])+" = "+Ecrire(InterS[i]));
					}
				}
				else
				{
					// Deux intervalles
					if ((InterS[i].Y()==InterS[i+1].X()) && ((!InterS[i].OuvertaD()) | (!InterS[i+1].OuvertaG())))
					{//[a;b]U[b;c]
						Intervalle I=new Intervalle(InterS[i].X(),InterS[i+1].Y());
						I.OuvertG=InterS[i].OuvertaG();I.OuvertG=InterS[i+1].OuvertaD();
						MsgErr2(Ecrire(InterS[i])+"\u22C3"+Ecrire(InterS[i+1])+" = "+Ecrire(I));
						Continue=false;
					}
				}
			}	
		}
		return (Continue);
	}
	public void OrdonnerIntervalles()
	{
		int Min;
		for (int i=0;i<(NbInterS-1);i++)
		{
			Min=i;
			for (int j=i+1;(j<(NbInterS));j++)
			{
				if (InterS[Min].X()>InterS[j].X()) {Min=j;}
			}
			if (Min!=i) Echanger(i,Min);
		}
	}
	public void Echanger(int i,int j)
	{
		double d,g; 
		boolean OuvertG,OuvertD,point;
		g=InterS[i].g;d=InterS[i].d;
		OuvertG=InterS[i].OuvertG;OuvertD=InterS[i].OuvertD;
		point=InterS[i].point;
		
		InterS[i].g=InterS[j].g;InterS[i].d=InterS[j].d;
		InterS[i].OuvertG=InterS[j].OuvertG;InterS[i].OuvertD=InterS[j].OuvertD;
		InterS[i].point=InterS[j].point;
		
		InterS[j].g=g;InterS[j].d=d;
		InterS[j].OuvertG=OuvertG;InterS[j].OuvertD=OuvertD;
		InterS[j].point=point;
	}
	public boolean Lave() // retire les espaces, transforme , en ; puis verifie les symboles
	{
		boolean Continue=true;
		char[] carac = { '-','0' , '1' , '2' , '3' , '4' , '5', '6' , '7' , '8' , '9' , '.', ';' , 'U', '[' , ']' , '{' , '}'};
		boolean k=true;
		char err;
		Rep=Rep.replaceAll(",",";");
		Rep=Rep.replaceAll("u","U");
		if (EnsDef) MesDef.Reponse.setText(Rep); else MesInequations.Reponse.setText(Rep);
		Rep=Rep.replaceAll(" ","");
		if (Rep=="") {Continue=false;}
		else
		{
			for (int i=0;i<Rep.length();i++)
			{
				k=true;
				for (int j=0;j<18;j++)
				{
					if (Rep.charAt(i)==carac[j]) {k=false;}
				}
				if (k) 
				{
					err=Rep.charAt(i);i=Rep.length();Continue=false;
					Avertissement("Vous ne pouvez pas utiliser le symbole "+guil+err+guil+".");
				}
			}
		}
		if ((Rep.charAt(0)<='9') && (Rep.charAt(0)>='0')) {Continue=false;Avertissement("Les singletons (nombres isols) s'crivent entre accolades.");}
		else
//			******** vrifie les intervalles
		{
			for (int i=0;i<Rep.length();i++)
			{
				if (Rep.charAt(i)=='[' | Rep.charAt(i)==']')
				{
					int nbVirg=0;
					String Ph="";
					boolean cont=true;
					while (cont)
					{
						Ph=Ph+Rep.charAt(i);
						i++;
						if (i>=Rep.length()) {cont=false;} 
						else 
						{
							cont=(Rep.charAt(i)!='[' && Rep.charAt(i)!=']');
							if (Rep.charAt(i)==';') {nbVirg++;}
						}
					}
					if (i<Rep.length()) 
					{
						Ph=Ph+Rep.charAt(i);
						if (nbVirg>1) {Continue=false;Avertissement("Il y a "+(nbVirg+1)+" extrmits dans l'intervalle " +Ph+
						".\nUtilisez le point du pav numrique pour saisir les virgules des nombres dcimaux." +
						"\nLa virgule et le point virgule sont rservs pour sparer les extrmits des intervalles.");}
						if (nbVirg==0) {Continue=false;Avertissement("Il n'y a pas deux nombres dans l'intervalle "+Ph+"\n\nSi vous voulez crire un nombre isol (singleton),\nil faut l'crire entre accolades.");}
						if ((nbVirg==1) && (Rep.charAt(i-1)==';')) {Continue=false;Avertissement("Il manque au moins une extrmit  l'intervalle "+Ph+" !");}
					}
					else
					{
						Continue=false;Avertissement("Il manque un crochet  l'intervalle "+Ph+" .");
					}
				}
			}
//				******** vrifie les accolades
			if (Continue)
			{
				for (int i=0;i<Rep.length();i++)
				{
					if (Rep.charAt(i)=='}') {Continue=false;Avertissement("Il manque \"{\".");i=Rep.length();}
					else
					{
						if (Rep.charAt(i)=='{')
						{
							int nbVirg=0;
							String Ph="";
							if (i<(Rep.length()-1)) {if (Rep.charAt(i+1)=='-') {Ph="{";i++;}}
							boolean cont=true;
							while (cont)
							{
								Ph=Ph+Rep.charAt(i);
								i++;
								if (i>=Rep.length()) {cont=false;} 
								else
								{
									cont=(Rep.charAt(i)<='9' && Rep.charAt(i)>='0');
									if (Rep.charAt(i)=='.') {cont=true;nbVirg++;}
					
								}
							}
							if (i<Rep.length()) 
								{if ((Rep.charAt(i)!='}') | (nbVirg>1)) {Continue=false;Error("Il y a une erreur dans "+Ph+" .");i=Rep.length();}}
							else {Continue=false;Avertissement("Il manque une accolade dans "+Ph+" .");i=Rep.length();}
						}	
					}
				}
			}
		}
		return (Continue);
	}
	
	public boolean ConvertirString()
	{
		NbInterS=0;
		double Ext;
		boolean PasErr=true;
		while ((Rep.length()>0) && PasErr)
		{
			switch (Rep.charAt(0))
			{
			case '{':
				Retire();
				if (RecupereNb()) 
				{
					if (Rep.charAt(0)=='}') {Retire();InterS[NbInterS]=new Intervalle(Extremite);NbInterS++;}
					else {PasErr=false;}
				}
				else {PasErr=false;}
				break;
			case 'U':
				Retire();
				if ((Rep.charAt(0)!='[') && (Rep.charAt(0)!=']') && (Rep.charAt(0)!='{')) {PasErr=false;}
				break;
			case '[':
				Retire();
				if (RecupereNb()) 
				{	Ext=Extremite;
					if (Rep.charAt(0)==';') 
					{
						Retire();
						if (RecupereNb()) 
						{
							if ((Rep.charAt(0)!='[') && (Rep.charAt(0)!=']')) {PasErr=false;}
							else
							{
								if (Ext>=Extremite) {PasErr=false;MsgErr(Double.toString(Ext)+"<"+Double.toString(Extremite));}
								else
								{
									InterS[NbInterS]=new Intervalle(Ext,Extremite);
									InterS[NbInterS].X(false); // ferm  gauche
									if (Rep.charAt(0)=='[') {InterS[NbInterS].Y(true);} else {InterS[NbInterS].Y(false);}
									Retire();
									NbInterS++;
								}
							}
							
						}
						else {PasErr=false;}
					}
					else {PasErr=false;}
				}
				else {PasErr=false;}
				break;
			case ']':
				Retire();
				if (RecupereNb()) 
				{	Ext=Extremite;
					if (Rep.charAt(0)==';') 
					{
						Retire();
						if (RecupereNb()) 
						{
							if ((Rep.charAt(0)!='[') && (Rep.charAt(0)!=']')) {PasErr=false;}
							else
							{
								if (Ext>=Extremite) {PasErr=false;MsgErr(Double.toString(Ext)+"<"+Double.toString(Extremite));}
								else
								{
									InterS[NbInterS]=new Intervalle(Ext,Extremite);
									InterS[NbInterS].X(true); // ouvert  gauche
									if (Rep.charAt(0)=='[') {InterS[NbInterS].Y(true);} else {InterS[NbInterS].Y(false);}
									Retire();
									NbInterS++;
								}
							}	
						}
						else {PasErr=false;}
					}
					else {PasErr=false;}
				}
				else {PasErr=false;}
				break;
			default:
				PasErr=false;
			}
		}
		return(PasErr);
	}
	public void MsgErr(String Ph)
	{
		JOptionPane.showMessageDialog(this, "Dois-je comprendre que "+guil+Ph+guil+" ?","Intervalle incohrent",JOptionPane.ERROR_MESSAGE);
	}
	public void MsgErr2(String Ph)
	{
		JOptionPane.showMessageDialog(this, Ph,"Simplifiez votre criture",JOptionPane.ERROR_MESSAGE);
	}
	public void Retire () {Rep=Rep.substring(1,Rep.length());} // retire le premier char
	public boolean RecupereNb() // sortie: Extremite=Nb et Nb effac de Rep
	{
		int i=0;
		int virgule=0;
		boolean Continue=true;
		boolean PasErr=true;
		
		if (Rep.charAt(0)=='-') {i=1;}
		while (Continue)
		{
			while (EstCeChiffre(i)) {i++;} // verifie aussi si i n'est pas trop grand.
		
			if (i==Rep.length()) {Continue=false;i--;}
			else
			{
				if (Rep.charAt(i)=='.') {virgule++;i++;} else {Continue=false;i--;}
				if (virgule==2) {Continue=false;PasErr=false;}
			}
		}
		
		Continue=true;
		if (PasErr) 
		{
			String Mot=Rep.substring(0,i+1);
			{
				try {Extremite=new Double (Mot).doubleValue();}
				catch (NumberFormatException ex) {PasErr=false;}
			}
			if (PasErr) 
			{
				if ((i+1)>=Rep.length()) {Rep="";} else {Rep=Rep.substring(i+1,Rep.length());}
			}
		}
		if (!PasErr) 
		{
			Continue=false;
			Error("Je ne comprends pas "+guil+Rep.substring(0,i+1)+guil+".");
		} 
		return(Continue);
	}
	public boolean EstCeChiffre(int i)
	{
		char[] carac = { '0' , '1' , '2' , '3' , '4' , '5', '6' , '7' , '8' , '9' };
		boolean Continue=false;
		if (i<Rep.length()) {for (int j=0;j<10;j++){if (Rep.charAt(i)==carac[j]) {Continue=true;}}}
		return (Continue);
	}
	
	public void Initialise_Inequation()
	{	
			Aide=false;
			if (Apprentissage) {Difficulte=1;AvecIneq=true;NbIneqEval=1;} // une seul seule solution
			FabriqIneq();
			if (SansSingleton)
			{
				boolean cont=true;
				while (cont)
				{
					cont=false;
					for (int i=0;i<NbInter;i++)
					{
						if (Inter[i].Point()) {cont=true;}
					}
					if (cont) {FabriqIneq();}
				}
			}
			if (Apprentissage)
				{while (Inter[0].Point() | ((Inter[0].X()==Point[0][0]) && (Inter[0].Y()==Point[NbPoints-1][0]))) {FabriqIneq();}} // la solution doit-tre un intervalle diffrent de Df.
		
		AvecIneq=false;
		
		
		
		MaCourbe.ChangeCourbe(xmin,xmax,ymin,ymax,Point,NbPoints);
		MesInequations.Enonce.setText(Ineq);
		MesInequations.Valider.setText("Valider votre rponse");
		MesInequations.Aucune_Reponse.setEnabled(true);
		MesInequations.Aucune_Reponse.setEnabled(true);
		MesInequations.BouttonCorrection.setEnabled(true);
		if (Evaluation) {MesInequations.BouttonCorrection.setText("Je passe la question et je perds les points");MesInequations.BouttonCorrection.setVisible(true);}
		else {MesInequations.BouttonCorrection.setVisible(false);MesInequations.Aide.setVisible(true);}
		
		int v=0;
		for (int i=0;i<NbInter;i++)
		{
			if (Inter[i].Point())
			{
				MaCourbe.Triche[v][0]=(float) Arrondir(Inter[i].X());
				MaCourbe.Triche[v][1]=(float) MaCourbe.Fonction(Inter[i].X());v++;
			}
			else
			{
				MaCourbe.Triche[v][0]=(float) Arrondir(Inter[i].X()); //0.1d
				MaCourbe.Triche[v][1]=(float) Arrondir3(MaCourbe.Fonction((Inter[i].X())));v++; //0.0001d
				MaCourbe.Triche[v][0]=(float) Arrondir(Inter[i].Y());
				MaCourbe.Triche[v][1]=(float) Arrondir3(MaCourbe.Fonction((Inter[i].Y())));v++;
				
			}
		}
		MaCourbe.NbTriche=v;
		if (Apprentissage)
		{
			MaCourbe.borne1=borne1;MaCourbe.borne2=borne2;
			MaCourbe.AfficheBarreIneq=true;
		}		
	}
	public void FabriqIneq()
	{
		int cpte=0;
		NbInter=NbIneqEval+1; // si (AvecIneq) alors NbIneqEval est le nb d'intervalles ou singletons solutions
		while (NbInter!=NbIneqEval)
		{
			PasSolIneq=false;
			Exo_Inequation_Calculs();
			InequationSolution();
			if (!AvecIneq) {NbIneqEval=NbInter;}
			cpte++;
			if (cpte>5) {Difficulte=Math.min(Difficulte+1,DiffMax);}
		}
	}
	public void Creation_Objets_Inequation()
	{
		HauteurCourbe=(int) (Hauteur/2);LargeurCourbe=Largeur-30;
		MaCourbe=new PanneauCourbe(10,10,LargeurCourbe,HauteurCourbe);
        Affichage.add(MaCourbe);
        MesInequations=new DialogueInequation(10,HauteurCourbe+20,LargeurCourbe,HauteurCourbe-60);
        Affichage.add(MesInequations);
	}
	public void Correction_Inequation()
	{			
		MaCourbe.Curseur=Point[NbPoints-1][0];
		MaCourbe.CurseurPixel=MaCourbe.Absc(MaCourbe.Curseur);
		MaCourbe.CursX=MaCourbe.CurseurPixel;
		MaCourbe.CompteurInter=0;
		MaCourbe.CompteurPoint=0;
		for (int i=0;i<NbInter;i++)	{MaCourbe.PixelisationIntervalle(Inter[i]);}
		MaCourbe.Correct_Ineq=true;
	}
	public void Exo_Inequation_Calculs()
	{
		boolean recomence=true;
		while (recomence)
		{
			Exo_Inequation_Calculs2();
			recomence=false;
			for (int i=1;i<NbPoints;i++)
			{
				if (Math.abs((Point[i][1]-Point[i-1][1])/(Point[i][0]-Point[i-1][0]))<0.2d) {recomence=true;}
			}
			recomence=(recomence | VoitonCourbeExtremite());
		}
	}
	public void Exo_Inequation_Calculs2()
	{
		int position=0;
		int ancposition;
		int ecart;
		GraduationHasard();  // Calculs xmin,...,ymax
		NbPoints=Math.min(8+Difficulte,NbGraduationsAbscisses);
		PointHasard();
        NbAnt=Math.min((int)(Math.random()*(double)(Difficulte+1)),(NbPoints/2));
        NbAnt=Math.min((Difficulte+1),(NbPoints/2));
        if (NbAnt==0) {NbAnt=1;}
        if (NbAnt>8) {NbAnt=8;};
        sup=Arrondir(Math.random()*(double)(ymax-ymin-3)+(double)(ymin+3));
        inf=Arrondir(Math.random()*(sup-(double)ymin-2d)+(double)(ymin));
                
		double quot=(double)NbPoints/(double)NbAnt; //	
		CompteurIndice=0;
		for (int i=0;i<NbAnt;i++)
		{
			
			ecart=(int) (Math.random()*(((double)(i-position))*quot));
			if (ecart<2) {ecart=2;}
			ancposition=position;
			position=position+ecart;
			Indice[CompteurIndice]=position;CompteurIndice++;
			if (Math.random()<0.5d) {Point[position][1]=sup;} else {Point[position][1]=inf;}
			if (i==0) 
			{
				if (Math.random()<0.2d) {for (int j=0;j<position;j++) {Point[j][1]=inf+Math.random()*(sup-inf-1d)+0.5d;}}
				else 
				{
					if (Point[position][1]==sup) {for (int j=0;j<position;j++){Point[j][1]=sup+1d+Math.random()*((double)ymax-sup);}}
					else {for (int j=0;j<position;j++){Point[j][1]=inf-1d-(Math.random()*Math.abs(inf-(double)ymin));}}
				}
			}
			
			if (i!=0)
			{	for (int j=ancposition+1;j<position;j++){Point[j][1]=inf+Math.random()*(sup-inf-1d)+0.5d;}
			
				if ((Point[position][1]==sup) && (Point[ancposition][1]==sup) && (Math.random()<0.9d) && (sup<((double)ymax-0.6d)))
				{
				for (int j=ancposition+1;j<position;j++){Point[j][1]=sup+1d+Math.random()*((double)ymax-sup);}
				}
				if ((Point[position][1]==inf) && (Point[ancposition][1]==inf) && (Math.random()<0.9d) && (inf>((double)ymin+0.6d)))
				{
				for (int j=ancposition+1;j<position;j++){Point[j][1]=inf-1d-(Math.random()*(inf-(double)ymin));}
				}
			}
		}
		
		for (int j=position+1;j<NbPoints;j++) {Point[j][1]=inf+Math.random()*(sup-inf-1d)+0.5d;}
		if (Math.random()<0.5d) {Inegalite1=true;} else {Inegalite1=false;}
		if (Math.random()<0.5d) {Inegalite2=true;} else {Inegalite2=false;}
		
		// Construction de l'nonc
		borne1=inf;borne2=sup;
		
		if (UneBorne) 
		{
			if (Math.random()<0.5d) 
			{
				borne1=-1024d;
				if (Math.random()<0.3d) {borne2=inf;}
				if (Point[0][1]<=ymin) {Point[0][1]=(inf+ymin)/2;}
				if (Point[NbPoints][1]<=ymin) {Point[NbPoints][1]=(inf+ymin)/2;}
			} 
			else 
			{
				borne2=1024d;
				if (Math.random()<0.3d) {borne1=sup;}
				if (Point[0][1]>=ymax) {Point[0][1]=(sup+ymax)/2;}
				if (Point[NbPoints][1]>=ymax) {Point[NbPoints][1]=(sup+ymax)/2;}
			}
			
		}
		Ineq=EnonceIneq(" f(x) ");
	}
	public String EnonceIneq(String f)
	{
		String Ph;
		Ph=Double.toString(borne1);
		if (borne1!=-1024d) {if (Inegalite1) {Ph=Ph+" <";} else {Ph=Ph+" \u2264";}} //<=
		else Ph="";
		Ph=Ph+f;
		if (borne2!=1024d) 
		{
			if (Inegalite2) {Ph=Ph+"< ";} else {Ph=Ph+"\u2264 ";}
			Ph=Ph+Double.toString(borne2);
		}
		return(Ph);
	}
	public void AideIneq(DialogueInequation Obj)
	{
		JLabel J;
		Obj.Aide.setVisible(false);
		Obj.T1.setVisible(true);
		
		J=Obj.T2;
		if (Math.abs(borne1)!=1024d) 
		{
			if (Inegalite1) J.setText("au dessus de la droite marron d'quation y = "+Double.toString(borne1)+" (droite exclue)");
				else J.setText("au dessus de la droite marron d'quation y = "+Double.toString(borne1)+" (droite comprise)");
			J.setVisible(true);
			J=Obj.T3;
		}
		
		if (Math.abs(borne2)!=1024d) 
		{
			if (Inegalite2) J.setText("en dessous de la droite violette d'quation y = "+Double.toString(borne2)+" (droite exclue).");
				else J.setText("en dessous de la droite violette d'quation y = "+Double.toString(borne2)+" (droite comprise).");
			J.setVisible(true);
		}
		Obj.Puce1(true);if (!UneBorne) Obj.Puce2(true);
		
	}
	public void InequationSolution()
	{
		int j,k,l;
		NbInter=0;
		
		for (int i=0;i<NbPoints;i++)
		{
			if (SuisJeDedans(i))
			{
				k=i-1;if (i==0) {k=0;}
				l=i+1;if (i==(NbPoints-1)) {l=i;}
				if (SuisJeDedansFerme(k) | SuisJeDedansFerme(l))
				{// intervalle
					
					if (SuisJeDedansFerme(k)) {j=k;} else {j=i;}
					
					while (SuisJeDedans(i) && (i<NbPoints)) {i++;}
					if ((i==NbPoints) | (!SuisJeDedansFerme(i))) {i--;}
					Inter[NbInter]=new Intervalle(Point[j][0],Point[i][0]);
					
					// ouvert ou ferm
					if (Point[j][1]==borne1) {Inter[NbInter].X(Inegalite1);}
					else
					{
						if (Point[j][1]==borne2) {Inter[NbInter].X(Inegalite2);}
						else {Inter[NbInter].X(false);}
					}
					if (Point[i][1]==borne1) {Inter[NbInter].Y(Inegalite1);}
					else
					{
						if (Point[i][1]==borne2) {Inter[NbInter].Y(Inegalite2);}
						else {Inter[NbInter].Y(false);}
					}
				}
				else
				{// point isol
					Inter[NbInter]=new Intervalle(Point[i][0]);
				}
				NbInter++;
			}
		}
		// correction d'un bug des intervalles [x,x] sont apparus
		for (int i=0;i<NbInter;i++)
		{
			if ((!Inter[i].Point()) && (Inter[i].X()==Inter[i].Y())) {Inter[i].point=true;}
		}
		Solution();
	}
	public void Solution()
	{
		Sol="";
		for (int i=0;i<NbInter;i++)
		{
			if (Inter[i].Point()) {Sol=Sol+"{"+Double.toString(Inter[i].X())+"}";}
			else
			{
				if (Inter[i].OuvertaG()) {Sol=Sol+"]";} else {Sol=Sol+"[";}
				Sol=Sol+Double.toString(Inter[i].X())+" , "+Double.toString(Inter[i].Y());
				if (Inter[i].OuvertaD()) {Sol=Sol+"[";} else {Sol=Sol+"]";}
			}
			if (i!=(NbInter-1)) {Sol=Sol+" \u22C3 ";}
		}
	}
	public boolean SuisJeDedans(int i)
	{
		boolean reponse;
		reponse=SuisJeDedansFerme(i);
		if ((borne1==Point[i][1]) && Inegalite1) {reponse=false;}
		if ((borne2==Point[i][1]) && Inegalite2) {reponse=false;}
		return(reponse);
	}
	public boolean SuisJeDedansFerme(int i)
	{
		boolean reponse=false;
		if ((borne1<=Point[i][1]) && (Point[i][1]<=borne2)) {reponse=true;}
		return(reponse);
	}
	
	
	public double Arrondir(double nb) {return ((double)Math.round(nb*10))/10d;}
	public double Arrondir3(double nb) {return ((double)Math.round(nb*1000))/1000d;}
	public double ArrondirFonction(double x) 
	{
		//double retour=((double)Math.round(MaCourbe.Fonction(x)*10000))/10000d;
		double retour=MaCourbe.Fonction(x);
		for (int v=0;v<MaCourbe.NbTriche;v++)
		{
			if ((float) Arrondir(x)==MaCourbe.Triche[v][0]) 
					{retour=(double) MaCourbe.Triche[v][1];}
		}
		
		
		return Arrondir3(retour);
	}
	public void Exo_Image()
	{	
		Affichage.removeAll();
		Creation_Objets_Images();
		Initialise_Images();
		Power.Barre(Difficulte);Power.repaint();
		MesImages.Reponse.requestFocus();
		MesImages.Valider.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e) 
    	{
			double Rep;
			try {Rep=new Double (MesImages.Reponse.getText()).doubleValue();}
			catch (NumberFormatException ex) {MesImages.Reponse.setText("");Rep=1024d;}
			if (Math.abs(Image-Rep)<0.102d) 
			{// Bonne rponse
				Congratulation("Vous avez raison.","Bonne rponse");
				ErreurQuestion=0;
			}
			else
			{// Erreur
				ErreurQuestion=1;
				String Ph;
				if (Phrase) {Ph="L'image de "+Double.toString(Anteced)+" est "+Double.toString(Image);}
				else {Ph="f("+Double.toString(Anteced)+") = "+Double.toString(Image);}
				Ph=Ph+". Regarder le graphique.";
				MaCourbe.Curseur=Anteced;Affichage.repaint();
				Difficulte=Math.max(Difficulte-1,0);
				Power.Barre(Difficulte);Power.repaint();
				Error(Ph);
				if (Evaluation) {Information("On continue avec un nouvel exercice.","Avertissement");}
			}
			if (Evaluation) 
			{
				NbreQuestImage++;
				ErrImage=ErrImage+ErreurQuestion;
				if (ErreurQuestion==0) {note++;}
				ErreurQuestion=0;
				Eval();
			}
			else
			{
				MesImages.Reponse.setText("");
				Initialise_Images();Affichage.repaint();	
			}
			
    	}});
		Affichage.repaint();
	}
	public void Initialise_Images()
	{
		
		
		Anteced=Exo_Images_Calculs();Image=Ant;
		MaCourbe.ChangeCourbe(xmin,xmax,ymin,ymax,Point,NbPoints);
		MaCourbe.NbTriche=0;
		if (Math.random()>0.5d) {Phrase=true;} else {Phrase=false;} // crit f(2)= ou image de 2 par ...
		String Ph="f("+Anteced+") ="; if (Phrase) {Ph="L'image de "+Anteced+" par f est ";}
		MesImages.ChangeEnonce(Ph);
	}
	public void Creation_Objets_Images()
	{
		HauteurCourbe=(int) (Hauteur/2);LargeurCourbe=Largeur-30;
		MaCourbe=new PanneauCourbe(10,10,LargeurCourbe,HauteurCourbe);
        Affichage.add(MaCourbe);
        MesImages=new DialogueImages(10,HauteurCourbe+20,LargeurCourbe,HauteurCourbe-100);
        Affichage.add(MesImages);
	}
	public double Exo_Images_Calculs()
	{
		GraduationHasard();
        NbPoints=Math.min(8+Difficulte,NbGraduationsAbscisses);
        NbAnt=Math.min((int)(Math.random()*5d),(NbPoints/2));
        if (NbAnt==0) {NbAnt=1;}
        if (NbAnt>8) {NbAnt=8;}
        Ant=Math.random()*(double)(ymax-ymin)+(double)ymin;
        if (Ant<(double)(ymin+1)) {Ant++;}
        if (Ant>(double)(ymax-1)) {Ant--;}
        //Ant=((double)Math.round(Ant*10))/10d;
        Ant=Arrondir(Ant);
        Antecedent(Ant,NbAnt);
        return xAnt[(int) (Math.random()*(double)NbAnt)];
	}
	
	public boolean VoitonCourbe()
	{
		boolean rep=true;
		for (int i=0;i<NbPoints;i++)
		{
			rep=rep && ((Point[i][1]<=ymin) | (Point[i][1]>=ymax));
		}
		return(rep);
	}
	public boolean VoitonCourbeExtremite()
	{
		return (((Point[0][1]<=ymin) | (Point[0][1]>=ymax)) | ((Point[NbPoints-1][1]<=ymin) | (Point[NbPoints-1][1]>=ymax)));
	}
	// Antcdents & Equations
	public void Exo_Ant()
	{	Affichage.removeAll(); // se libre de tous les panneaux
	
		Difficulte=4;
	
		ErreurQuestion=0;CorrectionAnt=false;
		Power.Barre(Difficulte);Power.repaint();
		Exo_Ant_Calculs();
		Creation_Objets_Ant();
        MaCourbe.ChangeCourbe(xmin,xmax,ymin,ymax,Point,NbPoints);
        Triche();
        
        if (!Evaluation)
		{
        	if (Exo_Ant) {Presentation("PresentationAnt.html",580,240);}
        	else {Presentation("PresentationEqu.html",580,240);}
		}
        
        if (Evaluation)
        {
        	MesAntecedents.Correction.setText("Je passe la question et je perds les points");
        }
        MesAntecedents.Correction.setVisible(true);
        MesAntecedents.LesAnt.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e)
        		{if (NbAnt!=0)
        		{
        			MesAntecedents.PasAnt.setVisible(false);
            		MesAntecedents.LesAnt.setEnabled(false);
            		//MesAntecedents.Texte.setText("Saisissez tous les antcdents (un antcdent par case).");
            		MesAntecedents.Texte.setVisible(true);
            		for (int i=0;i<8;i++) {MesAntecedents.Reponse[i].setVisible(true);}
            		MesAntecedents.Terminer.setVisible(true); // On lance l'interface de saisie des antcdents
        		}
        		else 
        		{
        			MesAntecedents.LesAnt.setVisible(false);
            		MesAntecedents.PasAnt.setVisible(false);
            		MaCourbe.BarrePasAnt=true;
            		if (!Evaluation) {Correction();}
        			
        			
        			String Ph;
        			if (Exo_Ant) {Ph="Le nombre "+Double.toString(Ant)+" n'a pas d'antcdent.";} 
        				else {Ph="L'quation f(x)="+Double.toString(Ant)+" n'a pas de solution.";}
        			Error(Ph);
        			Dialogue_Ant_Non_Visible();
        			if (Evaluation) {ErreurQuestion=1;} //***Evaluation***
    				Ant_Fin();
    				Erreur++;
        		}
        		}});;
        MesAntecedents.Terminer.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e)
        {
        			double Rep[]=new double[8];
        			int BonnesRep;
        			int RienC=0;
        			for (int i=0;i<8;i++) 
        			{
        				try {Rep[i]=new Double (MesAntecedents.Reponse[i].getText()).doubleValue();}
        				catch (NumberFormatException ex) {MesAntecedents.Reponse[i].setText("");Rep[i]=1024d;RienC++;} // Efface le texte qui ne correspond pas  un double
        			}
        			if (RienC==8)
        				{
        					BonnesRep=0;
        					Avertissement("Je ne comprends pas.\nVous devez saisir des nombres.");
        				}
        			else
        			{
        				BonnesRep=VerifieAnt(Rep);
            			if (BonnesRep<NbAnt) 
            			{
            				ErreurQuestion=ErreurQuestion+(NbAnt-BonnesRep);
            				if (BonnesRep==0) {Info="Tout est faux ! Indication: ";}
            				else
            				{
            					if (BonnesRep==1) {if (Exo_Ant) {Info="Vous avez trouv un antcdent. Mais il en manque ";} else {Info="Vous avez trouv une solution. Mais il en manque ";}}
            					else {if (Exo_Ant) {Info="Vous avez trouv "+Integer.toString(BonnesRep)+" antcdents. Mais il en manque ";} else {Info="Vous avez trouv "+Integer.toString(BonnesRep)+" solutions. Mais il en manque ";}}
            				}
            				if ((Difficulte<4) && (BonnesRep!=0)) {Info=Info+Integer.toString((NbAnt-BonnesRep))+". Continuez";}
            				if (BonnesRep==0) 
            				{
            					if (NbAnt==1) 
            					{
            						if (Exo_Ant) {Info=Info+"Il y a un antcdent.";} else {Info=Info+"Il y a une solution.";}
            					}
            					else
            					{
            						Info=Info+"Il y a "+Integer.toString(NbAnt);
            						if (Exo_Ant) {Info=Info+" antcdents.";} else {Info=Info+" solutions.";}
            					}
            				}
            				MesAntecedents.Texte.setText(Info);
            				if (!Evaluation) {MesAntecedents.Correction.setVisible(true);} // ***Si pas valuation ***
            				else 
            				{
            					if (ErreurQuestion>=NbAnt) {Ant_Fin();}
            				}
            			}
            			else
            			{
            				// Aucune erreur
            				Encouragement();
            				Dialogue_Ant_Non_Visible();
            				Ant_Fin();
            			}
        			}
        }});;
        MesAntecedents.PasAnt.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e) 
        	{
        	if (NbAnt==0) 
        	{	if (Difficulte<=1) {Difficulte++;}
        		Congratulation("Vous avez raison.","Bonne rponse");
        		Ant_Fin();
        	}
        	else
        	{
        		String Ph="Non, il y a "+Integer.toString(NbAnt);
        		
        		if (Exo_Ant) {Ph=Ph+" antcdent";} else {Ph=Ph+" solution";}
        		if (NbAnt>1) {Ph=Ph+"s.";}
        		Error(Ph);ErreurQuestion++;
        		if ((Evaluation) && (ErreurQuestion>=NbAnt)) {Ant_Fin();}
        		else
        			{
            			MesAntecedents.PasAnt.setVisible(false);
                		MesAntecedents.LesAnt.setEnabled(false);
                		MesAntecedents.Texte.setVisible(true);
                		for (int i=0;i<8;i++) {MesAntecedents.Reponse[i].setVisible(true);}
                		MesAntecedents.Terminer.setVisible(true);
            		}
        	}
        	}});
        MesAntecedents.Correction.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e) 
    	{
    	//NbAnt!=0
        	if (CorrectionAnt)
        	{
        		if (!Principal.IsThread)
        		{
        			MaCourbe.Correct_Ant=false;
            		MesAntecedents.LesAnt.setVisible(true);
            		MesAntecedents.PasAnt.setVisible(true);
            		MesAntecedents.Texte.setVisible(false);
            		Ant_Fin();
        		}
        	}
        	else
        	{
        		if (Evaluation) {ErreurQuestion=999;Ant_Fin();} //***Evaluation***
            	else
            	{
            		Dialogue_Ant_Non_Visible();MesAntecedents.Correction.setVisible(true);
            		MesAntecedents.LesAnt.setVisible(false);
            		MesAntecedents.PasAnt.setVisible(false);
            		MaCourbe.BarrePasAnt=false;
            		Correction();CorrectionAnt=true;
            	       	
            		String Ph;
            		switch(NbAnt)
            		{
            			case 0:
            				if (Exo_Ant) {Ph="Le nombre "+Double.toString(Ant)+" n'a pas d'antcdent.";}
                			else {Ph="L'quation f(x)="+Double.toString(Ant)+" n'a pas de solution.";}
            				break;
            			case 1:
            				if (Exo_Ant) {Ph="Le nombre "+Double.toString(Ant)+" n'a qu'un antcdent: "+Double.toString(xAnt[0]);}
                			else {Ph="L'quation f(x)="+Double.toString(Ant)+" n'a qu'une solution: "+Double.toString(xAnt[0]);}
            				break;
            			default:
            				if (Exo_Ant) {Ph="Le nombre ";} else {Ph="L'quation f(x)=";}
            			Ph=Ph+Double.toString(Ant)+" a "+Integer.toString(NbAnt);
            		
            			if (Exo_Ant) {Ph=Ph+" antcdents: ";} else {Ph=Ph+" solutions: ";}
            			for (int i=0;i<NbAnt-1;i++) {Ph=Ph+Double.toString(xAnt[i])+"; ";}
            			Ph=Ph+Double.toString(xAnt[NbAnt-1]);
            		}
            		MesAntecedents.Texte.setVisible(true);
            		MesAntecedents.Texte.setText(Ph);
            		
            	}
        	}
    	}});
        Affichage.repaint();
	}
	public void Ant_Fin()
	{
		MaCourbe.NbTriche=0;
		CorrectionAnt=false;
		MesAntecedents.Correction.setText("Correction");
		Power.Barre(Difficulte);Power.repaint();
		AvecAnt=false;
		Exo_Ant_text_A_jour();
		
		if (Evaluation) 
		{
			if (NbAnt==0) {NbAnt=1;} // pour l'valuation.
			if (Exo_Ant) {ErrAnt=ErrAnt+Math.min(NbAnt,ErreurQuestion);NbreQuestAnt=NbreQuestAnt+NbAnt;}
				else {ErrEqu=ErrEqu+Math.min(NbAnt,ErreurQuestion);NbreQuestEqu=NbreQuestEqu+NbAnt;}
			if ((NbAnt-ErreurQuestion)>0) {note=note+(double)(NbAnt-ErreurQuestion);}
			Eval();
		}
		else
		{
			Exo_Ant_Calculs();
			MaCourbe.ChangeCourbe(xmin,xmax,ymin,ymax,Point,NbPoints);
			Triche();
			if (Exo_Ant) {MesAntecedents.Enonce.setText("Le nombre "+Ant);} else {MesAntecedents.Enonce.setText("L'quation f(x)="+Ant);}
			MaCourbe.Correct_Ant=false;
			MaCourbe.BarrePasAnt=false;
			ErreurQuestion=0;
			Affichage.repaint();
		}
		
	}
	public void Dialogue_Ant_Non_Visible()
	{
		for (int i=0;i<8;i++) {MesAntecedents.Reponse[i].setText("");MesAntecedents.Reponse[i].setVisible(false);}
		MesAntecedents.Terminer.setVisible(false);
		MesAntecedents.Texte.setVisible(false);
		MesAntecedents.LesAnt.setVisible(true);
		MesAntecedents.PasAnt.setVisible(true);
		MesAntecedents.PasAnt.setEnabled(true);
		MesAntecedents.LesAnt.setEnabled(true);
		MesAntecedents.Correction.setVisible(false);
		MaCourbe.ChangeCourbe(xmin,xmax,ymin,ymax,Point,NbPoints);
	}
	public void Creation_Objets_Ant()
	{
		HauteurCourbe=(int) (Hauteur/2);LargeurCourbe=Largeur-30;
		MaCourbe=new PanneauCourbe(10,10,LargeurCourbe,HauteurCourbe);
        Affichage.add(MaCourbe);
        MesAntecedents=new DialogueAntecedents(10,HauteurCourbe+20,LargeurCourbe,HauteurCourbe-60,Ant);
        if (!Exo_Ant) 
        {
        	MesAntecedents.Enonce.setText("L'quation f(x)="+Ant);
        	MesAntecedents.LesAnt.setText("a des solutions");
        	MesAntecedents.PasAnt.setText("n'a pas de solution");
        	//MesAntecedents.Texte.setText("Saisissez toutes les solutions de l'quation (une solution par case).");
        	Exo_Ant_text_A_jour();
        	
        }
        Affichage.add(MesAntecedents);
	}
	public void Exo_Ant_text_A_jour()
	{
		if (Exo_Ant) {MesAntecedents.Texte.setText("Saisissez tous les antcdents (un antcdent par case).");} 
		else {MesAntecedents.Texte.setText("Saisissez toutes les solutions de l'quation (une solution par case).");}
	}
	// Choisit l'antcdent au hasard en fonction de la difficult, et construit les points  interpoller.
	public void Exo_Ant_Calculs2()
	{
		GraduationHasard();
        NbPoints=Math.min(8+Difficulte,NbGraduationsAbscisses);
        NbAnt=Math.min((int)(Math.random()*(double)(Difficulte+1)),(NbPoints/2));
        if (Preums) {Preums=false;NbAnt=1;}
        if (NbAnt==0) {Preums=true;} // On vite d'avoir deux fois l'ensemble vide
        
        if (NbAnt>8) {NbAnt=8;}
        if (AvecAnt) {NbAnt=NbAntEval;}
        if (NbAnt==0) 
        {
        	if (Math.random()>0.5d) {Ant=(double)ymin+Math.random()*2;ymin=ymin+3;Antecedent((double)(ymin+6),2);ymin=ymin-3;}
        	else {Ant=(double)ymax-Math.random()*2;ymax=ymax-3;Antecedent((double)(ymax-6),2);ymax=ymax+3;}
        	Ant=((double)Math.round(Ant*10))/10d;
        }
        else
        {
        	Ant=Math.random()*(double)(ymax-ymin)+(double)ymin;
        	if (Ant<(double)(ymin+1)) {Ant++;}
        	if (Ant>(double)(ymax-1)) {Ant--;}
        	Ant=((double)Math.round(Ant*10))/10d;
        	Antecedent(Ant,NbAnt);
        }
	}
	public void Exo_Ant_Calculs3()
	{
		Exo_Ant_Calculs2();
		while (VoitonCourbe()) {Exo_Ant_Calculs2();}
	}
	public void Exo_Ant_Calculs()
	{
		boolean recomence=true;
		while (recomence)
		{
			Exo_Ant_Calculs3();
			recomence=false;
			for (int i=1;i<NbPoints;i++)
			{
				if (Math.abs((Point[i][1]-Point[i-1][1])/(Point[i][0]-Point[i-1][0]))<0.2d) {recomence=true;}
			}
		}
	}
	public void Triche()
	{
		for (int i=0;i<NbAnt;i++)
		{
			MaCourbe.Triche[i][0]=(float) Arrondir(xAnt[i]);
			MaCourbe.Triche[i][1]=(float)Ant;
		}
		MaCourbe.NbTriche=NbAnt;
	}
	
	public int VerifieAnt(double[] Rep) // Rep:rponses
	{
		boolean Faux;
		boolean PasEcriture=true;
		int Vraie=0;
		// Compromet les doublons
		for (int k=0;k<7;k++)
		{
			for (int i=k+1;i<8;i++)
			{
				if (Math.abs(Rep[k]-Rep[i])<=0.201d) {Rep[k]=1024d;}
			}
		}
		// Verifie Ensemble de def
		boolean DansDef=true;
		for (int k=0;k<7;k++)
		{
			if ((Rep[k]<Point[0][0] | Rep[k]>Point[NbPoints-1][0]) && Rep[k]!=1024d)
			{
				if (DansDef) 
					{
					Information("La fonction f n'est pas dfinie en x=" +Rep[k]+
							"\n\nLe domaine de dfinition de la fonction f est ["+Point[0][0]+" ; "+Point[NbPoints-1][0]+"]");
					}
				Rep[k]=1024d;DansDef=false;
				MesAntecedents.Reponse[k].setText("");
				PasEcriture=false;
			}
		}
		//Vrifie
		for (int k=0;k<8;k++)
		{
			Faux=true;
			for (int i=0;i<NbAnt;i++)
			{
				if (Math.abs(Rep[k]-xAnt[i])<=0.201d) 
				{
					if (Arrondir3(MaCourbe.Fonction(Rep[k]))==Arrondir3(Ant) | (Math.abs(Rep[k]-xAnt[i])<=0.101d))
					{
						Faux=false;
						if (Arrondir(Rep[k])!=Arrondir(xAnt[i])) 
						{
							String Plate="car j'accepte les rponses au dixime prs.";
							if ((Math.abs(Rep[k]-xAnt[i])>0.1d)) Plate="car la courbe est pratiquement plate en "+xAnt[i]+"\nce qui rend difficile la lecture graphique.";
							MesAntecedents.Reponse[k].setText(""+xAnt[i]);
							String Ph="";
							if (Evaluation) Ph="\nJe vous rassure, vous n'avez pas perdu de point.";
							Information("Je considre que vous ne vous tes pas tromp,\n"+Plate+Ph+"\n\nCe n'tait pas "+Rep[k]+" , mais "+xAnt[i]+
									" la bonne rponse.\nJe corrige votre rponse.");
							Rep[k]=xAnt[i];
						}
					}
					else
					{
						if ((PasEcriture) && Rep[k]!=1024d) 
						{
							PasEcriture=false;
							Information("Soyez plus prcis: f("+Rep[k]+") = "+Arrondir3(MaCourbe.Fonction(Rep[k]))+"\u2260 "+Ant);
						}
					}
				}				
			}
			if (Faux) 
			{
				if ((PasEcriture) && Rep[k]!=1024d) 
				{
					PasEcriture=false;
					Information("f("+Rep[k]+") = "+Arrondir3(MaCourbe.Fonction(Rep[k]))+"\u2260 "+Ant);
				}
				MesAntecedents.Reponse[k].setText("");
			}
			else {Vraie++;}
			
		}
		return Vraie; // Nb de bonnes rponses
	}
	public void Antecedent(double Ant,int Nb) // cre Nb Antcdents de Ant
	{
		int position=0;
		int ancposition=-1;
		int ecart;
		int compteur=0;
		boolean sens;
		double quot=(double)NbPoints/(double)Nb; //
		PointHasard();	
		for (int i=0;i<Nb;i++)
		{
			if (i==0) {position=(int) (Math.random()*quot);}
			else
			{
				ecart=(int) (Math.random()*(((double)(i-position))*quot));
				if (ecart<2) {ecart=2;}
				ancposition=position;
				position=position+ecart;
			}
			Point[position][1]=Ant;xAnt[compteur]=Point[position][0];compteur++; // les abscisses des st placs dans xAnt[] pour la correction
			if (Math.random()<0.5d) {sens=true;} else {sens=false;}
			for (int j=ancposition+1;j<position;j++)
			{
				if (sens) {Point[j][1]=Ant+1d+Math.random()*((double)ymax-Ant-1d);}
				else {Point[j][1]=Ant-1d-Math.random()*(Ant-(double) ymin-1d);}
				
			}
		}
		if (Math.random()<0.5d) {sens=true;} else {sens=false;}
		for (int j=position+1;j<NbPoints;j++)  //
		{
			if (sens) {Point[j][1]=Ant+1d+Math.random()*((double)ymax-Ant-1d);}
			else {Point[j][1]=Ant-1d-Math.random()*(Ant-(double) ymin-1d);}
		}
		
	}	
	public void Correction()
	{	double pas;
		for (int i=0;i<8;i++)
		{
			MaCourbe.Abs_Ant[i]=xAnt[i]; // On transmet les abscisses des points antcdents
		}
		MaCourbe.Compt_Ant=0;
		MaCourbe.Correct_Parcours=Point[0][0]; // On commence par le premier point
		MaCourbe.NbAnt=NbAnt;
		pas=(Point[NbPoints-1][0]-Point[0][0])/100;
		Correction_Ant Tache=new Correction_Ant(MaCourbe,NbAnt,pas,Point[NbPoints-1][0],Ant); //Thread de correction
		Tache.start();
		MesAntecedents.Correction.setText("Continuez");
	}
	public void GraduationHasard()
	{
		xmin=-Math.floor((Math.random()*(double)NbGraduationsAbscisses)*0.9d);xmax=xmin+(double)NbGraduationsAbscisses;
		ymin=Math.min(-Math.floor((Math.random()*(double)NbGraduationsOrdonnees)*0.9d),-1);ymax=ymin+NbGraduationsOrdonnees;
	}
	// cre NbPoints aux hasards
	public void PointHasard()
	{	
		boolean oups=true;
		while (oups)
		{
			double Ampx=xmax-xmin-1d;
			double Ampy=ymax-ymin;
			double Min,t;
			int Echge;
			boolean test=true;
			while (test)
			{	
				for (int i=0;i<NbPoints;i++)
				{
					Point[i][0]=Arrondir(xmin+Math.random()*Ampx+0.5d);
					Point[i][1]=ymin+(Math.random())*Ampy;
				}		
				for (int i=0;i<NbPoints;i++)
				{
					Min=Point[i][0];Echge=i;
					for (int j=i;j<NbPoints;j++)
					{
						if (Min>Point[j][0]) {Min=Point[j][0];Echge=j;}
					}
					t=Point[i][0];Point[i][0]=Min;Point[Echge][0]=t;
				}
				test=false;
				for (int i=0;i<(NbPoints-1);i++)
				{
					if (Math.abs(Point[i][0]-Point[i+1][0])<0.4d) {test=true;}
				}	
			}
			
			oups=VoitonCourbeExtremite();
		}
	}
	
	public void EnsembleDefintion()
	{  // Diff=1 obligatoire pour les limites !
		ErreurQuestion=0;
		Affichage.removeAll();
		EnsDef=true;
		Creation_Objets_Def();
		Initialise_Def();
		MesDef.Reponse.requestFocus();
		MesDef.Agrandir.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e) 
    	{	
			if (PremierZoom) Information ("Aprs avoir valid cette fentre d'information,\n\nen cliquant sur le graphique tout en maintenant le bouton enfonc,\n" +
					"vous pourrez dlimiter la zone que vous souhaitez tirer.\n");
			PremierZoom=false;
			MesDef.TailleNormal.setEnabled(true);
			MaCourbe.Agrandir=true;
			MesDef.Agrandir.setForeground(new Color(0,0,255));
			Affichage.repaint();
    	}});
		MesDef.TailleNormal.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e) 
    	{	
			MesDef.TailleNormal.setEnabled(false);
			MaCourbe.Agrandir=false;MesDef.Agrandir.setForeground(new Color(0,0,0));
			ZoomAnimation Tache=new ZoomAnimation(MaCourbe,xmin,xmax,MaCourbe.xmin,MaCourbe.xmax);
			Tache.start();
			Affichage.repaint();
    	}});
		MesDef.Correction.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e) 
    	{	
			if (Lim) {Information("La limite demande est "+ValeurLimite);}
			else
			{
				Information("Le domaine de dfinition est :"+Sol+"\n\nContinuons.","Trop d'erreurs");
			}
			Initialise_Def();
			Affichage.repaint();
    	}});
		
		
		MesDef.Valider.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e) 
    	{	
		MaCourbe.Agrandir=false;MesDef.Agrandir.setForeground(new Color(0,0,0));
		Rep=MesDef.Reponse.getText();
		if (Rep.length()==0) 
		{
			
			if (Lim) {Information("La limite existe !");}
			else Information("Il y a toujours un ensemble de dfinition !");
		}
		else
		{
			if (Lim) 
			{	
				double RepNb=0;
				boolean Juste=true;
				try {RepNb=new Double (Rep).doubleValue();}
				catch (NumberFormatException ex) {MesDef.Reponse.setText("");Error("Illisible !");Juste=false;}
				if (Juste) 
				{
					if (PasAuDix(RepNb)) {Error("La limite est un dcimal\nayant au plus un chiffre non nul aprs la virgule.");}
					else
					{
						if (RepNb==ValeurLimite)
						{
							Congratulation("Bien, continuons","Rponse juste");
							Initialise_Def();
							Affichage.repaint();
						}
						else {Error("Ce n'est pas la limite.");ErreurQuestion++;if (ErreurQuestion>1) {MesDef.Correction.setVisible(true);}}
					}
				}
			}
			else
			{if (Lave())
			{	
				if (ConvertirString())
				{
					boolean iop=true;
					for (int i=0;i<NbInterS;i++)
					{
						if (PasAuDix(InterS[i].X()) | PasAuDix(InterS[i].Y())) 
						{iop=false;i=NbInterS+1;Error("Les bornes sont des dcimaux\nayant au plus un chiffre non nul aprs la virgule.");}
					}
					if (iop)
					{
						if (NbInterS>1) {OrdonnerIntervalles();} // Classe les InterS dans l'ordre croissant
						if (VerifieCoherence()) //vrifie si il n'y a pas par ex: [2;3[U{3}
						{
							if (ChercheErreurs()) 
							{
								Congratulation("Bien, continuons","Rponse juste");
								Initialise_Def();
								Affichage.repaint();
							}
							else
								{	ErreurQuestion++;
									if (ErreurQuestion>2){MesDef.Correction.setVisible(true);}
									Affichage.repaint();
								}
						}
					}
					
				}
			}
			}
		}
			
    	}});
		Affichage.repaint();
	}
	public boolean PasAuDix(double x)
	{
		return (Math.round(x*10d)/10d!=x);
	}
	public void Creation_Objets_Def()
	{
		HauteurCourbe=(int) (Hauteur/2);LargeurCourbe=Largeur-30;
		MaCourbe=new PanneauCourbe(10,10,LargeurCourbe,HauteurCourbe);
        Affichage.add(MaCourbe);
        MesDef=new EnsembleDef(10,HauteurCourbe+20,LargeurCourbe,HauteurCourbe-60,Lim);
        if (Difficulte==0) {MesDef.Agrandir.setVisible(false);MesDef.TailleNormal.setVisible(false);} 
        else {MesDef.Agrandir.setVisible(true);MesDef.TailleNormal.setVisible(true);}
        Affichage.add(MesDef);
	}
	public void Initialise_Def()
	{
		int abscisse=0;boolean ferme1,ferme2;MesDef.Reponse.setText("");
        NbPoints=Math.min(8+Difficulte,NbGraduationsAbscisses);
        MesDef.Correction.setVisible(false);
        ErreurQuestion=0;
        GraduationHasard();
        PointHasard();
        switch (Difficulte)
        {
        case 0:
        	NbInter=1;
        	Inter[0]=new Intervalle(Point[0][0],Point[NbPoints-1][0]);
        	Inter[0].X(false);Inter[0].Y(false);
        	
        	Inter[1]=new  Intervalle(Point[NbPoints-1][0],Point[NbPoints-1][0]);
        	break;
        default:
        	NbInter=2;
        	abscisse=(int)(Math.random()*(NbPoints-4))+1;
        	Inter[0]=new Intervalle(Point[0][0],Point[abscisse][0]);
        	Inter[0].X(false);Inter[0].Y(false);
        	if(Math.random()<0.5d) {ferme1=false;} else {ferme1=true;}
        	if(Math.random()<0.5d) {ferme2=false;} else {ferme2=true;}
        	Inter[1]=new Intervalle(Point[abscisse+1][0],Point[NbPoints-1][0]);
        	if (Math.random()<0.5d)
    		{Inter[0].Y(ferme1);Inter[1].X(ferme2);} else {Inter[0].Y(ferme2);Inter[1].X(ferme1);}
        	if ((Math.random()>0.5d) && ((Math.abs(Point[abscisse+1][1]-Point[abscisse][1]))>1.5d))
        		{
        			Point[abscisse+1][0]=Point[abscisse][0];
        			Inter[1].g=Point[abscisse][0];
        			Inter[0].Y(true);Inter[1].X(true);
        		}
        	Inter[0].X(false);Inter[1].Y(false);
        	break;
        }
        //EnonceChange
        String P="";
        if (Math.random()<0.3d) 
        {
        	int i=(int) (Math.random()*NbPoints);
        	if (i==abscisse) i++;
        	if (i==(abscisse+1)) i++;
        	P="La limite de f(x) lorsque x tend vers "+Point[i][0]+" est";
        	Point[i][1]=Arrondir(Point[i][1]);
        	ValeurLimite=Point[i][1];
        }
        else
        {
        	if (Math.random()<0.5d) {Point[abscisse][1]=Arrondir(Point[abscisse][1]);ValeurLimite=Point[abscisse][1];P="La limite  gauche de f(x) lorsque x tend vers "+Inter[0].Y()+" est";}
        	else 
        	{Point[abscisse+1][1]=Arrondir(Point[abscisse+1][1]);ValeurLimite=Point[abscisse+1][1];P="La limite  droite de f(x) lorsque x tend vers "+Inter[1].X()+" est";}
        }
        MaCourbe.indiceAbscisse=abscisse;
        if (Lim) MesDef.EnonceChange(P);
        Solution();
        if (Difficulte==0) MaCourbe.ChangeCourbe(xmin,xmax,ymin,ymax,Point,NbPoints); else MaCourbe.ChangeCourbeLimite(xmin,xmax,ymin,ymax,Point,NbPoints,Inter,NbInter,MesDef);
	}
	public void ErrV(int i,int j,int k)
	{
		String Ph="l'abscisse";
		if (k==1) {Ph="l'ordonne";}
		Error("Regardez, le curseur indique un point,\ndont "+Ph+" devrait tre "+PointV[i][k]);
		MaCourbe.Curseur=MaCourbe.Point[j][0];Affichage.repaint();
	}
	public boolean ErrDF(int i,int j)
	{
		boolean t=true;
		if (!Mabs(i,j))	{ErrV(i,j,0);t=false;}
		else
		{
			if (!Mord(i,j))
			{ErrV(i,j,1);t=false;}
		}
		return (t);
	}
	public int CherSupI(int j)
	{
		int i=1;
		while ((MaCourbe.Point[j][0]>PointV[i][0]) && (i<NbPointsV)) {i++;}
		return (i);
	}
	public void TableauVariation()
	{
		Affichage.removeAll();
		Creation_Objets_variation();
		InitialiseVariation();
		Affichage.repaint();
		if (!Evaluation)
		{
			Presentation("PresentationVariation.html",580,240);
		}
		MesVar.Valider.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e) 
    	{if (!Principal.IsThread)
    	{
			boolean PasErreur=true;
			PasErreur=(ErrDF(0,0)); // vrifie le premier
			if (PasErreur) {PasErreur=(ErrDF(NbPointsV-1,NbPoints-1));} // Vrifie le dernier
			if (PasErreur)
			{
				for (int j=0;j<NbPoints;j++)
				{
					for (int i=0;i<NbPointsV;i++)
					{	if (Mabs(i,j) && !Mord(i,j)) {ErrV(i,j,1);PasErreur=false;break;}}
					if (!PasErreur) {break;}
				}
			}
			if (PasErreur)
			{
				int i;
				double Ma,Mi;
				for (int j=1;j<NbPoints;j++) // vrifie si y(pt i-1)<y(pt j)<y(pt i)
				{
					i=CherSupI(j); // le pt j est entre le point i-1 et i
					if (!Mabs(i,j))
					{
						Ma=Math.max(PointV[i-1][1],PointV[i][1]);Mi=Math.min(PointV[i-1][1],PointV[i][1]);
							if (Arrondir(MaCourbe.Point[j][1])>Ma) 
							{
								PasErreur=false;MaCourbe.Curseur=MaCourbe.Point[j][0];Affichage.repaint();
								Error("Regardez, le curseur indique un point,\ndont l'ordonne est trop grande.\nElle devrait tre infrieure  "+Ma);
								break;
							}
							if (Arrondir(MaCourbe.Point[j][1])<Mi) 
							{
								PasErreur=false;MaCourbe.Curseur=MaCourbe.Point[j][0];Affichage.repaint();
								Error("Regardez, le curseur indique un point,\ndont l'ordonne est trop petite.\nElle devrait tre suprieure  "+Mi);
								break;
							}
					}
				}
			}
			if (PasErreur)
			{ // vrifie les variations
				int i;
				for (int j=1;j<NbPoints-1;j++)
				{
					i=CherSupI(j);
					if (!Mabs(i,j) && !Mabs(i,j+1) && i==CherSupI(j+1))
					{
						if ((PointV[i][1]>PointV[i-1][1]) && (Point[j+1][1]<Point[j][1]))
						{
							PasErreur=false;MaCourbe.Curseur=MaCourbe.Point[j][0];Affichage.repaint();
							Error("Votre courbe est dcroissante sur [ "+Arrondir(Point[j][0])+" ; "+Arrondir(Point[j+1][0])+" ],\nalors qu'elle devrait tre croissante.");
						}
						if ((PointV[i][1]<PointV[i-1][1]) && (Point[j+1][1]>Point[j][1]))
						{
							PasErreur=false;MaCourbe.Curseur=MaCourbe.Point[j][0];Affichage.repaint();
							Error("Votre courbe est croissante sur [ "+Arrondir(Point[j][0])+" ; "+Arrondir(Point[j+1][0])+" ],\nalors qu'elle devrait tre dcroissante.");
						}
						
					}
				}
			}
			if (PasErreur)
			{
				for (int i=1;i<(NbPointsV-1);i++)
				{
					int j=1;
					while (!Mabs(i,j) && j<NbPoints) {j++;}
					if (j==NbPoints)
					{
						PasErreur=false;MaCourbe.Curseur=PointV[i][0];Affichage.repaint();
						Error("Regardez, le curseur indique un point,\ndont l'ordonne devrait tre "+PointV[i][1]);
						break;
					}
				}
			}
					
		if (PasErreur)
		{
			if (Evaluation) 
			{
				ErrVariation=ErrVariation+ErreurQuestion;
				note=note+(double) Math.max((PointQuest-ErreurQuestion),0);
				ErreurQuestion=0;
				Eval();
			}
			else
			{
				Encouragement();
				InitialiseVariation();
				Affichage.repaint();
			}
			
		}
		else 
		{
			ErreurQuestion++;
			if ((PointQuest-ErreurQuestion)<=0 && (Evaluation))
			{
				ErreurQuestion=0;
				ErrVariation=ErrVariation+PointQuest;
				Eval();
			}
		}
    	}
    	}});
		MesVar.Correction.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e) 
    	{
			if (Evaluation)
			{
				ErrVariation=ErrVariation+PointQuest;
				Eval();
			}
			else
			{
				if (!Principal.IsThread)
				{
					if (CorrectionV) 
					{
						InitialiseVariation();
						Affichage.repaint();
					}
					else
					{
						CorrectionV();
						CorrectionV=true;
						MesVar.Correction.setText("Continuez");MesVar.Valider.setEnabled(false);	
					}
				}
			}
    	}});
		
	}
	public void CorrectionV()
	{
		CorrectionVariations Tache=new CorrectionVariations(MaCourbe,NbPointsV,PointV);
		Tache.start();
	}
	public boolean Mabs(int i,int j)
	{
		return(Egalite(MaCourbe.Point[j][0],PointV[i][0]));
	}
	public boolean Mord(int i,int j)
	{
		return(Egalite(MaCourbe.Point[j][1],PointV[i][1]));
	}
	
	public double EntreYminYmax()
	{
		return (Arrondir(Math.random()*(ymax-ymin-1d)+ymin+0.5d));
	}
	public void InitialiseVariation()
	{
		MesVar.Correction.setText("Correction");
		MesVar.Valider.setEnabled(true);CorrectionV=false;
		Difficulte=Math.min(Difficulte,6);
		NbPoints=3+Difficulte; // maximum 10;
		ErreurQuestion=0;
		
		PointQuest=Difficulte+2;
		ErreurQuestion=0;NbreQuestVariation=NbreQuestVariation+PointQuest;
		if (Evaluation) {MesVar.Correction.setText("Je passe la question et je perds les points");}
		
		Power.Barre(Difficulte);Power.repaint();
		GraduationHasard();
        PointHasard();while (EcartMinimum()<1) {PointHasard();}
        PointV[0][1]=EntreYminYmax();
        for (int i=0;i<NbPoints;i++) 
        {
        	PointV[i][0]=Point[i][0];
        	if (i<=1) {PointV[i][1]=EntreYminYmax();}
        	else
        	{
        		if (PointV[i-2][1]<PointV[i-1][1]) 
        		{//Point prcdent en haut
        			PointV[i][1]=Arrondir(PointV[i-1][1]-Math.abs(Math.random()*(PointV[i-1][1]-ymin-1d))-0.5d);
        		}
        		else
        		{
        			PointV[i][1]=Arrondir(PointV[i-1][1]+Math.abs(Math.random()*(ymax-PointV[i-1][1]-1d))+0.5d);
        		}
        	}
        	if (i==1)
        	{
        		while (Math.abs(PointV[0][1]-PointV[1][1])<2d) {PointV[1][1]=EntreYminYmax();}
        	}
        }
        NbPointsV=NbPoints;
        
        NbPoints=5+Difficulte;if (Difficulte==0) {NbPoints=NbPointsV;}
        for (int i=0;i<NbPoints;i++)
        {
        	Point[i][0]=xmin+((double)(i+1))*(xmax-xmin)/(double)(NbPoints+1);
        }
        for (int i=0;i<NbPoints;i++) {Point[i][0]=Point[i][0];Point[i][1]=Arrondir(Math.random()*(ymax-ymin-1d)+ymin+0.5d);}
        
        MaCourbe.ChangeCourbe(xmin,xmax,ymin,ymax,Point,NbPoints);
        MesVar.Tableau(NbPointsV,PointV); 
	}
	public double EcartMinimum()
	{
		double e=1000d;
		for (int i=0;i<NbPoints-1;i++) {e=Math.min(e,Math.abs(Point[i][0]-Point[i+1][0]));}
		return(e);
	}
	public void Creation_Objets_variation()
	{
		HauteurCourbe=(int) (Hauteur/2);LargeurCourbe=Largeur-30;
		MaCourbe=new PanneauCourbe(10,10,LargeurCourbe,HauteurCourbe);
		MaCourbe.tableau=true;
        Affichage.add(MaCourbe);
        MesVar=new DialogueVariations(10,HauteurCourbe+20,LargeurCourbe,HauteurCourbe-60);
        Affichage.add(MesVar);
	}
	public String Numero(int i)
	{
		String Ph;
		switch(i)
		{
			case 0:Ph="premire";break;
			case 1:Ph="deuxime";break;
			case 2:Ph="troisime";break;
			case 3:Ph="quatrime";break;
			case 4:Ph="cinquime";break;
			case 5:Ph="sixime";break;
			case 6:Ph="septime";break;
			case 7:Ph="huitime";break;
			case 8:Ph="neuvime";break;
			case 9:Ph="dixime";break;
			default: Ph=""+(i+1)+" me";
		}
		return (Ph);
	}
	public void PoufFocus(int i,int j)
	{
		MesVar2.Reponse[i][j].requestFocus();
		MesVar2.Reponse[i][j].setText("");
	}
	public void Presentation(String Fichier,int x, int y)
	{
		MaFenAide Fen=new MaFenAide(Fichier);
		Fen.setBounds((Largeur-x)/2,(Hauteur-y)/2,x,y);
		Fen.setVisible(true);
		Fermeture_Automatique Thr=new Fermeture_Automatique(Fen);
		Thr.start();
	}
	public void TableauVariation2()
	{
		Affichage.removeAll();
		Creation_Objets_variation2();
		InitialiseVariation2();
		Affichage.repaint();
		
		if (!Evaluation) {Presentation("PresentationVariation2.html",580,240);}
		
		
		
		MesVar2.Valider.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e) 
    	{
			boolean PasErreur=true;
			// Vrification du domaine de dfinition des abscisses crites
			for (int i=0;i<NbPoints;i++)
			{
				if (((Arrondir(MesVar2.Transmet(i,2))<Point[0][0]) | (Arrondir(MesVar2.Transmet(i,2))>Point[NbPoints-1][0])) && (Arrondir(MesVar2.Transmet(i,2))!=1024d))
					
				{PasErreur=false;Error("Le domaine de dfinition de la fonction est l'intervalle ["+Point[0][0]+";"+Point[NbPoints-1][0]+"].\n" +
						"Votre "+Numero(i)+" abscisse est "+Arrondir(MesVar2.Transmet(i,2))+"\n\nLa fonction n'est pas dfinie en "+Arrondir(MesVar2.Transmet(i,2))+" .");PoufFocus(i,2);break;}
			}
			//la premire est  traiter  part.
			if (PasErreur)
			{
				if (!Egalite(MesVar2.Transmet(0,2),Point[0][0]))
				{
					PasErreur=false;
					MaCourbe.Curseur=MesVar2.Transmet(0,2);Affichage.repaint();
					Error("Le domaine de dfinition de la fonction est l'intervalle ["+Point[0][0]+" ; "+Point[NbPoints-1][0]+
							"].\nVotre tableau commence en x="+Arrondir(MesVar2.Transmet(0,2))+"\nC'est trop grand !\n\nRegardez le graphique, puis corrigez.");
				}
				else
				{	
					double y=MesVar2.Transmet(0,1);
					if (y==1024d) y=MesVar2.Transmet(0,0);
					if (!Egalite(y,Point[0][1]))
					{
						PasErreur=false;
						MaCourbe.Curseur=Point[0][0];Affichage.repaint();
						if (y!=1024d)
						{
							Error("D'aprs votre tableau, f("+Point[0][0]+")="+y+"\n\nC'est faux, Regardez le graphique,\npuis corrigez votre premire image");
							if (MesVar2.Transmet(0,1)==1024d) PoufFocus(0,0); else PoufFocus(0,1);	
						}
						else 
						{
							Error("Le tableau commence bien en x="+Arrondir(MesVar2.Transmet(0,2))+
									"\nMais vous n'avez pas saisi son image\n\nRegardez le graphique\npuis corrigez.");
						}
					}
				}
			}
			// abscisses dans le bon ordre et diffrentes !
			if (PasErreur)
			{
				for (int i=0;i<NbPoints-1;i++)
				{
					if (MesVar2.Transmet(i,2)!=1024d)
					{
						if (MesVar2.Transmet(i,2)>MesVar2.Transmet(i+1,2))
						{PasErreur=false;Error("Vos abscisses ne sont pas ranges dans l'ordre croissant.");PoufFocus(i+1,2);break;}
						if (Egal(MesVar2.Transmet(i,2),MesVar2.Transmet(i+1,2)))
						{PasErreur=false;Error("Vous avez deux abscisses qui sont gales");break;}
					}
				}
			}
			//
			if (PasErreur)
			{
				for (int i=0;i<NbPoints-1;i++)
				{
					String Ph="";
					boolean Max2=true;
					double y1,y2;
					double x1=MesVar2.Transmet(i,2);y1=MesVar2.Transmet(i,0);
					double x2=MesVar2.Transmet(i+1,2);y2=MesVar2.Transmet(i+1,0);
					if (y1==1024d) {y1=MesVar2.Transmet(i,1);} 
					if (y2==1024d) {y2=MesVar2.Transmet(i+1,1);Max2=false;}
					if (x1==1024d | x2==1024d | y1==1024d | y2==1024d) {break;}
					if (!EgaliteLarge(x2,Point[i+1][0]))
					{
						PasErreur=false;
						if (Max2) {Ph="maximum";} else {Ph="minimum";}
						MaCourbe.Curseur=x2;Affichage.repaint();
						Error("La fonction n'admet pas de "+Ph+" local en "+x2+"\nRegardez le graphique.");
						PoufFocus(i+1,2);break;
					}
					else
					{// l'abscisse est juste
						MesVar2.Reponse[i+1][2].setText(""+Point[i+1][0]);
						if (!Egal(y2,Point[i+1][1]))
						{
							PasErreur=false;MaCourbe.Curseur=x2;Affichage.repaint();
							Error("D'aprs votre tableau, f("+Point[i+1][0]+")="+y2+"\n\nC'est faux, Regardez le graphique,\npuis corrigez votre "+Numero(i)+" image");
							if (Max2) PoufFocus(i+1,0); else PoufFocus(i+1,1);
							break;
						}
						else
						{
							//abscisse et ordonne sont justes
							if ((Point[i][1]<Point[i+1][1]) && !Max2)
							{PasErreur=false;Error("La fonction est strictement croissante\nsur l'intervalle ["+Point[i][0]+" ; "+Point[i+1][0]+"]");break;}
							if ((Point[i][1]>Point[i+1][1]) && Max2)
							{PasErreur=false;Error("La fonction est strictement dcroissante\nsur l'intervalle ["+Point[i][0]+" ; "+Point[i+1][0]+"]");break;}
						}
					}
				}
			}
			// Il manque des abscisses
			if (PasErreur)
			{
				for (int i=0;i<NbPoints;i++)
				{
					if (MesVar2.Transmet(i,2)==1024d)
					{PasErreur=false;Error("Il manque la "+Numero(i)+" abscisse.");PoufFocus(i,2);break;}
				}
			}
//			 Il manque des images
			if (PasErreur)
			{
				for (int i=0;i<NbPoints;i++)
				{
					if (MesVar2.Transmet(i,1)==1024d && MesVar2.Transmet(i,0)==1024d)
					{
						PasErreur=false;
						Error("Il manque la "+Numero(i)+" image.");
						PoufFocus(i,0);
					}
				}
			}
			if (PasErreur)
			{
				for (int i=0;i<NbPoints-1;i++)
				{
					if (!EgaliteLarge(MesVar2.Transmet(i,2),Point[i][0])) 
						{PasErreur=false;Error("La "+Numero(i)+" abscisse est fausse.");PoufFocus(i,2);break;}
					else
					{
						if (!Egal(MesVar2.TransmetForce(i),Point[i][1])) 
						{
							PasErreur=false;Error("La "+Numero(i)+" image est fausse.");PoufFocus(i,1);
							if (MesVar2.Transmet(i,0)==1024d){PoufFocus(i,1);} else {PoufFocus(i,0);}
							break;
						}
						else
						{
							if ((Point[i][1]<Point[i+1][1]) && MesVar2.Transmet(i,1)==1024d)
							{PasErreur=false;Error("La fonction est strictement croissante\nsur l'intervalle ["+Point[i][0]+" ; "+Point[i+1][0]+"]");break;}
							if ((Point[i][1]>Point[i+1][1]) && MesVar2.Transmet(i,0)==1024d)
							{PasErreur=false;Error("La fonction est strictement dcroissante\nsur l'intervalle ["+Point[i][0]+" ; "+Point[i+1][0]+"]");break;}
							if (PasErreur)
							{
								if (!Egal(MesVar2.TransmetForce(i+1),Point[i+1][1])) 
								{
									PasErreur=false;Error("La "+Numero(i+1)+" image est fausse.");
									if (MesVar2.Transmet(i+1,0)==1024d){PoufFocus(i+1,1);} else {PoufFocus(i+1,0);}
									break;
								}
								else
								{
									if (!Egal(MesVar2.Transmet(i+1,2),Point[i+1][0])) 
									{PasErreur=false;Error("La "+Numero(i+1)+" abscisse est fausse.");PoufFocus(i+1,2);break;}
								}
							}
						}
					}
				}
			}
			if (PasErreur)
			{
				if (Evaluation) 
				{
					ErrVariation=ErrVariation+ErreurQuestion;
					note=note+(double) Math.max((PointQuest-ErreurQuestion),0);
					ErreurQuestion=0;
					Eval();
				}
				else
				{
					Encouragement();
					MesVar2.removeAll();
					InitialiseVariation2();
					Affichage.repaint();
				}
			}
			else 
			{
				ErreurQuestion++;
				if ((Evaluation) && (PointQuest-ErreurQuestion)<=0)
				{
					ErrVariation=ErrVariation+ErreurQuestion;
					ErreurQuestion=0;
					if (PasDernierEval) {Information("On continue avec un nouvel exercice.","Avertissement");}
					Eval();
				}
			}
    	}});
		MesVar2.Correction.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e) 
    	{
				if (Evaluation)
				{
					ErrVariation=ErrVariation+PointQuest;
					Eval();
				}
				else
				{
					if (CorrectionV) 
					{
						MesVar2.removeAll();
						InitialiseVariation2();
						Affichage.repaint();
					}
					else
					{
						CorrectionV=true;
						MesVar2.Correction.setText("Continuez");MesVar2.Valider.setEnabled(false);
						for (int i=0;i<NbPoints-1;i++)
						{
							if (Point[i][1]<Point[i+1][1])
							{
								MesVar2.Reponse[i][0].setText("");
								MesVar2.Reponse[i][1].setText(""+Point[i][1]);
							}
							else
							{
								MesVar2.Reponse[i][1].setText("");
								MesVar2.Reponse[i][0].setText(""+Point[i][1]);
							}
							MesVar2.Reponse[i][2].setText(""+Point[i][0]);
						}
						if (Point[NbPoints-2][1]>Point[NbPoints-1][1])
						{
							MesVar2.Reponse[NbPoints-1][0].setText("");
							MesVar2.Reponse[NbPoints-1][1].setText(""+Point[NbPoints-1][1]);
						}
						else
						{
							MesVar2.Reponse[NbPoints-1][1].setText("");
							MesVar2.Reponse[NbPoints-1][0].setText(""+Point[NbPoints-1][1]);
						}
						MesVar2.Reponse[NbPoints-1][2].setText(""+Point[NbPoints-1][0]);
						MesVar2.CalculehImage();
						Affichage.repaint();
					}
				}
				
    	}});
	}
	public void Creation_Objets_variation2()
	{
		HauteurCourbe=(int) (Hauteur/2);LargeurCourbe=Largeur-30;
		MaCourbe=new PanneauCourbe(10,10,LargeurCourbe,HauteurCourbe);
        Affichage.add(MaCourbe);
        MesVar2=new DialogueVariations2(10,HauteurCourbe+20,LargeurCourbe,HauteurCourbe-60);
        Affichage.add(MesVar2);
	}
	public void InitialiseVariation2()
	{	
		MesVar2.Correction.setText("Correction");
		MesVar2.Valider.setEnabled(true);CorrectionV=false;
		Difficulte=Math.min(Difficulte,6);
		NbPoints=3+Difficulte; // maximum 10;
		
		PointQuest=Difficulte+2; // modifier l'valuation si chgt
		ErreurQuestion=0;NbreQuestVariation=NbreQuestVariation+PointQuest;
		if (Evaluation) {MesVar2.Correction.setText("Je passe la question et je perds les points");}
		
		Power.Barre(Difficulte);Power.repaint();
		GraduationHasard();
        PointHasard();while (EcartMinimum()<1) {PointHasard();}
        Point[0][1]=EntreYminYmax();
        for (int i=0;i<NbPoints;i++) 
        {
        	if (i<=1) {Point[i][1]=EntreYminYmax();}
        	else
        	{
        		if (Point[i-2][1]<Point[i-1][1]) 
        		{//Point prcdent en haut
        			Point[i][1]=Arrondir(Point[i-1][1]-Math.abs(Math.random()*(Point[i-1][1]-ymin-1d))-0.5d);
        		}
        		else
        		{
        			Point[i][1]=Arrondir(Point[i-1][1]+Math.abs(Math.random()*(ymax-Point[i-1][1]-1d))+0.5d);
        		}
        	}
        	if (i==1)
        	{
        		while (Math.abs(Point[0][1]-Point[1][1])<2d) {Point[1][1]=EntreYminYmax();}
        	}
        }
        MaCourbe.ChangeCourbe(xmin,xmax,ymin,ymax,Point,NbPoints);
        MesVar2.Tableau(NbPoints,Point); 
	}
	public void DroiteDE(int module) 
	//	AffLigne & AffCoef (tracs)
	//	BloqCoef=true-> coefficient directeur bloqu, donc droite mobile
	//  NbreQuestDroite,ErrDroite;
	{
		this.module=module;
		Affichage.removeAll();
		if (Tangente)
		{
			BloqCoef=false;
			if (module==2) {OrdAOrigine=false;} else {OrdAOrigine=true;}
			Creation_Objets_Tangente(module);
			InitialiseTangente(module);
		}
		else
		{
			Creation_Objets_droite(BloqCoef,module);
			InitialiseDroite();
		}
		
		Affichage.repaint();
		MesLectGraphCoef.Continuer.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e) 
    	{
			if (!Principal.IsThread)
			{
				if (!BloqCoef)
				{
					MesLectGraphCoef.Num.setText("");MesLectGraphCoef.Den.setText("1");MesLectGraphCoef.Ord.setText("");
				}
				MesLectGraphCoef.Correction.setEnabled(true);
				MesLectGraphCoef.Cours.setEnabled(true);
				MesLectGraphCoef.Valider.setEnabled(true);
				MesLectGraphCoef.Continuer.setVisible(false);
				RecomDroite();
			}
    	}});
		MesLectGraphCoef.Correction.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e) 
    	{
			if (Tangente)
			{
				if (MaCourbe.Curseur<Point[0][0]) {MaCourbe.Curseur=Point[0][0];}
				if (MaCourbe.Curseur>Point[NbPoints-1][0]) {MaCourbe.Curseur=Point[NbPoints-1][0];}
			}
			if (!BloqCoef)
			{
				if (!MaCourbe.AffLigne)
				{
					CorrectionDroiteEqu Tache=new CorrectionDroiteEqu(MaCourbe,xA,yA,xB,yB,Ordb,OrdAOrigine,MesLectGraphCoef);Tache.start();
				}
				else
				{
					if (Tangente) 
					{
						DeplaceTangente Tache=new DeplaceTangente(MaCourbe,xB,MesLectGraphCoef);Tache.start();
					}
					MaCourbe.AffCoef=true;MaCourbe.repaint();
					if (xB>xA) {MesLectGraphCoef.Num.setText(""+(yB-yA));MesLectGraphCoef.Den.setText(""+(xB-xA));}
					else {MesLectGraphCoef.Num.setText(""+(yA-yB));MesLectGraphCoef.Den.setText(""+(xA-xB));}
					MesLectGraphCoef.Ord.setText(""+Ordb);
					if (!Tangente) {MesLectGraphCoef.Continuer.setVisible(true);}
				}
			}
			else
			{
				CorrectionDroite Tache=new CorrectionDroite(MaCourbe,xA,yA,xB,yB,OrdAOrigine,MesLectGraphCoef);
				Tache.start();
			}
			MesLectGraphCoef.Correction.setEnabled(false);
			MesLectGraphCoef.Cours.setEnabled(false);
			MesLectGraphCoef.Valider.setEnabled(false);
    	}});
		MesLectGraphCoef.Cours.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e) 
    	{
			if (!Evaluation) 
			{
				if (!Tangente) Presentation("RappelDroite.html",600,420);
				else Presentation("RappelNombreDerive.html",700,520);
			}
			else 
			{
				Passe=true;
				if (Tangente)
				{
					if (OrdAOrigine) ErrTangente+=2; else ErrTangente++;
				}
				else
				{
					if (OrdAOrigine) ErrDroite+=2; else ErrDroite++;
				}
				RecomDroite();
			}
    	}});
		
		MesLectGraphCoef.Valider.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e) 
		{	
			boolean Err=true;
			if (BloqCoef) 
			{
				int Num=MaCourbe.Num;int Den=MaCourbe.Den;
				double O=MaCourbe.Droite(0d); // ordonne  l'origine
				if (Evaluation)
					{
					if (OrdAOrigine && (Arrondir(O)!=Ordb)) ErreurQuestion=1;
					if (((yB-yA)*(int)(Den))!=((xB-xA)*(int)(Num))) ErreurQuestion++;
					Err=false;
					}
				else
				{
					if ((yB>yA) && (Num<0)) {Error("Le coefficient directeur est positif\ndonc la droite devrait monter.");}
					else
					{
						if ((yB<yA) && (Num>0)) {Error("Le coefficient directeur est ngatif\ndonc la droite devrait descendre.");}
						else
						{
							if (((yB-yA)*(int)(Den))!=((xB-xA)*(int)(Num))) // coef. direct. sont diff.
							{
								Error("Le coefficient directeur de votre droite est : "+(int)(Num)+"/"+(int)(Den)+" !");	
							}
							else
							{
								if (!OrdAOrigine) {Encouragement();Err=false;} // fin si pas d'ordonne  l'origine
								else
								{
									if (Math.abs(Arrondir(O)-O)<0.001d && (Arrondir(O)==Ordb)) {Encouragement();Err=false;}
									else {Error("Votre droite a le bon coefficient directeur,\nmais son ordonne  l'origine est : "+Arrondir3(O));}
								}
							}
						}
					}	
				}
			}
			else
			{ //la droite est trace, il faut dterminer le coefficient directeur !
				double Num,Den,O;
				try {Num=new Double (MesLectGraphCoef.Num.getText()).doubleValue();}
				catch (NumberFormatException ex) {Num=1024d;MesLectGraphCoef.Num.requestFocus();}
				
				try {Den=new Double (MesLectGraphCoef.Den.getText()).doubleValue();}
				catch (NumberFormatException ex) {MesLectGraphCoef.Den.requestFocus();Den=1024d;}
				
				if ((Den==1024d) | (Num==1024d)) {Error("Vous devez saisir un nombre !");}
				else
				{
					if (Math.abs(((double)((int)(Num))-Num))>0.00000001d) {Error("Le numrateur doit tre un entier !");MesLectGraphCoef.Num.requestFocus();}
					else
					{
						if (Math.abs(((double)((int)(Den))-Den))>0.00000001d) {Error("Le dnominateur doit tre un entier !");MesLectGraphCoef.Den.requestFocus();}
						else
						{
							if (((int) Den)==0) {Error("Un dnominateur n'est jamais nul");MesLectGraphCoef.Den.requestFocus();}
							else
							{
								if (Evaluation)
								{
									if (((yB-yA)*(int)(Den))!=((xB-xA)*(int)(Num))) ErreurQuestion=1;
									if (OrdAOrigine)
									{
										if (MesLectGraphCoef.Ord.getText().length()==0) {O=0d;}
										else
										{
											try {O=new Double (MesLectGraphCoef.Ord.getText()).doubleValue();}
											catch (NumberFormatException ex) {MesLectGraphCoef.Ord.requestFocus();O=1024d;}
										}
										if (((int) O)!=Ordb) ErreurQuestion++;
									}
									Err=false;
								}
								else
								{
									if (((yB-yA)*(int)(Den))!=((xB-xA)*(int)(Num))) // coef. direct. sont diff.
									{
										
										if (((yB-yA)*(int)(Den))==-((xB-xA)*(int)(Num))) {Error("Erreur de signe !");}
										else 
										{
											if (Tangente)
											{
												if (MaCourbe.Arrondir(MaCourbe.Curseur)!=MaCourbe.Arrondir(MaCourbe.Tx))
												{
													if (!OrdAOrigine) Error ("Le nombre drive est faux.\nC'est normal, vous n'avez pas plac la tangente au point d'abscisse "+xB);
													else Error ("Le coefficient directeur est faux.\nC'est normal, vous n'avez pas plac la tangente au point d'abscisse "+xB);
												}
												else
												{
													if (!OrdAOrigine) 
													{
														String Ph="Le nombre drive est faux !";
														if (yB==yA) Ph=Ph+"\n\nRflchissez !\nLa tangente est horizontale donc le nombre driv est ...";
														else {if (Num==0d) Ph=Ph+"\n\nVotre nombre driv est nul,\nalors que la tangente n'est pas horizontale !";}
														Error (Ph);
													}
													else 
													{
														String Ph="Le coefficient directeur est faux !";
														if (yB==yA) Ph=Ph+"\n\nRflchissez !\nLa tangente est horizontale donc le coefficient directeur est ...";
														else {if (Num==0d) Ph=Ph+"\n\nVous avez saisi un coefficient directeur nul,\nalors que la tangente n'est pas horizontale !";}
														Error(Ph);
													}
												
												}
											}
											else 
											{
												String Ph="Votre coefficient directeur est faux !";
												if (((double)((yB-yA)*(xB-xA)))*Num*Den<0d) 
													{
														Ph=Ph+"\n\nLe coefficient directeur est ";
														if ((yB-yA)*(xB-xA)>0) Ph=Ph+"positif."; else Ph=Ph+"ngatif.";
													}
												else
												{
													if (yB==yA) Ph=Ph+"\n\nRflchissez !\nLa droite est horizontale donc le coefficient directeur est ...";
													else {if (Num==0d) Ph=Ph+"\n\nVous avez saisi un coefficient directeur nul,\nalors que la droite n'est pas horizontale !";}
												}
												Error(Ph);
											}
										}
									}
									else
									{
										if (!OrdAOrigine) {Encouragement();Err=false;} // fin si pas d'ordonne  l'origine
										else
										{
											if (MesLectGraphCoef.Ord.getText().length()==0) {O=0d;}
											else
											{
												try {O=new Double (MesLectGraphCoef.Ord.getText()).doubleValue();}
												catch (NumberFormatException ex) {MesLectGraphCoef.Ord.requestFocus();O=1024d;}
											}
											if (O==1024d) {Error("Le coefficient directeur est juste,\nMais je n'arrive pas  lire votre ordonne  l'origine !");}
											else
											{
												if (((int) O)==Ordb) {Encouragement();Err=false;} 
												else {Error("Le coefficient directeur est juste,\nMais l'ordonne  l'origine est fausse !");}
											}
											
										}
									}
								}
								
							}
						}
					}
				}
			}
			if (Err) 
			{
				ErreurQuestion++;
				if (Evaluation) RecomDroite();
				else
				{
					if (MaCourbe.AffLigne) {MaCourbe.AffCoef=true;}
					MaCourbe.AffLigne=true;
					MaCourbe.repaint();
				}
			}
			else 
			{ // C'est fini !
				RecomDroite();
			}
    	}});	
	}
	public void RecomDroite()
	{
		if (Evaluation)
		{
			if (Tangente) {ErrTangente=ErrTangente+ErreurQuestion;} else {ErrDroite=ErrDroite+ErreurQuestion;}
			if (!Passe) 
			{
				if (OrdAOrigine) note=note+2d; else note++;
				note=note-(double) ErreurQuestion;
			}
			Eval();
		}
		else
		{
			if (Tangente) {InitialiseTangente(module);} else {InitialiseDroite();}
			Affichage.repaint();
			MesLectGraphCoef.Num.requestFocus();
		}
	}
	public void Creation_Objets_droite(boolean tableau,int module) //tableau=true->on peut bouger la droite
	{
		HauteurCourbe=(int) (Hauteur/2);LargeurCourbe=Largeur-30;
		MaCourbe=new PanneauCourbe(10,10,LargeurCourbe,HauteurCourbe);
		MaCourbe.tableau=tableau;MaCourbe.Droite=true;
        Affichage.add(MaCourbe);
        MesLectGraphCoef=new DialogueLectGraphCoef(10,HauteurCourbe+20,LargeurCourbe,HauteurCourbe-60,module);
        Affichage.add(MesLectGraphCoef);
	}
	public void InitialiseDroite() //OrdB=ordonne  l'origine
	{
		int level=15;Doucement=true; // Difficult augmente lentement !
		ErreurQuestion=0;MaCourbe.NbTriche=0;
		if (OrdAOrigine) NbreQuestDroite+=2; else NbreQuestDroite++;
		if (Difficulte>=2) {MaCourbe.AffCoef=false;level=11;}
		if (Difficulte>=4) {MaCourbe.AffLigne=false;level=7;}
		for (int i=0;i<5;i++)
		{
			GraduationHasard();
			if ((xmin<-2d) && (xmax>2)) {i=5;}
		}
		
		NbPoints=2;xA=0;xB=0;
		while ((xA-xB==0) | (Math.abs(xA-xB)>level))
		{
			if (OrdAOrigine) {xA=0;} else {xA=1+(int)(xmin+Math.random()*(xmax-xmin-3d));}
			xB=1+(int)(xmin+Math.random()*(xmax-xmin-3d));
		}
		if (xA>xB) {int i=xA;xA=xB;xB=i;}
		yA=0;yB=0;
		while (yA==0 && yB==0)
		{
			yA=1+(int)(ymin+Math.random()*(ymax-ymin-3d));
			yB=1+(int)(ymin+Math.random()*(ymax-ymin-3d));
		}
		if (xA==0) {Ordb=yA;} else {Ordb=yB;}
		
        Power.Barre(Difficulte);Power.repaint();
        if (BloqCoef) 
        {
        	int y=yB-yA,x=xB-xA;
        	for (int i=2;i<14;i++)
        	{
        		if ((i*(y/i)==y) && (i*(x/i)==x)) {y=y/i;x=x/i;i--;}
        	}
        	if (xA==0) {xB=xA+x;yB=yA+y;} else {xA=xB-x;yA=yB-y;}
        	MesLectGraphCoef.Num.setText(""+y);
        	MesLectGraphCoef.Den.setText(""+x);
        	if (OrdAOrigine) 
        	{
        		MesLectGraphCoef.Ord.setText(""+Math.abs(Ordb));MesLectGraphCoef.Ord.setEditable(false);
        		if (Ordb<0) {MesLectGraphCoef.Enonce4.setText(" - ");} else {MesLectGraphCoef.Enonce4.setText(" + ");}
        		MesLectGraphCoef.Ord.setHorizontalAlignment(SwingConstants.LEFT);
        		if (Ordb==0) {MesLectGraphCoef.Ord.setVisible(false);MesLectGraphCoef.Enonce4.setVisible(false);}
        		else {MesLectGraphCoef.Ord.setVisible(true);MesLectGraphCoef.Enonce4.setVisible(true);}
        	}
        	Point[0][0]=xmin+2d;Point[0][1]=1d+Math.round((ymin+Math.random()*(ymax-ymin-3d)));
        	Point[1][0]=xmax-2d;Point[1][1]=1d+Math.round((ymin+Math.random()*(ymax-ymin-3d)));
            MaCourbe.ChangeCourbe(xmin,xmax,ymin,ymax,Point,NbPoints);
        	MesLectGraphCoef.Valider.requestFocus();
        	MesLectGraphCoef.Num.setEditable(false);MesLectGraphCoef.Den.setEditable(false);
        }
        else 
        {
        	Point[0][0]=(double)xA;Point[0][1]=(double)yA;
            Point[1][0]=(double)xB;Point[1][1]=(double)yB;
            MaCourbe.ChangeCourbe(xmin,xmax,ymin,ymax,Point,NbPoints);
        	MesLectGraphCoef.Num.setEditable(true);MesLectGraphCoef.Den.setEditable(true);
        	MesLectGraphCoef.Num.requestFocus();
        }
        if (Evaluation) 
        {
        	EvalDr();
        }
        
	}
	public void EvalDr()
	{
		MesLectGraphCoef.Cours.setText("Je passe la question et je perds les points");
    	MesLectGraphCoef.Cours.setBounds(20,10,LargeurCourbe-30,20);
    	MesLectGraphCoef.Correction.setVisible(false);
    	Passe=false;
	}
	public void Creation_Objets_Tangente(int module) //tableau=true->on peut bouger la droite
	{
		HauteurCourbe=(int) (Hauteur/2);LargeurCourbe=Largeur-30;
		MaCourbe=new PanneauCourbe(10,10,LargeurCourbe,HauteurCourbe);
		MaCourbe.Tangente=true;Affichage.add(MaCourbe);
        MesLectGraphCoef=new DialogueLectGraphCoef(10,HauteurCourbe+20,LargeurCourbe,HauteurCourbe-60,module+10);
        Affichage.add(MesLectGraphCoef);
	}
	public void InitialiseTangente(int module)
	{
		String S;
		
		if (Difficulte>=2) {MaCourbe.AffCoef=false;}
		if (Difficulte>=4) {MaCourbe.AffLigne=false;}
		
		int indice=0;
		ErreurQuestion=0;
		for (int i=0;i<6;i++)	{GraduationHasard();if ((xmin<-2d) && (xmax>2)) {i=6;}}
		if (OrdAOrigine) NbreQuestTangente+=2; else NbreQuestTangente++;
		
		boolean recomc=true;
		NbPoints=3+Difficulte;
		while (recomc)
		{
			PointHasard();
			indice=1+(int) (Math.random()*(double)(NbPoints-2));
			Point[indice][0]=Math.round(Point[indice][0]);
			if ((Point[indice-1][0]<(Point[indice][0]-1d)) &&  (Point[indice+1][0]>(Point[indice][0]+1d))) {recomc=false;}
			if ((Point[indice][1]>ymax-1) || (Point[indice][1]<ymin+1)) {recomc=true;}
			if (Math.abs(Point[indice][0])>8) {recomc=true;}
		}
		Point[indice][1]=Math.round(Point[indice][1]);
		yB=(int) Point[indice][1];xB=((int) Point[indice][0]);
		
		recomc=true;
		while (recomc)
		{
			xA=1+(int)(xmin+Math.random()*(xmax-xmin-3d));
			while (xA-xB==0)	{{xA=1+(int)(xmin+Math.random()*(xmax-xmin-3d));}}
			yA=1+(int)(ymin+Math.random()*(ymax-ymin-3d));
			if (Math.abs(xB-xA)<8) {recomc=false;}
			if (yA-yB==0) {recomc=false;}
		}
		Ordb=yB;
		if ((OrdAOrigine) && (xB!=0)) {xA=0;Ordb=yA;}
		
		int y=yB-yA,x=xB-xA;
		if (!OrdAOrigine)
		{
			for (int i=2;i<14;i++)
	    	{
	    		if ((i*(y/i)==y) && (i*(x/i)==x)) {y=y/i;x=x/i;i--;}
	    	}
			xA=xB-x;yA=yB-y;
		}
		if (xA<xB) {MaCourbe.xE=xA;MaCourbe.yE=yA;MaCourbe.xF=xB;MaCourbe.yF=yB;}
		else {MaCourbe.xE=xB;MaCourbe.yE=yB;MaCourbe.xF=xA;MaCourbe.yF=yA;}
		MaCourbe.indiceTangente=indice;MaCourbe.Tcoef=((double)(yB-yA))/((double)(xB-xA));
		MaCourbe.Tx=(double)xB; // triche
		MaCourbe.NbTriche=1;MaCourbe.Triche[0][0]=(float)(xB);MaCourbe.Triche[0][1]=(float)(yB);
		switch(module)
		{
		case 2:
			if (Math.random()>0.6d) {S="Le nombre driv de f au point d'abscisse "+xB+" est :";} else {S="f'("+xB+") = ";}
			MesLectGraphCoef.Cas2Tangente(S);
			break;
		case 4:
			MesLectGraphCoef.Cas4Tangente("L'quation de la tangente  Cf au point d'abscisse "+xB+" est :");
			break;
		}
		MaCourbe.ChangeCourbe(xmin,xmax,ymin,ymax,Point,NbPoints);
        Power.Barre(Difficulte);Power.repaint();
        if (Evaluation) 
        {
        	EvalDr();
        }
	}
}

