/*
 * Copyright Mr DROUOT Patrick since 2006
 * 
 * www.patrickdrouot2000@yahoo.fr
 * 
 * 
 * This file is part of GraphExotica.
 * GraphExotica is free software;
 * you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2 of the License.
 * GraphExotica is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. 

*/
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import javax.swing.JPanel;
import javax.swing.border.LineBorder;


public class BarreDiff extends JPanel
{

	/**
	 * 
	 */
	private static final long serialVersionUID = -1820236182521371765L;
	Font En;
	FontMetrics fm;
	public boolean Chronometre=false;
	public boolean ChronoFin=false;
	int LargeurString,LargeurChronos,LargeurPhT;
	int min=0,sec=0;
	final String Ph="Difficult";
	final String PhT="L'preuve est termine, finissez cet exercice.";
	int Largeur;
	int Difficulte=0;
	final int Ht=11; // paisseur de la barre.
	final int DiffMax=6;
	public BarreDiff(int Larg)
	{
		Largeur=Larg-5;
		setSize(Largeur,Ht);
        setBorder(new LineBorder(new Color(16,255, 0)));
        setBackground(new Color(0,0,255));
        En=new Font("",Font.PLAIN,9);
        fm=getFontMetrics(En);
        setFont(En);
        LargeurString=fm.stringWidth(Ph);
        LargeurChronos=(Largeur-fm.stringWidth("Fin de l'preuve dans: 00 m 00 s"))/2;
        LargeurPhT=(Largeur-fm.stringWidth(PhT))/2;
        
	}
	public void paintComponent(Graphics Graph)
	{
		super.paintComponent(Graph);
		if (Chronometre)
		{
			Graph.setColor(new Color(255,255,255));Graph.drawString("Fin de l'preuve dans: "+min+" m "+sec+" s",LargeurChronos,10);
		}
		else
		{
			if (ChronoFin) 
			{
				Graph.setColor(new Color(255,255,255));Graph.drawString(PhT,LargeurChronos,10);
			}
			else
			{
				int a=Difficulte*(Largeur-LargeurString)/DiffMax;
				Graph.setColor(new Color(255,0,0));Graph.fillRect(0,0,a,Ht);
				Graph.setColor(new Color(255,255,255));Graph.drawString(Ph,a,10);
			}	
		}
	}
	public void Barre(int Diff)
	{
		Difficulte=Math.min(DiffMax,Diff);
	}
	public void MiseJourChronos(int min,int sec,boolean c)
	{
		this.min=min;this.sec=sec;Chronometre=c;
	}
}
