/*
 * Copyright Mr DROUOT Patrick since 2006
 * 
 * www.patrickdrouot2000@yahoo.fr
 * 
 * 
 * This file is part of GraphExotica.
 * GraphExotica is free software;
 * you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2 of the License.
 * GraphExotica is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. 

*/
public class CorrectionVariations extends Thread 
{
	PanneauCourbe MaCourbe;
	double[][] PointV;
	int NbPointsV,NbPoints;
	double[][] Point=new double [20][2];
	double[] x=new double[20];
	double[] y=new double[20];
	final int NB=100;
	
	
	public CorrectionVariations(PanneauCourbe Obj,int NbPointsV,double[][] PointV)
	{
		MaCourbe=Obj;this.PointV=PointV;this.NbPointsV=NbPointsV;
		NbPoints=MaCourbe.NbPoints;
		int Exces=NbPoints-NbPointsV;
		int j=0;
		for (int i=0;i<NbPointsV;i++)
		{
			Point[j][0]=PointV[i][0];Point[j][1]=PointV[i][1];
			if (Exces>0)
			{
				Exces--;
				j++;
				Point[j][0]=(PointV[i][0]+PointV[i+1][0])/2;
				Point[j][1]=(PointV[i][1]+PointV[i+1][1])/2;
			}
			j++;
		}
		for (int i=0;i<NbPoints;i++)
		{
			x[i]=(Point[i][0]-MaCourbe.Point[i][0])/(double)NB;
			y[i]=(Point[i][1]-MaCourbe.Point[i][1])/(double)NB;
			Point[i][0]=MaCourbe.Point[i][0];
			Point[i][1]=MaCourbe.Point[i][1];
		}
	}
	public void run()
	{	
		Principal.IsThread=true;
		for (int j=0;j<NB;j++)
		{
			for (int i=0;i<NbPoints;i++)
			{
				Point[i][0]=Point[i][0]+x[i];
				MaCourbe.Point[i][0]=Point[i][0];
				Point[i][1]=Point[i][1]+y[i];
				MaCourbe.Point[i][1]=Point[i][1];
			}
			MaCourbe.TableauBall();
			MaCourbe.CalculTableau();
			MaCourbe.repaint();
			try {sleep(40);} catch (InterruptedException e) {}	
		}
		MaCourbe.repaint();
		Principal.IsThread=false;
	}
}
