/*
 * Copyright Mr DROUOT Patrick since 2006
 * 
 * www.patrickdrouot2000@yahoo.fr
 * 
 * 
 * This file is part of GraphExotica.
 * GraphExotica is free software;
 * you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2 of the License.
 * GraphExotica is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. 

*/
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.LineBorder;
public class DialogueLectGraphCoef extends JPanel implements FocusListener
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 2584108927281816264L;
	JButton Valider,Cours,Correction,Continuer;
	JLabel Enonce,Enonce2,Enonce3,Enonce4;
	JTextField Num,Den,Ord;
	boolean Focus=true;
	Font En,EnI;
	FontMetrics fm,fmI;
	int lgCh,lg,lgCh2,lgCh3,ht;
	int Xfraction,xbar,ybar;
	String Enon;
	final Color noire=new Color(0,0,0);
	final Color blanche=new Color(255,255,255);
	boolean Couleur=true;
	boolean Tangente=false;
	int Hauteur,Largeur,module;
	
	public DialogueLectGraphCoef(int x, int y,int Largeur , int Hauteur,int module)
	{
		if (module>4) {Tangente=true;module=module-10;}
		this.Hauteur=Hauteur;this.Largeur=Largeur;this.module=module;
		setBorder(new LineBorder(new Color(255, 0, 0)));
		setBackground(new Color(0, 0, 0));
		setBounds(x,y,Largeur,Hauteur);	
		setLayout(null);		
		Font En=new Font("", Font.BOLD, 16);fm = getFontMetrics(En);
		Font EnI=new Font("Serif", Font.ITALIC, 20);fmI = getFontMetrics(EnI);
		Valider=new JButton("Valider la saisie");
		Cours=new JButton("Rappels de cours");
		Correction=new JButton("Correction");
		Continuer=new JButton("Continuer");
		Ord=new JTextField("");Ord.setFont(En);Ord.setVisible(false);
		ht=2*Hauteur/3;
		switch(module)
		{
		case 1:
			Enon="Construire une droite dont le coefficient directeur est :";
			Enonce=new JLabel(Enon);lgCh=fm.stringWidth(Enon);lg=(Largeur-(lgCh+46))/2;
			Enonce.setBounds(lg,Hauteur/3,lgCh,20);
			Couleur=false;Fraction(lg+lgCh+5,10+Hauteur/3);
			Valider.setBounds(20,ht,Largeur-40,30);
			break;
		case 2:
			Enon="Le coefficient directeur de cette droite est :";
			Enonce=new JLabel(Enon);lgCh=fm.stringWidth(Enon);lg=(Largeur-(lgCh+46))/2;
			Enonce.setBounds(lg,Hauteur/3,lgCh,20);
			Couleur=true;Fraction(lg+lgCh+5,10+Hauteur/3);
			Valider.setBounds(20,ht,Largeur-40,30);
			break;
		case 3:
			
			Enon="Construire une droite dont l'quation rduite est :";
			Enonce=new JLabel(Enon);lgCh=fm.stringWidth(Enon);lg=(Largeur-lgCh)/2;
			Enonce.setBounds(lg,Hauteur/4,lgCh,20);
			Enon="y =";Enonce2=new JLabel(Enon);Enonce2.setFont(EnI);lgCh=fmI.stringWidth(Enon)+1;
			Enon="x";Enonce3=new JLabel(Enon);Enonce3.setFont(EnI);lgCh2=fmI.stringWidth(Enon)+1;
			Enon=" + ";Enonce4=new JLabel(Enon);Enonce4.setFont(En);lgCh3=fm.stringWidth(Enon)+1;
			lg=lgCh+lgCh2+lgCh3+96;lg=(Largeur-lg)/2;
			Enonce2.setBounds(lg,Hauteur/2,lgCh,30);lg=lg+lgCh+5;Enonce2.setForeground(new Color(255,255,255));
			Couleur=false;Fraction(lg,18+Hauteur/2);lg=lg+46+5;
			Enonce3.setBounds(lg,Hauteur/2,lgCh2,30);lg=lg+lgCh2+5;Enonce3.setForeground(new Color(255,255,255));
			Enonce4.setBounds(lg,Hauteur/2,lgCh3,30);lg=lg+lgCh3+5;Enonce4.setForeground(new Color(255,255,255));
			Ord.setBounds(lg,Hauteur/2+6,40,22);Ord.setHorizontalAlignment(SwingConstants.CENTER);
			Ord.setVisible(true);
			this.add(Enonce2);Enonce2.setVisible(true);this.add(Enonce3);Enonce3.setVisible(true);this.add(Enonce4);Enonce4.setVisible(true);
			ht=3*Hauteur/4;
			Valider.setBounds(20,ht,Largeur-40,30);
			break;
		case 4:
			Enon="Complter l'quation rduite de cette droite :";
			Enonce=new JLabel(Enon);lgCh=fm.stringWidth(Enon);lg=(Largeur-lgCh)/2;
			Enonce.setBounds(lg,Hauteur/4,lgCh,20);
			Enon="y =";Enonce2=new JLabel(Enon);Enonce2.setFont(EnI);lgCh=fmI.stringWidth(Enon)+1;
			Enon="x";Enonce3=new JLabel(Enon);Enonce3.setFont(EnI);lgCh2=fmI.stringWidth(Enon)+1;
			Enon=" + ";Enonce4=new JLabel(Enon);Enonce4.setFont(En);lgCh3=fm.stringWidth(Enon)+1;
			lg=lgCh+lgCh2+lgCh3+96;lg=(Largeur-lg)/2;
			Enonce2.setBounds(lg,Hauteur/2,lgCh,30);lg=lg+lgCh+5;Enonce2.setForeground(new Color(255,255,255));
			Couleur=true;Fraction(lg,18+Hauteur/2);lg=lg+46+5;
			Enonce3.setBounds(lg,Hauteur/2,lgCh2,30);lg=lg+lgCh2+5;Enonce3.setForeground(new Color(255,255,255));
			Enonce4.setBounds(lg,Hauteur/2,lgCh3,30);lg=lg+lgCh3+5;Enonce4.setForeground(new Color(255,255,255));
			Ord.setBounds(lg,Hauteur/2+6,40,22);Ord.setHorizontalAlignment(SwingConstants.CENTER);
			Ord.setVisible(true);
			this.add(Enonce2);Enonce2.setVisible(true);this.add(Enonce3);Enonce3.setVisible(true);this.add(Enonce4);Enonce4.setVisible(true);
			ht=3*Hauteur/4;Valider.setBounds(20,ht,Largeur-40,30);
			break;
		}
		Enonce.setForeground(new Color(255,255,255));Enonce.setHorizontalAlignment(SwingConstants.RIGHT);Enonce.setFont(En);
		Valider.setVisible(true);Num.setVisible(true);Den.setVisible(true);Enonce.setVisible(true);
		Cours.setBounds(20,20,200,20);Cours.setVisible(true);
		Correction.setBounds(Largeur-150,20,130,20);Correction.setVisible(true);
		Continuer.setBounds(20,ht+33,Largeur-40,Hauteur-ht-43);Continuer.setBackground(new Color(0,0,250));Continuer.setForeground(new Color(255,255,255));
		Continuer.setVisible(false);
		add(Num);add(Den);add(Ord);add(Valider);add(Continuer);add(Correction);add(Cours);add(Enonce);
		Num.setNextFocusableComponent(Den);Den.setNextFocusableComponent(Ord);Ord.setNextFocusableComponent(Num);
		Num.requestFocus();
	}
	public void Cas4Tangente(String E)
	{
		lgCh=fm.stringWidth(E);lg=(Largeur-lgCh)/2;Enonce.setBounds(lg,Hauteur/4,lgCh,20);
		Enonce.setText(E);
	}
	public void Cas2Tangente(String E)
	{
		lgCh=fm.stringWidth(E);lg=(Largeur-(lgCh+46))/2;
		FractionTaille(lg+lgCh+5,10+Hauteur/3);
		Enonce.setBounds(lg,Hauteur/3,lgCh,20);
		//Couleur=true;
		Valider.setBounds(20,ht,Largeur-40,30);
		Enonce.setText(E);
	}
	public void paintComponent(Graphics Graph)
	{
		super.paintComponent(Graph);
		
		FractionComp(Graph);
		
		Graph.setColor(new Color(255,255,255));
		Graph.setColor(new Color(0,0,0));
	}
	public void Fraction(int x, int y) // la hauteur d'une fraction est 52, sa largeur est 46
	{
		Font En=new Font("", Font.BOLD, 16);
		Num=new JTextField("");Num.setFont(En);Num.setBounds(x+3,y-26,40,22);Num.setHorizontalAlignment(SwingConstants.CENTER);
		Den=new JTextField("1");Den.setFont(En);Den.setBounds(x+3,y+4,40,22);Den.setHorizontalAlignment(SwingConstants.CENTER);
		Num.addFocusListener(this);Den.addFocusListener(this);Ord.addFocusListener(this);
		ybar=y;xbar=x;
		if (Couleur) {CouleurFraction(blanche,noire);} else {CouleurFraction(noire,blanche);}
	}
	public void FractionTaille(int x, int y)
	{
		Num.setBounds(x+3,y-26,40,22);Den.setBounds(x+3,y+4,40,22);
		ybar=y;xbar=x;
	}
	public void CouleurFraction(Color c1,Color c2)
	{
		Num.setBackground(c1);Num.setForeground(c2);Num.setBorder(new LineBorder(c1));
		Den.setBackground(c1);Den.setForeground(c2);Den.setBorder(new LineBorder(c1));
		Ord.setBackground(c1);Ord.setForeground(c2);Ord.setBorder(new LineBorder(c1));
	}
	public void FractionComp(Graphics Graph)
	{
		Graph.setColor(blanche);
		if (Couleur) {Graph.fillRect(xbar,ybar-26,46,52);}
		if (Couleur) {Graph.setColor(noire);}
		Graph.drawLine(xbar+6,ybar,xbar+40,ybar);
	}
	public void focusGained(FocusEvent ev) 
	{
		JTextField Foc=(JTextField) ev.getSource();
		if (Foc==Den || Foc==Num || Foc==Ord)
		{
			Foc.setSelectionStart(0);
			Foc.setSelectionEnd(Foc.getText().length());
		}
	}
	public void focusLost(FocusEvent ev){}
}
